(function() {
  var AccountSidebar, AccountStore, AccountSwitcher, Flexbox, OutlineView, React, ScrollRegion, SidebarStore, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  AccountStore = require('nylas-exports').AccountStore;

  _ref = require('nylas-component-kit'), OutlineView = _ref.OutlineView, ScrollRegion = _ref.ScrollRegion, Flexbox = _ref.Flexbox;

  AccountSwitcher = require('./account-switcher');

  SidebarStore = require('../sidebar-store');

  AccountSidebar = (function(_super) {
    __extends(AccountSidebar, _super);

    AccountSidebar.displayName = 'AccountSidebar';

    AccountSidebar.containerRequired = false;

    AccountSidebar.containerStyles = {
      minWidth: 165,
      maxWidth: 250
    };

    function AccountSidebar(props) {
      this.props = props;
      this.render = __bind(this.render, this);
      this._renderUserSections = __bind(this._renderUserSections, this);
      this._getStateFromStores = __bind(this._getStateFromStores, this);
      this._onStoreChange = __bind(this._onStoreChange, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = this._getStateFromStores();
    }

    AccountSidebar.prototype.componentDidMount = function() {
      this.unsubscribers = [];
      this.unsubscribers.push(SidebarStore.listen(this._onStoreChange));
      return this.unsubscribers.push(AccountStore.listen(this._onStoreChange));
    };

    AccountSidebar.prototype.componentWillUnmount = function() {
      var unsubscribe, _i, _len, _ref1, _results;
      _ref1 = this.unsubscribers;
      _results = [];
      for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
        unsubscribe = _ref1[_i];
        _results.push(unsubscribe());
      }
      return _results;
    };

    AccountSidebar.prototype._onStoreChange = function() {
      return this.setState(this._getStateFromStores());
    };

    AccountSidebar.prototype._getStateFromStores = function() {
      return {
        accounts: AccountStore.accounts(),
        sidebarAccountIds: SidebarStore.sidebarAccountIds(),
        userSections: SidebarStore.userSections(),
        standardSection: SidebarStore.standardSection()
      };
    };

    AccountSidebar.prototype._renderUserSections = function(sections) {
      return sections.map((function(_this) {
        return function(section) {
          return React.createElement(OutlineView, React.__spread({
            "key": section.title
          }, section));
        };
      })(this));
    };

    AccountSidebar.prototype.render = function() {
      var accounts, sidebarAccountIds, standardSection, userSections, _ref1;
      _ref1 = this.state, accounts = _ref1.accounts, sidebarAccountIds = _ref1.sidebarAccountIds, userSections = _ref1.userSections, standardSection = _ref1.standardSection;
      return React.createElement(Flexbox, {
        "direction": "column",
        "style": {
          order: 0,
          flexShrink: 1,
          flex: 1
        }
      }, React.createElement(ScrollRegion, {
        "className": "account-sidebar",
        "style": {
          order: 2
        }
      }, React.createElement(AccountSwitcher, {
        "accounts": accounts,
        "sidebarAccountIds": sidebarAccountIds
      }), React.createElement("div", {
        "className": "account-sidebar-sections"
      }, React.createElement(OutlineView, React.__spread({}, standardSection)), this._renderUserSections(userSections))));
    };

    return AccountSidebar;

  })(React.Component);

  module.exports = AccountSidebar;

}).call(this);
