(function() {
  var AccountCommands, AccountSwitcher, Actions, React, RetinaImg,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  Actions = require('nylas-exports').Actions;

  RetinaImg = require('nylas-component-kit').RetinaImg;

  AccountCommands = require('../account-commands');

  AccountSwitcher = (function(_super) {
    __extends(AccountSwitcher, _super);

    function AccountSwitcher() {
      this.render = __bind(this.render, this);
      this._onShowMenu = __bind(this._onShowMenu, this);
      this._onManageAccounts = __bind(this._onManageAccounts, this);
      this._onAddAccount = __bind(this._onAddAccount, this);
      this._makeMenuTemplate = __bind(this._makeMenuTemplate, this);
      return AccountSwitcher.__super__.constructor.apply(this, arguments);
    }

    AccountSwitcher.displayName = 'AccountSwitcher';

    AccountSwitcher.propTypes = {
      accounts: React.PropTypes.array.isRequired,
      sidebarAccountIds: React.PropTypes.array.isRequired
    };

    AccountSwitcher.prototype._makeMenuTemplate = function() {
      var template;
      template = AccountCommands.menuTemplate(this.props.accounts, this.props.sidebarAccountIds, {
        clickHandlers: true
      });
      template = template.concat([
        {
          type: 'separator'
        }, {
          label: 'Add Account...',
          click: this._onAddAccount
        }, {
          label: 'Manage Accounts...',
          click: this._onManageAccounts
        }
      ]);
      return template;
    };

    AccountSwitcher.prototype._onAddAccount = function() {
      var ipc;
      ipc = require('electron').ipcRenderer;
      return ipc.send('command', 'application:add-account');
    };

    AccountSwitcher.prototype._onManageAccounts = function() {
      Actions.switchPreferencesTab('Accounts');
      return Actions.openPreferences();
    };

    AccountSwitcher.prototype._onShowMenu = function() {
      var Menu, menu, remote;
      remote = require('electron').remote;
      Menu = remote.Menu;
      menu = Menu.buildFromTemplate(this._makeMenuTemplate());
      return menu.popup();
    };

    AccountSwitcher.prototype.render = function() {
      return React.createElement("div", {
        "className": "account-switcher",
        "onMouseDown": this._onShowMenu
      }, React.createElement(RetinaImg, {
        "style": {
          width: 13,
          height: 14
        },
        "name": "account-switcher-dropdown.png",
        "mode": RetinaImg.Mode.ContentDark
      }));
    };

    return AccountSwitcher;

  })(React.Component);

  module.exports = AccountSwitcher;

}).call(this);
