(function() {
  var AccountStore, Actions, CategoryPicker, CategoryPickerPopover, KeyCommandsRegion, React, ReactDOM, RetinaImg, WorkspaceStore, _, _ref, _ref1,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  ReactDOM = require('react-dom');

  _ref = require('nylas-exports'), Actions = _ref.Actions, AccountStore = _ref.AccountStore, WorkspaceStore = _ref.WorkspaceStore;

  _ref1 = require('nylas-component-kit'), RetinaImg = _ref1.RetinaImg, KeyCommandsRegion = _ref1.KeyCommandsRegion;

  CategoryPickerPopover = require('./category-picker-popover')["default"];

  CategoryPicker = (function(_super) {
    __extends(CategoryPicker, _super);

    CategoryPicker.displayName = "CategoryPicker";

    CategoryPicker.containerRequired = false;

    CategoryPicker.propTypes = {
      items: React.PropTypes.array
    };

    CategoryPicker.contextTypes = {
      sheetDepth: React.PropTypes.number
    };

    function CategoryPicker(props) {
      this.props = props;
      this.render = __bind(this.render, this);
      this._onOpenCategoryPopover = __bind(this._onOpenCategoryPopover, this);
      this._account = AccountStore.accountForItems(this.props.items);
    }

    CategoryPicker.prototype.componentWillReceiveProps = function(nextProps) {
      return this._account = AccountStore.accountForItems(nextProps.items);
    };

    CategoryPicker.prototype._keymapHandlers = function() {
      return {
        "core:change-category": this._onOpenCategoryPopover
      };
    };

    CategoryPicker.prototype._onOpenCategoryPopover = function() {
      var buttonRect;
      if (!(this.props.items.length > 0)) {
        return;
      }
      if (this.context.sheetDepth !== WorkspaceStore.sheetStack().length - 1) {
        return;
      }
      buttonRect = ReactDOM.findDOMNode(this.refs.button).getBoundingClientRect();
      Actions.openPopover(React.createElement(CategoryPickerPopover, {
        "threads": this.props.items,
        "account": this._account
      }), {
        originRect: buttonRect,
        direction: 'down'
      });
    };

    CategoryPicker.prototype.render = function() {
      var btnClasses, img, tooltip;
      if (!this._account) {
        return React.createElement("span", null);
      }
      btnClasses = "btn btn-toolbar btn-category-picker";
      img = "";
      tooltip = "";
      if (this._account.usesLabels()) {
        img = "toolbar-tag.png";
        tooltip = "Apply Labels";
      } else {
        img = "toolbar-movetofolder.png";
        tooltip = "Move to Folder";
      }
      return React.createElement(KeyCommandsRegion, {
        "style": {
          order: -103
        },
        "globalHandlers": this._keymapHandlers(),
        "globalMenuItems": [
          {
            "label": "Thread",
            "submenu": [
              {
                "label": "" + tooltip + "...",
                "command": "core:change-category",
                "position": "endof=thread-actions"
              }
            ]
          }
        ]
      }, React.createElement("button", {
        "tabIndex": -1.,
        "ref": "button",
        "title": tooltip,
        "onClick": this._onOpenCategoryPopover,
        "className": btnClasses
      }, React.createElement(RetinaImg, {
        "name": img,
        "mode": RetinaImg.Mode.ContentIsMask
      })));
    };

    return CategoryPicker;

  })(React.Component);

  module.exports = CategoryPicker;

}).call(this);
