(function() {
  var CollapsedParticipants, Contact, Fields, React, ReactDOM, ReactTestUtils, _;

  _ = require("underscore");

  React = require("react");

  ReactDOM = require('react-dom');

  ReactTestUtils = require('react-addons-test-utils');

  Fields = require('../lib/fields')["default"];

  CollapsedParticipants = require('../lib/collapsed-participants')["default"];

  Contact = require('nylas-exports').Contact;

  describe("CollapsedParticipants", function() {
    var makeField, numStr;
    makeField = function(props) {
      if (props == null) {
        props = {};
      }
      return this.fields = ReactTestUtils.renderIntoDocument(React.createElement(CollapsedParticipants, React.__spread({}, props)));
    };
    numStr = function() {
      return ReactDOM.findDOMNode(ReactTestUtils.findRenderedDOMComponentWithClass(this.fields, "num-remaining")).innerHTML;
    };
    it("doesn't render num remaining when nothing remains", function() {
      var els;
      makeField.call(this);
      els = ReactTestUtils.scryRenderedDOMComponentsWithClass(this.fields, "num-remaining");
      return expect(els.length).toBe(0);
    });
    it("renders num remaining when remaining with no bcc", function() {
      var str;
      makeField.call(this);
      spyOn(this.fields, "_setNumHiddenParticipants");
      this.fields.setState({
        numRemaining: 10,
        numBccRemaining: 0
      });
      str = numStr.call(this);
      return expect(str).toBe("10 more");
    });
    it("renders num remaining when only bcc", function() {
      var str;
      makeField.call(this);
      spyOn(this.fields, "_setNumHiddenParticipants");
      this.fields.setState({
        numRemaining: 0,
        numBccRemaining: 5
      });
      str = numStr.call(this);
      return expect(str).toBe("5 Bcc");
    });
    return it("renders num remaining when both remaining andj bcc", function() {
      var str;
      makeField.call(this);
      spyOn(this.fields, "_setNumHiddenParticipants");
      this.fields.setState({
        numRemaining: 10,
        numBccRemaining: 5
      });
      str = numStr.call(this);
      return expect(str).toBe("15 more (5 Bcc)");
    });
  });

}).call(this);
