(function() {
  var Actions, ContentsColumn, InjectedComponentSet, ListTabular, ParticipantsColumn, React, StatusColumn, Utils, snippet, subject, _, _ref, _ref1;

  _ = require('underscore');

  React = require('react');

  _ref = require('nylas-exports'), Actions = _ref.Actions, Utils = _ref.Utils;

  _ref1 = require('nylas-component-kit'), InjectedComponentSet = _ref1.InjectedComponentSet, ListTabular = _ref1.ListTabular;

  snippet = (function(_this) {
    return function(html) {
      var text;
      if (!(html && typeof html === 'string')) {
        return "";
      }
      try {
        text = Utils.extractTextFromHtml(html, {
          maxLength: 400
        });
        return text.slice(0, 201);
      } catch (_error) {
        return "";
      }
    };
  })(this);

  subject = function(subj) {
    if ((subj != null ? subj : "").trim().length === 0) {
      return React.createElement("span", {
        "className": "no-subject"
      }, "(No Subject)");
    } else {
      return subj;
    }
  };

  ParticipantsColumn = new ListTabular.Column({
    name: "Participants",
    width: 200,
    resolver: (function(_this) {
      return function(draft) {
        var list;
        list = [].concat(draft.to, draft.cc, draft.bcc);
        if (list.length > 0) {
          return React.createElement("div", {
            "className": "participants"
          }, React.createElement("span", null, list.map(function(p) {
            return p.displayName();
          }).join(', ')));
        } else {
          return React.createElement("div", {
            "className": "participants no-recipients"
          }, "(No Recipients)");
        }
      };
    })(this)
  });

  ContentsColumn = new ListTabular.Column({
    name: "Contents",
    flex: 4,
    resolver: (function(_this) {
      return function(draft) {
        var attachments, _ref2;
        attachments = [];
        if (((_ref2 = draft.files) != null ? _ref2.length : void 0) > 0) {
          attachments = React.createElement("div", {
            "className": "thread-icon thread-icon-attachment"
          });
        }
        return React.createElement("span", {
          "className": "details"
        }, React.createElement("span", {
          "className": "subject"
        }, subject(draft.subject)), React.createElement("span", {
          "className": "snippet"
        }, snippet(draft.body)), attachments);
      };
    })(this)
  });

  StatusColumn = new ListTabular.Column({
    name: "State",
    resolver: (function(_this) {
      return function(draft) {
        return React.createElement(InjectedComponentSet, {
          "inline": true,
          "containersRequired": false,
          "matching": {
            role: "DraftList:DraftStatus"
          },
          "className": "draft-list-injected-state",
          "exposedProps": {
            draft: draft
          }
        });
      };
    })(this)
  });

  module.exports = {
    Wide: [ParticipantsColumn, ContentsColumn, StatusColumn]
  };

}).call(this);
