(function() {
  var AccountStore, DatabaseStore, DraftListStore, FocusedPerspectiveStore, ListTabular, Message, MutableQueryResultSet, MutableQuerySubscription, NylasStore, ObservableListDataSource, OutboxStore, Rx, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  NylasStore = require('nylas-store');

  Rx = require('rx-lite');

  _ = require('underscore');

  _ref = require('nylas-exports'), Message = _ref.Message, OutboxStore = _ref.OutboxStore, AccountStore = _ref.AccountStore, MutableQueryResultSet = _ref.MutableQueryResultSet, MutableQuerySubscription = _ref.MutableQuerySubscription, ObservableListDataSource = _ref.ObservableListDataSource, FocusedPerspectiveStore = _ref.FocusedPerspectiveStore, DatabaseStore = _ref.DatabaseStore;

  ListTabular = require('nylas-component-kit').ListTabular;

  DraftListStore = (function(_super) {
    __extends(DraftListStore, _super);

    function DraftListStore() {
      this._createListDataSource = __bind(this._createListDataSource, this);
      this._onPerspectiveChanged = __bind(this._onPerspectiveChanged, this);
      this.selectionObservable = __bind(this.selectionObservable, this);
      this.dataSource = __bind(this.dataSource, this);
      this.listenTo(FocusedPerspectiveStore, this._onPerspectiveChanged);
      this._createListDataSource();
    }

    DraftListStore.prototype.dataSource = function() {
      return this._dataSource;
    };

    DraftListStore.prototype.selectionObservable = function() {
      return Rx.Observable.fromListSelection(this);
    };

    DraftListStore.prototype._onPerspectiveChanged = function() {
      return this._createListDataSource();
    };

    DraftListStore.prototype._createListDataSource = function() {
      var $resultSet, mailboxPerspective, query, subscription;
      mailboxPerspective = FocusedPerspectiveStore.current();
      if (mailboxPerspective.drafts) {
        query = DatabaseStore.findAll(Message).include(Message.attributes.body).order(Message.attributes.date.descending()).where({
          draft: true
        }).page(0, 1);
        if (mailboxPerspective.accountIds.length < AccountStore.accounts().length) {
          query.where({
            accountId: mailboxPerspective.accountIds
          });
        }
        subscription = new MutableQuerySubscription(query, {
          emitResultSet: true
        });
        $resultSet = Rx.Observable.fromNamedQuerySubscription('draft-list', subscription);
        $resultSet = Rx.Observable.combineLatest([$resultSet, Rx.Observable.fromStore(OutboxStore)], (function(_this) {
          return function(resultSet, outbox) {
            var resultSetWithTasks;
            resultSetWithTasks = new MutableQueryResultSet(resultSet);
            mailboxPerspective.accountIds.forEach(function(aid) {
              return OutboxStore.itemsForAccount(aid).forEach(function(task) {
                var draft;
                draft = resultSet.modelWithId(task.draftClientId);
                if (draft) {
                  draft = draft.clone();
                  draft.uploadTaskId = task.id;
                  draft.uploadProgress = task.progress;
                  return resultSetWithTasks.updateModel(draft);
                }
              });
            });
            return resultSetWithTasks.immutableClone();
          };
        })(this));
        this._dataSource = new ObservableListDataSource($resultSet, subscription.replaceRange);
      } else {
        this._dataSource = new ListTabular.DataSource.Empty();
      }
      return this.trigger(this);
    };

    return DraftListStore;

  })(NylasStore);

  module.exports = new DraftListStore();

}).call(this);
