(function() {
  var Actions, DraftList, DraftListColumns, DraftListStore, EmptyListState, FluxContainer, FocusContainer, MultiselectList, React, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  Actions = require('nylas-exports').Actions;

  _ref = require('nylas-component-kit'), FluxContainer = _ref.FluxContainer, FocusContainer = _ref.FocusContainer, EmptyListState = _ref.EmptyListState, MultiselectList = _ref.MultiselectList;

  DraftListStore = require('./draft-list-store');

  DraftListColumns = require('./draft-list-columns');

  DraftList = (function(_super) {
    __extends(DraftList, _super);

    function DraftList() {
      this._onRemoveFromView = __bind(this._onRemoveFromView, this);
      this._onDoubleClick = __bind(this._onDoubleClick, this);
      this._keymapHandlers = __bind(this._keymapHandlers, this);
      this.render = __bind(this.render, this);
      return DraftList.__super__.constructor.apply(this, arguments);
    }

    DraftList.displayName = 'DraftList';

    DraftList.containerRequired = false;

    DraftList.prototype.render = function() {
      return React.createElement(FluxContainer, {
        "stores": [DraftListStore],
        "getStateFromStores": (function() {
          return {
            dataSource: DraftListStore.dataSource()
          };
        })
      }, React.createElement(FocusContainer, {
        "collection": "draft"
      }, React.createElement(MultiselectList, {
        "columns": DraftListColumns.Wide,
        "onDoubleClick": this._onDoubleClick,
        "emptyComponent": EmptyListState,
        "keymapHandlers": this._keymapHandlers(),
        "itemPropsProvider": this._itemPropsProvider,
        "itemHeight": 39.,
        "className": "draft-list"
      })));
    };

    DraftList.prototype._itemPropsProvider = function(draft) {
      var props;
      props = {};
      if (draft.uploadTaskId) {
        props.className = 'sending';
      }
      return props;
    };

    DraftList.prototype._keymapHandlers = function() {
      return {
        'core:delete-item': this._onRemoveFromView,
        'core:gmail-remove-from-view': this._onRemoveFromView,
        'core:remove-from-view': this._onRemoveFromView
      };
    };

    DraftList.prototype._onDoubleClick = function(draft) {
      if (!draft.uploadTaskId) {
        return Actions.composePopoutDraft(draft.clientId);
      }
    };

    DraftList.prototype._onRemoveFromView = function() {
      var draft, drafts, _i, _len, _results;
      drafts = DraftListStore.dataSource().selection.items();
      _results = [];
      for (_i = 0, _len = drafts.length; _i < _len; _i++) {
        draft = drafts[_i];
        _results.push(Actions.destroyDraft(draft.clientId));
      }
      return _results;
    };

    return DraftList;

  })(React.Component);

  module.exports = DraftList;

}).call(this);
