(function() {
  var Actions, React, RetinaImg, SendingCancelButton,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  Actions = require('nylas-exports').Actions;

  RetinaImg = require('nylas-component-kit').RetinaImg;

  SendingCancelButton = (function(_super) {
    __extends(SendingCancelButton, _super);

    SendingCancelButton.displayName = 'SendingCancelButton';

    SendingCancelButton.propTypes = {
      taskId: React.PropTypes.string.isRequired
    };

    function SendingCancelButton(props) {
      this.props = props;
      this._onClick = __bind(this._onClick, this);
      this.render = __bind(this.render, this);
      this.state = {
        cancelling: false
      };
    }

    SendingCancelButton.prototype.render = function() {
      if (this.state.cancelling) {
        return React.createElement(RetinaImg, {
          "style": {
            width: 20,
            height: 20,
            marginTop: 2
          },
          "name": "inline-loading-spinner.gif",
          "mode": RetinaImg.Mode.ContentPreserve
        });
      } else {
        return React.createElement("div", {
          "onClick": this._onClick,
          "style": {
            marginTop: 1
          }
        }, React.createElement(RetinaImg, {
          "name": "image-cancel-button.png",
          "mode": RetinaImg.Mode.ContentPreserve
        }));
      }
    };

    SendingCancelButton.prototype._onClick = function() {
      Actions.dequeueTask(this.props.taskId);
      return this.setState({
        cancelling: true
      });
    };

    return SendingCancelButton;

  })(React.Component);

  module.exports = SendingCancelButton;

}).call(this);
