(function() {
  var Actions, KeyManager, KeybaseUser, PGPKeyStore, PassphrasePopover, React, Utils, fs, kb, pgp, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), Utils = _ref.Utils, React = _ref.React, Actions = _ref.Actions;

  PGPKeyStore = require('./pgp-key-store');

  KeybaseUser = require('./keybase-user');

  PassphrasePopover = require('./passphrase-popover');

  kb = require('./keybase');

  _ = require('underscore');

  pgp = require('kbpgp');

  fs = require('fs');

  module.exports = KeyManager = (function(_super) {
    __extends(KeyManager, _super);

    KeyManager.displayName = 'KeyManager';

    KeyManager.propTypes = {
      pubKeys: React.PropTypes.array.isRequired,
      privKeys: React.PropTypes.array.isRequired
    };

    function KeyManager(props) {
      this._exportPrivateKey = __bind(this._exportPrivateKey, this);
      this._exportPopoverDone = __bind(this._exportPopoverDone, this);
      KeyManager.__super__.constructor.call(this, props);
    }

    KeyManager.prototype._exportPopoverDone = function(passphrase, identity) {
      return fs.readFile(identity.keyPath, (function(_this) {
        return function(err, data) {
          return pgp.KeyManager.import_from_armored_pgp({
            armored: data
          }, function(err, km) {
            if (err) {
              return console.warn(err);
            } else {
              return km.unlock_pgp({
                passphrase: passphrase
              }, function(err) {
                if (err) {
                  return PGPKeyStore._displayError(err);
                } else {
                  return PGPKeyStore.exportKey({
                    identity: identity,
                    passphrase: passphrase
                  });
                }
              });
            }
          });
        };
      })(this));
    };

    KeyManager.prototype._exportPrivateKey = function(identity, event) {
      var popoverTarget;
      popoverTarget = event.target.getBoundingClientRect();
      return Actions.openPopover(React.createElement(PassphrasePopover, {
        "identity": identity,
        "onPopoverDone": this._exportPopoverDone
      }), {
        originRect: popoverTarget,
        direction: 'left'
      });
    };

    KeyManager.prototype.render = function() {
      var privKeys, pubKeys, _ref1;
      _ref1 = this.props, pubKeys = _ref1.pubKeys, privKeys = _ref1.privKeys;
      pubKeys = pubKeys.map((function(_this) {
        return function(identity) {
          var actionButton, deleteButton, exportButton;
          deleteButton = React.createElement("button", {
            "title": "Delete Public",
            "className": "btn btn-toolbar btn-danger",
            "onClick": (function() {
              return PGPKeyStore.deleteKey(identity);
            }),
            "ref": "button"
          }, "Delete Key");
          exportButton = React.createElement("button", {
            "title": "Export Public",
            "className": "btn btn-toolbar",
            "onClick": (function() {
              return PGPKeyStore.exportKey({
                identity: identity
              });
            }),
            "ref": "button"
          }, "Export Key");
          actionButton = React.createElement("div", {
            "className": "key-actions"
          }, exportButton, deleteButton);
          return React.createElement(KeybaseUser, {
            "profile": identity,
            "key": identity.clientId,
            "actionButton": actionButton
          });
        };
      })(this));
      privKeys = privKeys.map((function(_this) {
        return function(identity) {
          var actionButton, deleteButton, exportButton;
          deleteButton = React.createElement("button", {
            "title": "Delete Private",
            "className": "btn btn-toolbar btn-danger",
            "onClick": (function() {
              return PGPKeyStore.deleteKey(identity);
            }),
            "ref": "button"
          }, "Delete Key");
          exportButton = React.createElement("button", {
            "title": "Export Private",
            "className": "btn btn-toolbar",
            "onClick": (function(event) {
              return _this._exportPrivateKey(identity, event);
            }),
            "ref": "button"
          }, "Export Key");
          actionButton = React.createElement("div", {
            "className": "key-actions"
          }, exportButton, deleteButton);
          return React.createElement(KeybaseUser, {
            "profile": identity,
            "key": identity.clientId,
            "actionButton": actionButton
          });
        };
      })(this));
      return React.createElement("div", {
        "className": "key-manager"
      }, React.createElement("div", {
        "className": "line-w-label"
      }, React.createElement("div", {
        "className": "border"
      }), React.createElement("div", {
        "className": "title-text"
      }, "Saved Public Keys"), React.createElement("div", {
        "className": "border"
      })), React.createElement("div", null, pubKeys), React.createElement("div", {
        "className": "line-w-label"
      }, React.createElement("div", {
        "className": "border"
      }), React.createElement("div", {
        "className": "title-text"
      }, "Saved Private Keys"), React.createElement("div", {
        "className": "border"
      })), React.createElement("div", null, privKeys));
    };

    return KeyManager;

  })(React.Component);

}).call(this);
