(function() {
  var AccountStore, Actions, EdgehillAPI, EmailPopover, Identity, IdentityStore, KeybaseInviteButton, KeybaseSearch, KeybaseUser, PGPKeyStore, React, ReactDOM, RegExpUtils, RetinaImg, Utils, kb, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), Utils = _ref.Utils, React = _ref.React, ReactDOM = _ref.ReactDOM, Actions = _ref.Actions, RegExpUtils = _ref.RegExpUtils, IdentityStore = _ref.IdentityStore, AccountStore = _ref.AccountStore, EdgehillAPI = _ref.EdgehillAPI;

  RetinaImg = require('nylas-component-kit').RetinaImg;

  EmailPopover = require('./email-popover');

  PGPKeyStore = require('./pgp-key-store');

  KeybaseUser = require('../lib/keybase-user');

  Identity = require('./identity');

  kb = require('./keybase');

  _ = require('underscore');

  KeybaseInviteButton = (function(_super) {
    __extends(KeybaseInviteButton, _super);

    function KeybaseInviteButton(props) {
      this.props = props;
      this.render = __bind(this.render, this);
      this._onGetKeybaseInvite = __bind(this._onGetKeybaseInvite, this);
      this.state = {
        loading: false
      };
    }

    KeybaseInviteButton.prototype._onGetKeybaseInvite = function() {
      var errorHandler, token;
      this.setState({
        loading: true
      });
      token = AccountStore.tokenForAccountId(AccountStore.accounts()[0].id);
      errorHandler = (function(_this) {
        return function(err) {
          _this.setState({
            loading: false
          });
          return NylasEnv.showErrorDialog(err.message);
        };
      })(this);
      return EdgehillAPI.makeRequest({
        auth: {
          user: token,
          pass: ""
        },
        path: "/keybase-invite",
        method: "POST",
        body: {
          n1_id: IdentityStore.identityId()
        },
        error: errorHandler,
        success: (function(_this) {
          return function(body, response) {
            var err;
            _this.setState({
              loading: false
            });
            try {
              if (!(body instanceof Object) || !body.invite_url) {
                throw new Error("We were unable to retrieve an invitation.");
              }
            } catch (_error) {
              err = _error;
              errorHandler(err);
            }
            return require('electron').shell.openExternal(body.invite_url);
          };
        })(this)
      });
    };

    KeybaseInviteButton.prototype.render = function() {
      if (this.state.loading) {
        return React.createElement("a", null, "Processing...");
      } else {
        return React.createElement("a", {
          "onClick": this._onGetKeybaseInvite
        }, "We\'ve got an invite for you!");
      }
    };

    return KeybaseInviteButton;

  })(React.Component);

  module.exports = KeybaseSearch = (function(_super) {
    __extends(KeybaseSearch, _super);

    KeybaseSearch.displayName = 'KeybaseSearch';

    KeybaseSearch.propTypes = {
      initialSearch: React.PropTypes.string,
      importFunc: React.PropTypes["function"],
      inPreferences: React.PropTypes.bool
    };

    KeybaseSearch.defaultProps = {
      initialSearch: "",
      importFunc: false,
      inPreferences: false
    };

    function KeybaseSearch(props) {
      this._queryChange = __bind(this._queryChange, this);
      this._save = __bind(this._save, this);
      this._popoverDone = __bind(this._popoverDone, this);
      this._importKey = __bind(this._importKey, this);
      KeybaseSearch.__super__.constructor.call(this, props);
      this.state = {
        query: props.initialSearch,
        results: [],
        loading: false,
        searchedByEmail: false
      };
      this.debouncedSearch = _.debounce(this._search, 300);
    }

    KeybaseSearch.prototype.componentDidMount = function() {
      return this._search();
    };

    KeybaseSearch.prototype.componentWillReceiveProps = function(props) {
      return this.setState({
        query: props.initialSearch
      });
    };

    KeybaseSearch.prototype._search = function() {
      var oldquery;
      oldquery = this.state.query;
      if (this.state.query !== "" && this.state.loading === false) {
        this.setState({
          loading: true
        });
        return kb.autocomplete(this.state.query, (function(_this) {
          return function(error, profiles) {
            if (profiles != null) {
              profiles = _.map(profiles, function(profile) {
                return new Identity({
                  keybase_profile: profile,
                  isPriv: false
                });
              });
              _this.setState({
                results: profiles,
                loading: false
              });
            } else {
              _this.setState({
                results: [],
                loading: false
              });
            }
            if (_this.state.query !== oldquery) {
              return _this.debouncedSearch();
            }
          };
        })(this));
      } else {
        return this.setState({
          results: []
        });
      }
    };

    KeybaseSearch.prototype._importKey = function(profile, event) {
      var popoverTarget;
      popoverTarget = event.target.getBoundingClientRect();
      return Actions.openPopover(React.createElement(EmailPopover, {
        "profile": profile,
        "onPopoverDone": this._popoverDone
      }), {
        originRect: popoverTarget,
        direction: 'left'
      });
    };

    KeybaseSearch.prototype._popoverDone = function(addresses, identity) {
      if (addresses.length < 1) {

      } else {
        identity.addresses = addresses;
        return this._save(identity);
      }
    };

    KeybaseSearch.prototype._save = function(identity) {
      var keybaseUsername;
      keybaseUsername = identity.keybase_profile.components.username.val;
      return kb.getKey(keybaseUsername, (function(_this) {
        return function(error, key) {
          if (error) {
            return console.error(error);
          } else {
            return PGPKeyStore.saveNewKey(identity, key);
          }
        };
      })(this));
    };

    KeybaseSearch.prototype._queryChange = function(event) {
      var emailQuery;
      emailQuery = RegExpUtils.emailRegex().test(event.target.value);
      this.setState({
        query: event.target.value,
        searchedByEmail: emailQuery
      });
      return this.debouncedSearch();
    };

    KeybaseSearch.prototype.render = function() {
      var badSearch, empty, loading, profiles;
      profiles = _.map(this.state.results, (function(_this) {
        return function(profile) {
          var boundFunc, saveButton;
          if (typeof _this.props.importFunc === "function") {
            boundFunc = _this.props.importFunc;
          } else {
            boundFunc = _this._importKey;
          }
          saveButton = React.createElement("button", {
            "title": "Import",
            "className": "btn btn-toolbar",
            "onClick": (function(event) {
              return boundFunc(profile, event);
            }),
            "ref": "button"
          }, "Import Key");
          if (profile.keyPath == null) {
            return React.createElement(KeybaseUser, {
              "profile": profile,
              "actionButton": saveButton
            });
          }
        };
      })(this));
      if ((profiles == null) || profiles.length < 1) {
        profiles = [];
      }
      badSearch = null;
      loading = null;
      empty = null;
      if (profiles.length < 1 && this.state.searchedByEmail) {
        badSearch = React.createElement("span", {
          "className": "bad-search-msg"
        }, "Keybase cannot be searched by email address. ", React.createElement("br", null), "Try entering a name, or a username from GitHub, Keybase or Twitter.");
      }
      if (this.state.loading) {
        loading = React.createElement(RetinaImg, {
          "style": {
            width: 20,
            height: 20,
            marginTop: 2
          },
          "name": "inline-loading-spinner.gif",
          "mode": RetinaImg.Mode.ContentPreserve
        });
      }
      if (this.props.inPreferences && !loading && !badSearch && profiles.length === 0) {
        empty = React.createElement("p", {
          "className": "empty"
        }, "Not a Keybase user yet? ", React.createElement(KeybaseInviteButton, null));
      }
      return React.createElement("div", {
        "className": "keybase-search"
      }, React.createElement("div", {
        "className": "searchbar"
      }, React.createElement("input", {
        "type": "text",
        "value": this.state.query,
        "placeholder": "Search for PGP public keys on Keybase",
        "ref": "searchbar",
        "onChange": this._queryChange
      }), empty, React.createElement("div", {
        "className": "loading"
      }, loading)), React.createElement("div", {
        "className": "results",
        "ref": "results"
      }, profiles, badSearch));
    };

    return KeybaseSearch;

  })(React.Component);

}).call(this);
