(function() {
  var Actions, EmailPopover, Identity, KeybaseUser, PGPKeyStore, ParticipantsTextField, React, Utils, kb, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), Utils = _ref.Utils, React = _ref.React, Actions = _ref.Actions;

  ParticipantsTextField = require('nylas-component-kit').ParticipantsTextField;

  PGPKeyStore = require('./pgp-key-store');

  EmailPopover = require('./email-popover');

  Identity = require('./identity');

  kb = require('./keybase');

  _ = require('underscore');

  module.exports = KeybaseUser = (function(_super) {
    __extends(KeybaseUser, _super);

    KeybaseUser.displayName = 'KeybaseUserProfile';

    KeybaseUser.propTypes = {
      profile: React.PropTypes.instanceOf(Identity).isRequired,
      actionButton: React.PropTypes.node,
      displayEmailList: React.PropTypes.bool
    };

    KeybaseUser.defaultProps = {
      actionButton: false,
      displayEmailList: true
    };

    function KeybaseUser(props) {
      this.render = __bind(this.render, this);
      this._removeEmail = __bind(this._removeEmail, this);
      this._popoverDone = __bind(this._popoverDone, this);
      this._addEmailClick = __bind(this._addEmailClick, this);
      this._addEmail = __bind(this._addEmail, this);
      KeybaseUser.__super__.constructor.call(this, props);
    }

    KeybaseUser.prototype.componentDidMount = function() {
      return PGPKeyStore.getKeybaseData(this.props.profile);
    };

    KeybaseUser.prototype._addEmail = function(email) {
      return PGPKeyStore.addAddressToKey(this.props.profile, email);
    };

    KeybaseUser.prototype._addEmailClick = function(event) {
      var popoverTarget;
      popoverTarget = event.target.getBoundingClientRect();
      return Actions.openPopover(React.createElement(EmailPopover, {
        "profile": this.props.profile,
        "onPopoverDone": this._popoverDone
      }), {
        originRect: popoverTarget,
        direction: 'left'
      });
    };

    KeybaseUser.prototype._popoverDone = function(addresses, identity) {
      if (addresses.length < 1) {

      } else {
        return _.each(addresses, (function(_this) {
          return function(address) {
            return _this._addEmail(address);
          };
        })(this));
      }
    };

    KeybaseUser.prototype._removeEmail = function(email) {
      return PGPKeyStore.removeAddressFromKey(this.props.profile, email);
    };

    KeybaseUser.prototype.render = function() {
      var abv, bgColor, emailList, emailListDiv, emails, fullname, hue, keybase, keybaseDetails, keybase_string, keybase_url, picture, profile, username, _ref1, _ref2;
      profile = this.props.profile;
      keybaseDetails = React.createElement("div", {
        "className": "details"
      });
      if (profile.keybase_profile != null) {
        keybase = profile.keybase_profile;
        if (keybase.thumbnail != null) {
          picture = React.createElement("img", {
            "className": "user-picture",
            "src": keybase.thumbnail
          });
        } else {
          hue = Utils.hueForString("Keybase");
          bgColor = "hsl(" + hue + ", 50%, 45%)";
          abv = "K";
          picture = React.createElement("div", {
            "className": "default-profile-image",
            "style": {
              backgroundColor: bgColor
            }
          }, abv);
        }
        if (((_ref1 = keybase.components.full_name) != null ? _ref1.val : void 0) != null) {
          fullname = keybase.components.full_name.val;
        } else {
          fullname = username;
          username = false;
        }
        keybase_url = "keybase.io/" + keybase.components.username.val;
        if (keybase_url.length > 25) {
          keybase_string = keybase_url.slice(0, 23).concat('...');
        } else {
          keybase_string = keybase_url;
        }
        username = React.createElement("a", {
          "href": "https://" + keybase_url
        }, keybase_string);

        /*
        possible_profiles = ["twitter", "github", "coinbase"]
        profiles = _.map(possible_profiles, (possible) =>
          if keybase.components[possible]?.val?
             * TODO icon instead of weird "service: username" text
            return (<span key={ possible }><b>{ possible }</b>: { keybase.components[possible].val }</span>)
        )
        profiles = _.reject(profiles, (profile) -> profile is undefined)
        
        profiles =  _.map(profiles, (profile) ->
          return <span key={ profile.key }>{ profile } </span>)
        profileList = (<span>{ profiles }</span>)
         */
        keybaseDetails = React.createElement("div", {
          "className": "details"
        }, React.createElement("div", {
          "className": "profile-name"
        }, fullname), React.createElement("div", {
          "className": "profile-username"
        }, username));
      } else {
        hue = Utils.hueForString(this.props.profile.addresses[0]);
        bgColor = "hsl(" + hue + ", 50%, 45%)";
        abv = this.props.profile.addresses[0][0].toUpperCase();
        picture = React.createElement("div", {
          "className": "default-profile-image",
          "style": {
            backgroundColor: bgColor
          }
        }, abv);
      }
      if (((_ref2 = profile.addresses) != null ? _ref2.length : void 0) > 0) {
        emails = _.map(profile.addresses, (function(_this) {
          return function(email) {
            return React.createElement("li", {
              "key": email
            }, email, " ", React.createElement("small", null, React.createElement("a", {
              "onClick": (function() {
                return _this._removeEmail(email);
              })
            }, "(X)")));
          };
        })(this));
        emailList = React.createElement("ul", null, " ", emails, React.createElement("a", {
          "ref": "addEmail",
          "onClick": this._addEmailClick
        }, "+ Add Email"));
      }
      emailListDiv = React.createElement("div", {
        "className": "email-list"
      }, React.createElement("ul", null, emailList));
      return React.createElement("div", {
        "className": "keybase-profile"
      }, React.createElement("div", {
        "className": "profile-photo-wrap"
      }, React.createElement("div", {
        "className": "profile-photo"
      }, picture)), keybaseDetails, (this.props.displayEmailList ? emailListDiv : void 0), this.props.actionButton);
    };

    return KeybaseUser;

  })(React.Component);

}).call(this);
