(function() {
  var Actions, Identity, PassphrasePopover, React, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), React = _ref.React, Actions = _ref.Actions;

  Identity = require('./identity');

  _ = require('underscore');

  module.exports = PassphrasePopover = (function(_super) {
    __extends(PassphrasePopover, _super);

    function PassphrasePopover() {
      this._onDone = __bind(this._onDone, this);
      this._onPassphraseChange = __bind(this._onPassphraseChange, this);
      this.state = {
        passphrase: ""
      };
    }

    PassphrasePopover.propTypes = {
      identity: React.PropTypes.instanceOf(Identity)
    };

    PassphrasePopover.prototype.render = function() {
      var passphrase;
      passphrase = this.state;
      return React.createElement("div", {
        "className": "passphrase-popover"
      }, React.createElement("input", {
        "type": "password",
        "value": this.state.passphrase,
        "placeholder": "PGP private key password",
        "className": "key-passphrase-input form-control",
        "onChange": this._onPassphraseChange
      }), React.createElement("button", {
        "className": "btn btn-toolbar",
        "onClick": this._onDone
      }, "Done"));
    };

    PassphrasePopover.prototype._onPassphraseChange = function(event) {
      return this.setState({
        passphrase: event.target.value
      });
    };

    PassphrasePopover.prototype._onDone = function() {
      if (this.props.identity != null) {
        this.props.onPopoverDone(this.state.passphrase, this.props.identity);
      } else {
        this.props.onPopoverDone(this.state.passphrase);
      }
      return Actions.closePopover();
    };

    return PassphrasePopover;

  })(React.Component);

}).call(this);
