(function() {
  var Actions, DraftStore, FileDownloadStore, Identity, MessageBodyProcessor, NylasStore, PGPKeyStore, RegExpUtils, fs, kb, os, path, pgp, remote, shell, _, _ref, _ref1,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  NylasStore = require('nylas-store');

  _ref = require('nylas-exports'), Actions = _ref.Actions, FileDownloadStore = _ref.FileDownloadStore, DraftStore = _ref.DraftStore, MessageBodyProcessor = _ref.MessageBodyProcessor, RegExpUtils = _ref.RegExpUtils;

  _ref1 = require('electron'), remote = _ref1.remote, shell = _ref1.shell;

  Identity = require('./identity');

  kb = require('./keybase');

  pgp = require('kbpgp');

  _ = require('underscore');

  path = require('path');

  fs = require('fs');

  os = require('os');

  PGPKeyStore = (function(_super) {
    __extends(PGPKeyStore, _super);

    function PGPKeyStore() {
      this.decryptAttachments = __bind(this.decryptAttachments, this);
      this.decrypt = __bind(this.decrypt, this);
      this.getDecrypted = __bind(this.getDecrypted, this);
      this.privKeys = __bind(this.privKeys, this);
      this.pubKeys = __bind(this.pubKeys, this);
      this.removeAddressFromKey = __bind(this.removeAddressFromKey, this);
      this.addAddressToKey = __bind(this.addAddressToKey, this);
      this.deleteKey = __bind(this.deleteKey, this);
      this.exportKey = __bind(this.exportKey, this);
      this.saveNewKey = __bind(this.saveNewKey, this);
      this.getKeybaseData = __bind(this.getKeybaseData, this);
      this.getKeyContents = __bind(this.getKeyContents, this);
      this._populate = __bind(this._populate, this);
      this.unwatch = __bind(this.unwatch, this);
      this.watch = __bind(this.watch, this);
      this.validAddress = __bind(this.validAddress, this);
      PGPKeyStore.__super__.constructor.call(this);
      this._identities = {};
      this._msgCache = [];
      this._msgStatus = [];
      this._pubWatcher = null;
      this._privWatcher = null;
      this._keyDir = path.join(NylasEnv.getConfigDirPath(), 'keys');
      this._pubKeyDir = path.join(this._keyDir, 'public');
      this._privKeyDir = path.join(this._keyDir, 'private');
      fs.access(this._keyDir, fs.R_OK | fs.W_OK, (function(_this) {
        return function(err) {
          if (err) {
            return fs.mkdir(_this._keyDir, function(err) {
              if (err) {
                return console.warn(err);
              } else {
                return fs.mkdir(_this._pubKeyDir, function(err) {
                  if (err) {
                    return console.warn(err);
                  } else {
                    return fs.mkdir(_this._privKeyDir, function(err) {
                      if (err) {
                        return console.warn(err);
                      } else {
                        return _this.watch();
                      }
                    });
                  }
                });
              }
            });
          } else {
            fs.access(_this._pubKeyDir, fs.R_OK | fs.W_OK, function(err) {
              if (err) {
                return fs.mkdir(_this._pubKeyDir, function(err) {
                  if (err) {
                    return console.warn(err);
                  }
                });
              }
            });
            fs.access(_this._privKeyDir, fs.R_OK | fs.W_OK, function(err) {
              if (err) {
                return fs.mkdir(_this._privKeyDir, function(err) {
                  if (err) {
                    return console.warn(err);
                  }
                });
              }
            });
            _this._populate();
            return _this.watch();
          }
        };
      })(this));
    }

    PGPKeyStore.prototype.validAddress = function(address, isPub) {
      var keys, keystate;
      if (!address || address.length === 0) {
        this._displayError('You must provide an email address.');
        return false;
      }
      if (!(RegExpUtils.emailRegex().test(address))) {
        this._displayError('Invalid email address.');
        return false;
      }
      keys = isPub ? this.pubKeys(address) : this.privKeys({
        address: address,
        timed: false
      });
      keystate = isPub ? 'public' : 'private';
      if (keys.length > 0) {
        this._displayError("A PGP " + keystate + " key for that email address already exists.");
        return false;
      }
      return true;
    };


    /* I/O and File Tracking */

    PGPKeyStore.prototype.watch = function() {
      if (!this._pubWatcher) {
        this._pubWatcher = fs.watch(this._pubKeyDir, this._populate);
      }
      if (!this._privWatcher) {
        return this._privWatcher = fs.watch(this._privKeyDir, this._populate);
      }
    };

    PGPKeyStore.prototype.unwatch = function() {
      if (this._pubWatcher) {
        this._pubWatcher.close();
      }
      this._pubWatcher = null;
      if (this._privWatcher) {
        this._privWatcher.close();
      }
      return this._privWatcher = null;
    };

    PGPKeyStore.prototype._populate = function() {
      return fs.readdir(this._pubKeyDir, (function(_this) {
        return function(err, pubFilenames) {
          return fs.readdir(_this._privKeyDir, function(err, privFilenames) {
            _this._identities = {};
            return _.each([[pubFilenames, false], [privFilenames, true]], function(readresults) {
              var filename, filenames, i, ident, _results;
              filenames = readresults[0];
              i = 0;
              if (filenames.length === 0) {
                _this.trigger(_this);
              }
              _results = [];
              while (i < filenames.length) {
                filename = filenames[i];
                if (filename[0] === '.') {
                  continue;
                }
                ident = new Identity({
                  addresses: filename.split(" "),
                  isPriv: readresults[1]
                });
                _this._identities[ident.clientId] = ident;
                _this.trigger(_this);
                _results.push(i++);
              }
              return _results;
            });
          });
        };
      })(this));
    };

    PGPKeyStore.prototype.getKeyContents = function(_arg) {
      var callback, key, passphrase;
      key = _arg.key, passphrase = _arg.passphrase, callback = _arg.callback;
      if (key.keyPath == null) {
        console.error("Identity has no path for key!", key);
        return;
      }
      return fs.readFile(key.keyPath, (function(_this) {
        return function(err, data) {
          return pgp.KeyManager.import_from_armored_pgp({
            armored: data
          }, function(err, km) {
            if (err) {
              console.warn(err);
            } else {
              if (km.is_pgp_locked()) {
                if (passphrase == null) {
                  passphrase = "";
                }
                km.unlock_pgp({
                  passphrase: passphrase
                }, function(err) {
                  if (err) {
                    console.warn(err);
                  } else {
                    key.key = km;
                    key.setTimeout();
                    if (callback != null) {
                      return callback(key);
                    }
                  }
                });
              } else {
                key.key = km;
                key.setTimeout();
                _this.getKeybaseData(key);
                if (callback != null) {
                  callback(key);
                }
              }
            }
            return _this.trigger(_this);
          });
        };
      })(this));
    };

    PGPKeyStore.prototype.getKeybaseData = function(identity) {
      var fingerprint;
      if ((identity.key == null) && !identity.isPriv && !identity.keybase_profile) {
        return this.getKeyContents({
          key: identity
        });
      } else {
        fingerprint = identity.fingerprint();
        return kb.getUser(fingerprint, 'key_fingerprint', (function(_this) {
          return function(err, user) {
            if ((user != null ? user.length : void 0) === 1) {
              identity.keybase_profile = user[0];
              return _this.trigger(_this);
            }
          };
        })(this));
      }
    };

    PGPKeyStore.prototype.saveNewKey = function(identity, contents) {
      var addresses;
      if (!identity instanceof Identity) {
        console.error("saveNewKey requires an identity object");
        return;
      }
      addresses = identity.addresses;
      if (addresses.length < 1) {
        console.error("Identity must have at least one email address to save key");
        return;
      }
      if (_.every(addresses, (function(_this) {
        return function(address) {
          return _this.validAddress(address, !identity.isPriv);
        };
      })(this))) {
        if (contents.charAt(contents.length - 1) !== '-') {
          contents = contents.slice(0, -1);
        }
        return fs.writeFile(identity.keyPath, contents, (function(_this) {
          return function(err) {
            if (err) {
              return _this._displayError(err);
            }
          };
        })(this));
      }
    };

    PGPKeyStore.prototype.exportKey = function(_arg) {
      var atIndex, identity, passphrase, savePath, shortName, suffix, _base;
      identity = _arg.identity, passphrase = _arg.passphrase;
      atIndex = identity.addresses[0].indexOf("@");
      suffix = identity.isPriv ? "-private.asc" : ".asc";
      shortName = identity.addresses[0].slice(0, atIndex).concat(suffix);
      if ((_base = NylasEnv.savedState).lastKeybaseDownloadDirectory == null) {
        _base.lastKeybaseDownloadDirectory = os.homedir();
      }
      savePath = path.join(NylasEnv.savedState.lastKeybaseDownloadDirectory, shortName);
      return this.getKeyContents({
        key: identity,
        passphrase: passphrase,
        callback: ((function(_this) {
          return function(identity) {
            return NylasEnv.showSaveDialog({
              title: "Export PGP Key",
              defaultPath: savePath
            }, function(keyPath) {
              if (!keyPath) {
                return;
              }
              NylasEnv.savedState.lastKeybaseDownloadDirectory = keyPath.slice(0, keyPath.length - shortName.length);
              if (passphrase != null) {
                return identity.key.export_pgp_private({
                  passphrase: passphrase
                }, function(err, pgp_private) {
                  if (err) {
                    _this._displayError(err);
                  }
                  return fs.writeFile(keyPath, pgp_private, function(err) {
                    if (err) {
                      _this._displayError(err);
                    }
                    return shell.showItemInFolder(keyPath);
                  });
                });
              } else {
                return identity.key.export_pgp_public({}, function(err, pgp_public) {
                  return fs.writeFile(keyPath, pgp_public, function(err) {
                    if (err) {
                      _this._displayError(err);
                    }
                    return shell.showItemInFolder(keyPath);
                  });
                });
              }
            });
          };
        })(this))
      });
    };

    PGPKeyStore.prototype.deleteKey = function(key) {
      if (this._displayDialog('Delete this key?', 'The key will be permanently deleted.', ['Delete', 'Cancel'])) {
        return fs.unlink(key.keyPath, (function(_this) {
          return function(err) {
            if (err) {
              _this._displayError(err);
            }
            return _this._populate();
          };
        })(this));
      }
    };

    PGPKeyStore.prototype.addAddressToKey = function(profile, address) {
      var oldPath;
      if (this.validAddress(address, true)) {
        oldPath = profile.keyPath;
        profile.addresses.push(address);
        return fs.rename(oldPath, profile.keyPath, (function(_this) {
          return function(err) {
            if (err) {
              return _this._displayError(err);
            }
          };
        })(this));
      }
    };

    PGPKeyStore.prototype.removeAddressFromKey = function(profile, address) {
      var oldPath;
      if (profile.addresses.length > 1) {
        oldPath = profile.keyPath;
        profile.addresses = _.without(profile.addresses, address);
        return fs.rename(oldPath, profile.keyPath, (function(_this) {
          return function(err) {
            if (err) {
              return _this._displayError(err);
            }
          };
        })(this));
      } else {
        return this.deleteKey(profile);
      }
    };


    /* Internal Key Management */

    PGPKeyStore.prototype.pubKeys = function(addresses) {
      var identities;
      identities = _.where(_.values(this._identities), {
        isPriv: false
      });
      if (addresses == null) {
        return identities;
      }
      if (typeof addresses === "string") {
        addresses = [addresses];
      }
      identities = _.filter(identities, function(identity) {
        return _.intersection(addresses, identity.addresses).length > 0;
      });
      return identities;
    };

    PGPKeyStore.prototype.privKeys = function(_arg) {
      var address, identities, timed, _ref2;
      _ref2 = _arg != null ? _arg : {
        timed: true
      }, address = _ref2.address, timed = _ref2.timed;
      identities = _.where(_.values(this._identities), {
        isPriv: true
      });
      if (address != null) {
        identities = _.filter(identities, function(identity) {
          return __indexOf.call(identity.addresses, address) >= 0;
        });
      }
      if (timed) {
        identities = _.reject(identities, function(identity) {
          return identity.isTimedOut();
        });
      }
      return identities;
    };

    PGPKeyStore.prototype._displayError = function(err) {
      var dialog;
      dialog = remote.dialog;
      return dialog.showErrorBox('Key Management Error', err.toString());
    };

    PGPKeyStore.prototype._displayDialog = function(title, message, buttons) {
      var dialog;
      dialog = remote.dialog;
      return dialog.showMessageBox({
        title: title,
        message: title,
        detail: message,
        buttons: buttons,
        type: 'info'
      }) === 0;
    };

    PGPKeyStore.prototype.msgStatus = function(msg) {
      var clientId, status, statuses;
      if (msg == null) {
        return null;
      } else {
        clientId = msg.clientId;
        statuses = _.filter(this._msgStatus, function(status) {
          return status.clientId === clientId;
        });
        status = _.max(statuses, function(stat) {
          return stat.time;
        });
      }
      return status.message;
    };

    PGPKeyStore.prototype.isDecrypted = function(message) {
      if (!this.hasEncryptedComponent(message)) {
        return true;
      } else if (this.getDecrypted(message) != null) {
        return true;
      } else {
        return false;
      }
    };

    PGPKeyStore.prototype.getDecrypted = function(message) {
      var msg, _ref2;
      if (_ref2 = message.clientId, __indexOf.call(_.pluck(this._msgCache, 'clientId'), _ref2) >= 0) {
        msg = _.findWhere(this._msgCache, {
          clientId: message.clientId
        });
        if (msg.timeout > Date.now()) {
          return msg.body;
        }
      }
      return null;
    };

    PGPKeyStore.prototype.hasEncryptedComponent = function(message) {
      var blockEnd, blockStart, pgpEnd, pgpStart;
      if (message.body == null) {
        return false;
      }
      pgpStart = "-----BEGIN PGP MESSAGE-----";
      pgpEnd = "-----END PGP MESSAGE-----";
      blockStart = message.body.indexOf(pgpStart);
      blockEnd = message.body.indexOf(pgpEnd);
      return blockStart >= 0 && blockEnd >= 0;
    };

    PGPKeyStore.prototype.fetchEncryptedAttachments = function(message) {
      var encrypted;
      encrypted = _.map(message.files, (function(_this) {
        return function(file) {
          var extension, tokenized;
          if (file.filename != null) {
            tokenized = file.filename.split('.');
            extension = tokenized[tokenized.length - 1];
            if (extension === "asc" || extension === "pgp") {
              return file;
            } else {
              return null;
            }
          } else {
            return null;
          }
        };
      })(this));
      return _.compact(encrypted);
    };

    PGPKeyStore.prototype.decrypt = function(message) {
      var blockEnd, blockStart, key, pgpEnd, pgpMsg, pgpStart, ring, _i, _len, _ref2;
      if (this.getDecrypted(message) != null) {
        return;
      }
      if (!this.hasEncryptedComponent(message)) {
        return;
      }
      ring = new pgp.keyring.KeyRing;
      _ref2 = this.privKeys({
        timed: true
      });
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        key = _ref2[_i];
        if (key.key != null) {
          ring.add_key_manager(key.key);
        }
      }
      pgpStart = "-----BEGIN PGP MESSAGE-----";
      blockStart = message.body.indexOf(pgpStart);
      pgpEnd = "-----END PGP MESSAGE-----";
      blockEnd = message.body.indexOf(pgpEnd) + pgpEnd.length;
      if (!(blockStart >= 0 && blockEnd >= 0)) {
        return;
      }
      pgpMsg = message.body.slice(blockStart, blockEnd);
      pgpMsg = pgpMsg.replace(/&#43;/gm, '+');
      return pgp.unbox({
        keyfetch: ring,
        armored: pgpMsg
      }, (function(_this) {
        return function(err, literals, warnings, subkey) {
          var body, keyprint, plaintext, timeout;
          if (err) {
            console.warn(err);
            return _this._msgStatus.push({
              "clientId": message.clientId,
              "time": Date.now(),
              "message": "Unable to decrypt message."
            });
          } else {
            if (warnings._w.length > 0) {
              console.warn(warnings._w);
            }
            if (literals.length > 0) {
              plaintext = literals[0].toString('utf8');
              body = message.body.slice(0, blockStart) + plaintext + message.body.slice(blockEnd);
              timeout = 1000 * 60 * 30;
              _this._msgCache.push({
                clientId: message.clientId,
                body: body,
                timeout: Date.now() + timeout
              });
              keyprint = subkey.get_fingerprint().toString('hex');
              _this._msgStatus.push({
                "clientId": message.clientId,
                "time": Date.now(),
                "message": "Message decrypted with key " + keyprint + "!"
              });
              MessageBodyProcessor.resetCache();
              return _this.trigger(_this);
            } else {
              console.warn("Unable to decrypt message.");
              return _this._msgStatus.push({
                "clientId": message.clientId,
                "time": Date.now(),
                "message": "Unable to decrypt message."
              });
            }
          }
        };
      })(this));
    };

    PGPKeyStore.prototype.decryptAttachments = function(identity, files) {
      var keyring;
      keyring = new pgp.keyring.KeyRing;
      if (identity.key != null) {
        keyring.add_key_manager(identity.key);
      }
      return FileDownloadStore._fetchAndSaveAll(files).then(function(filepaths) {
        return _.each(filepaths, (function(_this) {
          return function(filepath) {
            return fs.readFile(filepath, function(err, data) {
              var blockEnd, blockStart, pgpEnd, pgpMsg, pgpStart;
              pgpStart = "-----BEGIN PGP MESSAGE-----";
              blockStart = data.indexOf(pgpStart);
              pgpEnd = "-----END PGP MESSAGE-----";
              blockEnd = data.indexOf(pgpEnd) + pgpEnd.length;
              if (!(blockStart >= 0 && blockEnd >= 0)) {
                return;
              }
              pgpMsg = data.slice(blockStart, blockEnd);
              return pgp.unbox({
                keyfetch: keyring,
                armored: pgpMsg
              }, function(err, literals, warnings, subkey) {
                var literalLen;
                if (err) {
                  console.warn(err);
                } else {
                  if (warnings._w.length > 0) {
                    console.warn(warnings._w);
                  }
                }
                literalLen = literals != null ? literals.length : void 0;
                if (literalLen == null) {
                  return;
                }
                if (literalLen === 1) {
                  filepath = filepath.slice(0, filepath.length - 3).concat("txt");
                  return fs.writeFile(filepath, literals[0].toBuffer(), function(err) {
                    if (err) {
                      return console.warn(err);
                    }
                  });
                } else {
                  return console.warn("Attempt to decrypt attachment failed: " + literalLen + " literals found, expected 1.");
                }
              });
            });
          };
        })(this));
      });
    };

    return PGPKeyStore;

  })(NylasStore);

  module.exports = new PGPKeyStore();

}).call(this);
