(function() {
  var KeyAdder, KeyManager, KeybaseSearch, PGPKeyStore, PreferencesKeybase, React, RegExpUtils, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), React = _ref.React, RegExpUtils = _ref.RegExpUtils;

  PGPKeyStore = require('./pgp-key-store');

  KeybaseSearch = require('./keybase-search');

  KeyManager = require('./key-manager');

  KeyAdder = require('./key-adder');

  PreferencesKeybase = (function(_super) {
    __extends(PreferencesKeybase, _super);

    PreferencesKeybase.displayName = 'PreferencesKeybase';

    function PreferencesKeybase(props) {
      var privKeys, pubKeys, _ref1;
      this.props = props;
      this.render = __bind(this.render, this);
      this._onChange = __bind(this._onChange, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this._keySaveQueue = {};
      _ref1 = this._getStateFromStores(), pubKeys = _ref1.pubKeys, privKeys = _ref1.privKeys;
      this.state = {
        pubKeys: pubKeys,
        privKeys: privKeys
      };
    }

    PreferencesKeybase.prototype.componentDidMount = function() {
      return this.unlistenKeystore = PGPKeyStore.listen(this._onChange, this);
    };

    PreferencesKeybase.prototype.componentWillUnmount = function() {
      return this.unlistenKeystore();
    };

    PreferencesKeybase.prototype._onChange = function() {
      return this.setState(this._getStateFromStores());
    };

    PreferencesKeybase.prototype._getStateFromStores = function() {
      var privKeys, pubKeys;
      pubKeys = PGPKeyStore.pubKeys();
      privKeys = PGPKeyStore.privKeys({
        timed: false
      });
      return {
        pubKeys: pubKeys,
        privKeys: privKeys
      };
    };

    PreferencesKeybase.prototype.render = function() {
      var keyManager, noKeysMessage;
      noKeysMessage = React.createElement("div", {
        "className": "key-status-bar no-keys-message"
      }, "You have no saved PGP keys!");
      keyManager = React.createElement(KeyManager, {
        "pubKeys": this.state.pubKeys,
        "privKeys": this.state.privKeys
      });
      return React.createElement("div", {
        "className": "container-keybase"
      }, React.createElement("section", {
        "className": "key-add"
      }, React.createElement(KeyAdder, null)), React.createElement("section", {
        "className": "keybase"
      }, React.createElement(KeybaseSearch, {
        "inPreferences": true
      }), (this.state.pubKeys.length === 0 && this.state.privKeys.length === 0 ? noKeysMessage : keyManager)));
    };

    return PreferencesKeybase;

  })(React.Component);

  module.exports = PreferencesKeybase;

}).call(this);
