(function() {
  var MessageStore, PGPKeyStore, React, RecipientKeyChip, RetinaImg, pgp, _, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), MessageStore = _ref.MessageStore, React = _ref.React;

  RetinaImg = require('nylas-component-kit').RetinaImg;

  PGPKeyStore = require('./pgp-key-store');

  pgp = require('kbpgp');

  _ = require('underscore');

  RecipientKeyChip = (function(_super) {
    __extends(RecipientKeyChip, _super);

    RecipientKeyChip.displayName = 'RecipientKeyChip';

    RecipientKeyChip.propTypes = {
      contact: React.PropTypes.object.isRequired
    };

    function RecipientKeyChip(props) {
      RecipientKeyChip.__super__.constructor.call(this, props);
      this.state = this._getStateFromStores();
    }

    RecipientKeyChip.prototype.componentDidMount = function() {
      var keys;
      keys = PGPKeyStore.pubKeys(this.props.contact.email);
      _.each(keys, function(key) {
        return PGPKeyStore.getKeyContents({
          key: key
        });
      });
      return this.unlistenKeystore = PGPKeyStore.listen(this._onKeystoreChange, this);
    };

    RecipientKeyChip.prototype.componentWillUnmount = function() {
      return this.unlistenKeystore();
    };

    RecipientKeyChip.prototype._getStateFromStores = function() {
      return {
        keys: PGPKeyStore.pubKeys(this.props.contact.email).some((function(_this) {
          return function(cv, ind, arr) {
            return cv.hasOwnProperty('key');
          };
        })(this))
      };
    };

    RecipientKeyChip.prototype._onKeystoreChange = function() {
      return this.setState(this._getStateFromStores());
    };

    RecipientKeyChip.prototype.render = function() {
      if (this.state.keys) {
        return React.createElement("div", {
          "className": "n1-keybase-recipient-key-chip"
        }, React.createElement(RetinaImg, {
          "url": "nylas://keybase/key-present@2x.png",
          "mode": RetinaImg.Mode.ContentPreserve,
          "ref": "keyIcon"
        }));
      } else {
        return React.createElement("div", {
          "className": "n1-keybase-recipient-key-chip"
        }, React.createElement("span", {
          "ref": "noKeyIcon"
        }));
      }
    };

    return RecipientKeyChip;

  })(React.Component);

  module.exports = RecipientKeyChip;

}).call(this);
