(function() {
  var kb;

  kb = require('../lib/keybase');

  xdescribe("keybase lib", function() {
    it("should be able to fetch an account by username", function() {
      this.them = null;
      runs((function(_this) {
        return function() {
          return kb.getUser('dakota', 'usernames', function(err, them) {
            return _this.them = them;
          });
        };
      })(this));
      waitsFor(((function(_this) {
        return function() {
          return _this.them !== null;
        };
      })(this)), 2000);
      return runs((function(_this) {
        return function() {
          var _ref;
          return expect((_ref = _this.them) != null ? _ref[0].components.username.val : void 0).toEqual("dakota");
        };
      })(this));
    });
    it("should be able to fetch an account by key fingerprint", function() {
      this.them = null;
      runs((function(_this) {
        return function() {
          return kb.getUser('7FA5A43BBF2BAD1845C8D0E8145FCCD989968E3B', 'key_fingerprint', function(err, them) {
            return _this.them = them;
          });
        };
      })(this));
      waitsFor(((function(_this) {
        return function() {
          return _this.them !== null;
        };
      })(this)), 2000);
      return runs((function(_this) {
        return function() {
          var _ref;
          return expect((_ref = _this.them) != null ? _ref[0].components.username.val : void 0).toEqual("dakota");
        };
      })(this));
    });
    it("should be able to fetch a user's key", function() {
      this.key = null;
      runs((function(_this) {
        return function() {
          return kb.getKey('dakota', function(error, key) {
            return _this.key = key;
          });
        };
      })(this));
      waitsFor(((function(_this) {
        return function() {
          return _this.key !== null;
        };
      })(this)), 2000);
      return runs((function(_this) {
        return function() {
          var _ref;
          return expect((_ref = _this.key) != null ? _ref.startsWith('-----BEGIN PGP PUBLIC KEY BLOCK-----') : void 0);
        };
      })(this));
    });
    return it("should be able to return an autocomplete query", function() {
      this.completions = null;
      runs((function(_this) {
        return function() {
          return kb.autocomplete('dakota', function(error, completions) {
            return _this.completions = completions;
          });
        };
      })(this));
      waitsFor(((function(_this) {
        return function() {
          return _this.completions !== null;
        };
      })(this)), 2000);
      return runs((function(_this) {
        return function() {
          return expect(_this.completions[0].components.username.val).toEqual("dakota");
        };
      })(this));
    });
  });

}).call(this);
