(function() {
  var ComponentRegistry, DecryptMessageButton, DecryptPGPExtension, EncryptMessageButton, ExtensionRegistry, activate, deactivate, _ref, _ref1;

  _ref = require('nylas-exports'), ComponentRegistry = _ref.ComponentRegistry, ExtensionRegistry = _ref.ExtensionRegistry;

  _ref1 = require('../lib/main'), activate = _ref1.activate, deactivate = _ref1.deactivate;

  EncryptMessageButton = require('../lib/encrypt-button');

  DecryptMessageButton = require('../lib/decrypt-button');

  DecryptPGPExtension = require('../lib/decryption-preprocess');

  describe("activate", function() {
    it("should register the encryption button", function() {
      spyOn(ComponentRegistry, 'register');
      activate();
      return expect(ComponentRegistry.register).toHaveBeenCalledWith(EncryptMessageButton, {
        role: 'Composer:ActionButton'
      });
    });
    it("should register the decryption button", function() {
      spyOn(ComponentRegistry, 'register');
      activate();
      return expect(ComponentRegistry.register).toHaveBeenCalledWith(DecryptMessageButton, {
        role: 'message:BodyHeader'
      });
    });
    return it("should register the decryption processor", function() {
      spyOn(ExtensionRegistry.MessageView, 'register');
      activate();
      return expect(ExtensionRegistry.MessageView.register).toHaveBeenCalledWith(DecryptPGPExtension);
    });
  });

  describe("deactivate", function() {
    it("should unregister the encrypt button", function() {
      spyOn(ComponentRegistry, 'unregister');
      deactivate();
      return expect(ComponentRegistry.unregister).toHaveBeenCalledWith(EncryptMessageButton);
    });
    it("should unregister the decryption button", function() {
      spyOn(ComponentRegistry, 'unregister');
      deactivate();
      return expect(ComponentRegistry.unregister).toHaveBeenCalledWith(DecryptMessageButton);
    });
    return it("should unregister the decryption processor", function() {
      spyOn(ExtensionRegistry.MessageView, 'unregister');
      deactivate();
      return expect(ExtensionRegistry.MessageView.unregister).toHaveBeenCalledWith(DecryptPGPExtension);
    });
  });

}).call(this);
