(function() {
  var Contact, DraftStore, PGPKeyStore, React, ReactTestUtils, RecipientKeyChip, pgp, _ref;

  _ref = require('nylas-exports'), React = _ref.React, ReactTestUtils = _ref.ReactTestUtils, DraftStore = _ref.DraftStore, Contact = _ref.Contact;

  pgp = require('kbpgp');

  RecipientKeyChip = require('../lib/recipient-key-chip');

  PGPKeyStore = require('../lib/pgp-key-store');

  describe("DecryptMessageButton", function() {
    beforeEach(function() {
      this.contact = new Contact({
        email: "test@example.com"
      });
      return this.component = ReactTestUtils.renderIntoDocument(React.createElement(RecipientKeyChip, {
        "contact": this.contact
      }));
    });
    it("should render into the page", function() {
      return expect(this.component).toBeDefined();
    });
    it("should have a displayName", function() {
      return expect(RecipientKeyChip.displayName).toBe('RecipientKeyChip');
    });
    xit("should indicate when a recipient has a PGP key available", function() {
      var key;
      spyOn(PGPKeyStore, "pubKeys").andCallFake((function(_this) {
        return function(address) {
          return [
            {
              'key': 0
            }
          ];
        };
      })(this));
      key = PGPKeyStore.pubKeys(this.contact.email);
      expect(key).toBeDefined();
      expect(this.component.refs.keyIcon).toBeDefined();
      return expect(this.component.refs.noKeyIcon).not.toBeDefined();
    });
    return xit("should indicate when a recipient does not have a PGP key available", function() {
      var component, key;
      component = ReactTestUtils.renderIntoDocument(React.createElement(RecipientKeyChip, {
        "contact": this.contact
      }));
      key = PGPKeyStore.pubKeys(this.contact.email);
      expect(key).toEqual([]);
      expect(component.refs.keyIcon).not.toBeDefined();
      return expect(component.refs.noKeyIcon).toBeDefined();
    });
  });

}).call(this);
