(function() {
  var EmailFrameStylesStore, NylasStore,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  NylasStore = require('nylas-store');

  EmailFrameStylesStore = (function(_super) {
    __extends(EmailFrameStylesStore, _super);

    function EmailFrameStylesStore() {
      this._unlistenToStyles = __bind(this._unlistenToStyles, this);
      this._listenToStyles = __bind(this._listenToStyles, this);
      this._findStyles = __bind(this._findStyles, this);
      this.styles = __bind(this.styles, this);
    }

    EmailFrameStylesStore.prototype.styles = function() {
      if (!this._styles) {
        this._findStyles();
        this._listenToStyles();
      }
      return this._styles;
    };

    EmailFrameStylesStore.prototype._findStyles = function() {
      var sheet, _i, _len, _ref;
      this._styles = "";
      _ref = document.querySelectorAll('[source-path*="email-frame.less"]');
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        sheet = _ref[_i];
        this._styles += "\n" + sheet.innerText;
      }
      this._styles = this._styles.replace(/.ignore-in-parent-frame/g, '');
      return this.trigger();
    };

    EmailFrameStylesStore.prototype._listenToStyles = function() {
      var target;
      target = document.getElementsByTagName('nylas-styles')[0];
      this._mutationObserver = new MutationObserver(this._findStyles);
      return this._mutationObserver.observe(target, {
        attributes: true,
        subtree: true,
        childList: true
      });
    };

    EmailFrameStylesStore.prototype._unlistenToStyles = function() {
      var _ref;
      return (_ref = this._mutationObserver) != null ? _ref.disconnect() : void 0;
    };

    module.exports = new EmailFrameStylesStore();

    return EmailFrameStylesStore;

  })(NylasStore);

}).call(this);
