(function() {
  var ComponentRegistry, ExtensionRegistry, MessageList, MessageListHiddenMessagesToggle, SidebarParticipantPicker, SidebarPluginContainer, WorkspaceStore, _ref;

  _ref = require('nylas-exports'), ComponentRegistry = _ref.ComponentRegistry, ExtensionRegistry = _ref.ExtensionRegistry, WorkspaceStore = _ref.WorkspaceStore;

  MessageList = require("./message-list");

  MessageListHiddenMessagesToggle = require('./message-list-hidden-messages-toggle')["default"];

  SidebarPluginContainer = require("./sidebar-plugin-container");

  SidebarParticipantPicker = require('./sidebar-participant-picker')["default"];

  module.exports = {
    activate: function() {
      ComponentRegistry.register(MessageList, {
        location: WorkspaceStore.Location.MessageList
      });
      ComponentRegistry.register(SidebarParticipantPicker, {
        location: WorkspaceStore.Location.MessageListSidebar
      });
      ComponentRegistry.register(SidebarPluginContainer, {
        location: WorkspaceStore.Location.MessageListSidebar
      });
      return ComponentRegistry.register(MessageListHiddenMessagesToggle, {
        role: 'MessageListHeaders'
      });
    },
    deactivate: function() {
      ComponentRegistry.unregister(MessageList);
      ComponentRegistry.unregister(SidebarPluginContainer);
      return ComponentRegistry.unregister(SidebarParticipantPicker);
    }
  };

}).call(this);
