(function() {
  var AccountStore, Actions, ChangeLabelsTask, ChangeStarredTask, ComponentRegistry, DatabaseStore, DraftStore, FindInThread, InjectedComponent, InjectedComponentSet, KeyCommandsRegion, MailImportantIcon, MailLabelSet, Message, MessageItemContainer, MessageList, MessageListScrollTooltip, MessageStore, React, ReactDOM, RetinaImg, ScrollRegion, SearchableComponentMaker, SearchableComponentStore, Spinner, Utils, WorkspaceStore, classNames, _, _ref, _ref1,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  ReactDOM = require('react-dom');

  classNames = require('classnames');

  FindInThread = require('./find-in-thread')["default"];

  MessageItemContainer = require('./message-item-container');

  _ref = require("nylas-exports"), Utils = _ref.Utils, Actions = _ref.Actions, Message = _ref.Message, DraftStore = _ref.DraftStore, MessageStore = _ref.MessageStore, AccountStore = _ref.AccountStore, DatabaseStore = _ref.DatabaseStore, WorkspaceStore = _ref.WorkspaceStore, ChangeLabelsTask = _ref.ChangeLabelsTask, ComponentRegistry = _ref.ComponentRegistry, ChangeStarredTask = _ref.ChangeStarredTask, SearchableComponentStore = _ref.SearchableComponentStore, SearchableComponentMaker = _ref.SearchableComponentMaker;

  _ref1 = require('nylas-component-kit'), Spinner = _ref1.Spinner, RetinaImg = _ref1.RetinaImg, MailLabelSet = _ref1.MailLabelSet, ScrollRegion = _ref1.ScrollRegion, MailImportantIcon = _ref1.MailImportantIcon, InjectedComponent = _ref1.InjectedComponent, KeyCommandsRegion = _ref1.KeyCommandsRegion, InjectedComponentSet = _ref1.InjectedComponentSet;

  MessageListScrollTooltip = (function(_super) {
    __extends(MessageListScrollTooltip, _super);

    function MessageListScrollTooltip() {
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      this.componentWillReceiveProps = __bind(this.componentWillReceiveProps, this);
      this.componentWillMount = __bind(this.componentWillMount, this);
      return MessageListScrollTooltip.__super__.constructor.apply(this, arguments);
    }

    MessageListScrollTooltip.displayName = 'MessageListScrollTooltip';

    MessageListScrollTooltip.propTypes = {
      viewportCenter: React.PropTypes.number.isRequired,
      totalHeight: React.PropTypes.number.isRequired
    };

    MessageListScrollTooltip.prototype.componentWillMount = function() {
      return this.setupForProps(this.props);
    };

    MessageListScrollTooltip.prototype.componentWillReceiveProps = function(newProps) {
      return this.setupForProps(newProps);
    };

    MessageListScrollTooltip.prototype.shouldComponentUpdate = function(newProps, newState) {
      return !_.isEqual(this.state, newState);
    };

    MessageListScrollTooltip.prototype.setupForProps = function(props) {
      var els, idx;
      els = document.querySelectorAll('.message-item-wrap');
      idx = _.findIndex(els, function(el) {
        return el.offsetTop > props.viewportCenter;
      });
      if (idx === -1) {
        idx = els.length;
      }
      return this.setState({
        idx: idx,
        count: els.length
      });
    };

    MessageListScrollTooltip.prototype.render = function() {
      return React.createElement("div", {
        "className": "scroll-tooltip"
      }, this.state.idx, " of ", this.state.count);
    };

    return MessageListScrollTooltip;

  })(React.Component);

  MessageList = (function(_super) {
    __extends(MessageList, _super);

    MessageList.displayName = 'MessageList';

    MessageList.containerRequired = false;

    MessageList.containerStyles = {
      minWidth: 500,
      maxWidth: 999999
    };

    function MessageList(props) {
      this.props = props;
      this._getStateFromStores = __bind(this._getStateFromStores, this);
      this._onChange = __bind(this._onChange, this);
      this._onScrollByPage = __bind(this._onScrollByPage, this);
      this._scrollTo = __bind(this._scrollTo, this);
      this._messagesWithMinification = __bind(this._messagesWithMinification, this);
      this._messageElements = __bind(this._messageElements, this);
      this._onClickReplyArea = __bind(this._onClickReplyArea, this);
      this._onPrintThread = __bind(this._onPrintThread, this);
      this._replyType = __bind(this._replyType, this);
      this._lastMessage = __bind(this._lastMessage, this);
      this._renderReplyArea = __bind(this._renderReplyArea, this);
      this._renderExpandToggle = __bind(this._renderExpandToggle, this);
      this._renderIcons = __bind(this._renderIcons, this);
      this.render = __bind(this.render, this);
      this._onForward = __bind(this._onForward, this);
      this._focusDraft = __bind(this._focusDraft, this);
      this._getMessageContainer = __bind(this._getMessageContainer, this);
      this.componentDidUpdate = __bind(this.componentDidUpdate, this);
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = this._getStateFromStores();
      this.state.minified = true;
      this._draftScrollInProgress = false;
      this.MINIFY_THRESHOLD = 3;
    }

    MessageList.prototype.componentDidMount = function() {
      this._unsubscribers = [];
      this._unsubscribers.push(MessageStore.listen(this._onChange));
      return this._unsubscribers.push(Actions.focusDraft.listen((function(_this) {
        return function(_arg) {
          var draftClientId;
          draftClientId = _arg.draftClientId;
          return Utils.waitFor(function() {
            return _this._getMessageContainer(draftClientId) != null;
          }).then(function() {
            return _this._focusDraft(_this._getMessageContainer(draftClientId));
          })["catch"](function() {});
        };
      })(this)));
    };

    MessageList.prototype.componentWillUnmount = function() {
      var unsubscribe, _i, _len, _ref2, _results;
      _ref2 = this._unsubscribers;
      _results = [];
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        unsubscribe = _ref2[_i];
        _results.push(unsubscribe());
      }
      return _results;
    };

    MessageList.prototype.shouldComponentUpdate = function(nextProps, nextState) {
      return !Utils.isEqualReact(nextProps, this.props) || !Utils.isEqualReact(nextState, this.state);
    };

    MessageList.prototype.componentDidUpdate = function(prevProps, prevState) {};

    MessageList.prototype._globalMenuItems = function() {
      var toggleExpandedLabel;
      toggleExpandedLabel = this.state.hasCollapsedItems ? "Expand" : "Collapse";
      return [
        {
          "label": "Thread",
          "submenu": [
            {
              "label": "" + toggleExpandedLabel + " conversation",
              "command": "message-list:toggle-expanded",
              "position": "endof=view-actions"
            }
          ]
        }
      ];
    };

    MessageList.prototype._globalKeymapHandlers = function() {
      var handlers;
      handlers = {
        'core:reply': (function(_this) {
          return function() {
            return Actions.composeReply({
              thread: _this.state.currentThread,
              message: _this._lastMessage(),
              type: 'reply',
              behavior: 'prefer-existing'
            });
          };
        })(this),
        'core:reply-all': (function(_this) {
          return function() {
            return Actions.composeReply({
              thread: _this.state.currentThread,
              message: _this._lastMessage(),
              type: 'reply-all',
              behavior: 'prefer-existing'
            });
          };
        })(this),
        'core:forward': (function(_this) {
          return function() {
            return _this._onForward();
          };
        })(this),
        'core:print-thread': (function(_this) {
          return function() {
            return _this._onPrintThread();
          };
        })(this),
        'core:messages-page-up': (function(_this) {
          return function() {
            return _this._onScrollByPage(-1);
          };
        })(this),
        'core:messages-page-down': (function(_this) {
          return function() {
            return _this._onScrollByPage(1);
          };
        })(this)
      };
      if (this.state.canCollapse) {
        handlers['message-list:toggle-expanded'] = (function(_this) {
          return function() {
            return _this._onToggleAllMessagesExpanded();
          };
        })(this);
      }
      return handlers;
    };

    MessageList.prototype._getMessageContainer = function(clientId) {
      return this.refs["message-container-" + clientId];
    };

    MessageList.prototype._focusDraft = function(draftElement) {
      this._draftScrollInProgress = true;
      draftElement.focus();
      return this.refs.messageWrap.scrollTo(draftElement, {
        position: ScrollRegion.ScrollPosition.Top,
        settle: true,
        done: (function(_this) {
          return function() {
            return _this._draftScrollInProgress = false;
          };
        })(this)
      });
    };

    MessageList.prototype._onForward = function() {
      if (!this.state.currentThread) {
        return;
      }
      return Actions.composeForward({
        thread: this.state.currentThread
      });
    };

    MessageList.prototype.render = function() {
      var messageListClass, wrapClass;
      if (!this.state.currentThread) {
        return React.createElement("span", null);
      }
      wrapClass = classNames({
        "messages-wrap": true,
        "ready": !this.state.loading
      });
      messageListClass = classNames({
        "message-list": true,
        "height-fix": SearchableComponentStore.searchTerm !== null
      });
      return React.createElement(KeyCommandsRegion, {
        "globalHandlers": this._globalKeymapHandlers(),
        "globalMenuItems": this._globalMenuItems()
      }, React.createElement(FindInThread, {
        "ref": "findInThread"
      }), React.createElement("div", {
        "className": messageListClass,
        "id": "message-list"
      }, React.createElement(ScrollRegion, {
        "tabIndex": "-1",
        "className": wrapClass,
        "scrollbarTickProvider": SearchableComponentStore,
        "scrollTooltipComponent": MessageListScrollTooltip,
        "ref": "messageWrap"
      }, this._renderSubject(), React.createElement("div", {
        "className": "headers",
        "style": {
          position: 'relative'
        }
      }, React.createElement(InjectedComponentSet, {
        "className": "message-list-headers",
        "matching": {
          role: "MessageListHeaders"
        },
        "exposedProps": {
          thread: this.state.currentThread
        },
        "direction": "column"
      })), this._messageElements()), React.createElement(Spinner, {
        "visible": this.state.loading
      })));
    };

    MessageList.prototype._renderSubject = function() {
      var subject;
      subject = this.state.currentThread.subject;
      if (!subject || subject.length === 0) {
        subject = "(No Subject)";
      }
      return React.createElement("div", {
        "className": "message-subject-wrap"
      }, React.createElement(MailImportantIcon, {
        "thread": this.state.currentThread
      }), React.createElement("div", {
        "style": {
          flex: 1
        }
      }, React.createElement("span", {
        "className": "message-subject"
      }, subject), React.createElement(MailLabelSet, {
        "removable": true,
        "thread": this.state.currentThread,
        "includeCurrentCategories": true
      })), this._renderIcons());
    };

    MessageList.prototype._renderIcons = function() {
      return React.createElement("div", {
        "className": "message-icons-wrap"
      }, this._renderExpandToggle(), React.createElement("div", {
        "onClick": this._onPrintThread
      }, React.createElement(RetinaImg, {
        "name": "print.png",
        "title": "Print Thread",
        "mode": RetinaImg.Mode.ContentIsMask
      })));
    };

    MessageList.prototype._renderExpandToggle = function() {
      if (!this.state.canCollapse) {
        return React.createElement("span", null);
      }
      if (this.state.hasCollapsedItems) {
        return React.createElement("div", {
          "onClick": this._onToggleAllMessagesExpanded
        }, React.createElement(RetinaImg, {
          "name": "expand.png",
          "title": "Expand All",
          "mode": RetinaImg.Mode.ContentIsMask
        }));
      } else {
        return React.createElement("div", {
          "onClick": this._onToggleAllMessagesExpanded
        }, React.createElement(RetinaImg, {
          "name": "collapse.png",
          "title": "Collapse All",
          "mode": RetinaImg.Mode.ContentIsMask
        }));
      }
    };

    MessageList.prototype._renderReplyArea = function() {
      return React.createElement("div", {
        "className": "footer-reply-area-wrap",
        "onClick": this._onClickReplyArea,
        "key": 'reply-area'
      }, React.createElement("div", {
        "className": "footer-reply-area"
      }, React.createElement(RetinaImg, {
        "name": "" + (this._replyType()) + "-footer.png",
        "mode": RetinaImg.Mode.ContentIsMask
      }), React.createElement("span", {
        "className": "reply-text"
      }, "Write a reply\u2026")));
    };

    MessageList.prototype._lastMessage = function() {
      var _ref2;
      return _.last(_.filter((_ref2 = this.state.messages) != null ? _ref2 : [], function(m) {
        return !m.draft;
      }));
    };

    MessageList.prototype._replyType = function() {
      var defaultReplyType, lastMessage;
      defaultReplyType = NylasEnv.config.get('core.sending.defaultReplyType');
      lastMessage = this._lastMessage();
      if (!lastMessage) {
        return 'reply';
      }
      if (lastMessage.canReplyAll()) {
        if (defaultReplyType === 'reply-all') {
          return 'reply-all';
        } else {
          return 'reply';
        }
      } else {
        return 'reply';
      }
    };

    MessageList.prototype._onToggleAllMessagesExpanded = function() {
      return Actions.toggleAllMessagesExpanded();
    };

    MessageList.prototype._onPrintThread = function() {
      var node;
      node = ReactDOM.findDOMNode(this);
      return Actions.printThread(this.state.currentThread, node.innerHTML);
    };

    MessageList.prototype._onClickReplyArea = function() {
      if (!this.state.currentThread) {
        return;
      }
      return Actions.composeReply({
        thread: this.state.currentThread,
        message: this._lastMessage(),
        type: this._replyType(),
        behavior: 'prefer-existing-if-pristine'
      });
    };

    MessageList.prototype._messageElements = function() {
      var elements, hasReplyArea, messages, _ref2;
      elements = [];
      hasReplyArea = !((_ref2 = _.last(this.state.messages)) != null ? _ref2.draft : void 0);
      messages = this._messagesWithMinification(this.state.messages);
      messages.forEach((function(_this) {
        return function(message, idx) {
          var collapsed, isBeforeReplyArea, isLastMsg;
          if (message.type === "minifiedBundle") {
            elements.push(_this._renderMinifiedBundle(message));
            return;
          }
          collapsed = !_this.state.messagesExpandedState[message.id];
          isLastMsg = messages.length - 1 === idx;
          isBeforeReplyArea = isLastMsg && hasReplyArea;
          return elements.push(React.createElement(MessageItemContainer, {
            "key": message.clientId,
            "ref": "message-container-" + message.clientId,
            "thread": _this.state.currentThread,
            "message": message,
            "collapsed": collapsed,
            "isLastMsg": isLastMsg,
            "isBeforeReplyArea": isBeforeReplyArea,
            "scrollTo": _this._scrollTo
          }));
        };
      })(this));
      if (hasReplyArea) {
        elements.push(this._renderReplyArea());
      }
      return elements;
    };

    MessageList.prototype._renderMinifiedBundle = function(bundle) {
      var BUNDLE_HEIGHT, h, lines;
      BUNDLE_HEIGHT = 36;
      lines = bundle.messages.slice(0, 10);
      h = Math.round(BUNDLE_HEIGHT / lines.length);
      return React.createElement("div", {
        "className": "minified-bundle",
        "onClick": ((function(_this) {
          return function() {
            return _this.setState({
              minified: false
            });
          };
        })(this)),
        "key": Utils.generateTempId()
      }, React.createElement("div", {
        "className": "num-messages"
      }, bundle.messages.length, " older messages"), React.createElement("div", {
        "className": "msg-lines",
        "style": {
          height: h * lines.length
        }
      }, lines.map(function(msg, i) {
        return React.createElement("div", {
          "key": msg.id,
          "style": {
            height: h * 2,
            top: -h * i
          },
          "className": "msg-line"
        });
      })));
    };

    MessageList.prototype._messagesWithMinification = function(messages) {
      var consecutiveCollapsed, indexOffset, minified, minifyRanges, range, start, _i, _len;
      if (messages == null) {
        messages = [];
      }
      if (!this.state.minified) {
        return messages;
      }
      messages = _.clone(messages);
      minifyRanges = [];
      consecutiveCollapsed = 0;
      messages.forEach((function(_this) {
        return function(message, idx) {
          var expandState, minifyOffset;
          if (idx === 0) {
            return;
          }
          expandState = _this.state.messagesExpandedState[message.id];
          if (!expandState) {
            return consecutiveCollapsed += 1;
          } else {
            if (expandState === "default") {
              minifyOffset = 1;
            } else {
              minifyOffset = 0;
            }
            if (consecutiveCollapsed >= _this.MINIFY_THRESHOLD + minifyOffset) {
              minifyRanges.push({
                start: idx - consecutiveCollapsed,
                length: consecutiveCollapsed - minifyOffset
              });
            }
            return consecutiveCollapsed = 0;
          }
        };
      })(this));
      indexOffset = 0;
      for (_i = 0, _len = minifyRanges.length; _i < _len; _i++) {
        range = minifyRanges[_i];
        start = range.start - indexOffset;
        minified = {
          type: "minifiedBundle",
          messages: messages.slice(start, start + range.length)
        };
        messages.splice(start, range.length, minified);
        indexOffset += range.length - 1;
      }
      return messages;
    };

    MessageList.prototype._scrollTo = function(_arg) {
      var clientId, messageElement, pos, position, rect, _ref2;
      _ref2 = _arg != null ? _arg : {}, clientId = _ref2.clientId, rect = _ref2.rect, position = _ref2.position;
      if (this._draftScrollInProgress) {
        return;
      }
      if (clientId) {
        messageElement = this._getMessageContainer(clientId);
        if (!messageElement) {
          return;
        }
        pos = position != null ? position : ScrollRegion.ScrollPosition.Visible;
        return this.refs.messageWrap.scrollTo(messageElement, {
          position: pos
        });
      } else if (rect) {
        return this.refs.messageWrap.scrollToRect(rect, {
          position: ScrollRegion.ScrollPosition.CenterIfInvisible
        });
      } else {
        throw new Error("onChildScrollRequest: expected clientId or rect");
      }
    };

    MessageList.prototype._onScrollByPage = function(direction) {
      var height;
      height = ReactDOM.findDOMNode(this.refs.messageWrap).clientHeight;
      return this.refs.messageWrap.scrollTop += height * direction;
    };

    MessageList.prototype._onChange = function() {
      var newState, _ref2, _ref3;
      newState = this._getStateFromStores();
      if (((_ref2 = this.state.currentThread) != null ? _ref2.id : void 0) !== ((_ref3 = newState.currentThread) != null ? _ref3.id : void 0)) {
        newState.minified = true;
      }
      return this.setState(newState);
    };

    MessageList.prototype._getStateFromStores = function() {
      var _ref2;
      return {
        messages: (_ref2 = MessageStore.items()) != null ? _ref2 : [],
        messagesExpandedState: MessageStore.itemsExpandedState(),
        canCollapse: MessageStore.items().length > 1,
        hasCollapsedItems: MessageStore.hasCollapsedItems(),
        currentThread: MessageStore.thread(),
        loading: MessageStore.itemsLoading()
      };
    };

    return MessageList;

  })(React.Component);

  module.exports = SearchableComponentMaker.extend(MessageList);

}).call(this);
