(function() {
  var DateUtils, MessageTimestamp, React, Utils, moment, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  moment = require('moment-timezone');

  React = require('react');

  _ref = require('nylas-exports'), DateUtils = _ref.DateUtils, Utils = _ref.Utils;

  MessageTimestamp = (function(_super) {
    __extends(MessageTimestamp, _super);

    function MessageTimestamp() {
      this._formattedDate = __bind(this._formattedDate, this);
      this.render = __bind(this.render, this);
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      return MessageTimestamp.__super__.constructor.apply(this, arguments);
    }

    MessageTimestamp.displayName = 'MessageTimestamp';

    MessageTimestamp.propTypes = {
      date: React.PropTypes.object.isRequired,
      className: React.PropTypes.string,
      isDetailed: React.PropTypes.bool,
      onClick: React.PropTypes.func
    };

    MessageTimestamp.prototype.shouldComponentUpdate = function(nextProps, nextState) {
      return +nextProps.date !== +this.props.date || nextProps.isDetailed !== this.props.isDetailed;
    };

    MessageTimestamp.prototype.render = function() {
      var formattedDate, msgDate, nowDate;
      msgDate = moment.tz(this.props.date, Utils.timeZone);
      nowDate = this._today();
      formattedDate = this._formattedDate(msgDate, nowDate, this.props.isDetailed);
      return React.createElement("div", {
        "className": this.props.className,
        "title": Utils.fullTimeString(this.props.date),
        "onClick": this.props.onClick
      }, formattedDate);
    };

    MessageTimestamp.prototype._formattedDate = function(msgDate, now, isDetailed) {
      var diff, isSameDay, monthAndDay, timeAgo, timeFormat;
      timeFormat = DateUtils.getTimeFormat({
        upperCase: true
      });
      if (isDetailed) {
        return msgDate.format("MMMM D, YYYY [at] " + timeFormat);
      } else {
        diff = now.diff(msgDate, 'days', true);
        isSameDay = now.isSame(msgDate, 'days');
        if (diff < 1 && isSameDay) {
          return msgDate.format(timeFormat);
        }
        if (diff < 1.5 && !isSameDay) {
          timeAgo = msgDate.from(now);
          monthAndDay = msgDate.format(timeFormat);
          return monthAndDay + " (" + timeAgo + ")";
        }
        if (diff >= 1.5 && diff < 365) {
          return msgDate.format("MMM D");
        }
        if (diff >= 365) {
          return msgDate.format("MMM D, YYYY");
        }
      }
    };

    MessageTimestamp.prototype._today = function() {
      return moment.tz(Utils.timeZone);
    };

    return MessageTimestamp;

  })(React.Component);

  module.exports = MessageTimestamp;

}).call(this);
