(function() {
  var FocusedContactStorePropsContainer, FocusedContactsStore, InjectedComponentSet, React, SidebarPluginContainer, SidebarPluginContainerInner, _,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require("react");

  FocusedContactsStore = require("nylas-exports").FocusedContactsStore;

  InjectedComponentSet = require("nylas-component-kit").InjectedComponentSet;

  FocusedContactStorePropsContainer = (function(_super) {
    __extends(FocusedContactStorePropsContainer, _super);

    FocusedContactStorePropsContainer.displayName = 'FocusedContactStorePropsContainer';

    function FocusedContactStorePropsContainer(props) {
      this.props = props;
      this._getStateFromStores = __bind(this._getStateFromStores, this);
      this._onChange = __bind(this._onChange, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = this._getStateFromStores();
    }

    FocusedContactStorePropsContainer.prototype.componentDidMount = function() {
      return this.unsubscribe = FocusedContactsStore.listen(this._onChange);
    };

    FocusedContactStorePropsContainer.prototype.componentWillUnmount = function() {
      return this.unsubscribe();
    };

    FocusedContactStorePropsContainer.prototype.render = function() {
      var classname, inner;
      classname = "sidebar-section";
      if (this.state.focusedContact) {
        classname += " visible";
        inner = React.cloneElement(this.props.children, this.state);
      }
      return React.createElement("div", {
        "className": classname
      }, inner);
    };

    FocusedContactStorePropsContainer.prototype._onChange = function() {
      return this.setState(this._getStateFromStores());
    };

    FocusedContactStorePropsContainer.prototype._getStateFromStores = function() {
      return {
        sortedContacts: FocusedContactsStore.sortedContacts(),
        focusedContact: FocusedContactsStore.focusedContact(),
        focusedContactThreads: FocusedContactsStore.focusedContactThreads()
      };
    };

    return FocusedContactStorePropsContainer;

  })(React.Component);

  SidebarPluginContainer = (function(_super) {
    __extends(SidebarPluginContainer, _super);

    SidebarPluginContainer.displayName = 'SidebarPluginContainer';

    SidebarPluginContainer.containerStyles = {
      order: 1,
      flexShrink: 0,
      minWidth: 200,
      maxWidth: 300
    };

    function SidebarPluginContainer(props) {
      this.props = props;
    }

    SidebarPluginContainer.prototype.render = function() {
      return React.createElement(FocusedContactStorePropsContainer, null, React.createElement(SidebarPluginContainerInner, null));
    };

    return SidebarPluginContainer;

  })(React.Component);

  SidebarPluginContainerInner = (function(_super) {
    __extends(SidebarPluginContainerInner, _super);

    function SidebarPluginContainerInner(props) {
      this.props = props;
    }

    SidebarPluginContainerInner.prototype.render = function() {
      return React.createElement(InjectedComponentSet, {
        "className": "sidebar-contact-card",
        "key": this.props.focusedContact.email,
        "matching": {
          role: "MessageListSidebar:ContactCard"
        },
        "direction": "column",
        "exposedProps": {
          contact: this.props.focusedContact,
          contactThreads: this.props.focusedContactThreads
        }
      });
    };

    return SidebarPluginContainerInner;

  })(React.Component);

  module.exports = SidebarPluginContainer;

}).call(this);
