(function() {
  var AccountStore, Actions, DOMUtils, FocusedPerspectiveStore, React, RetinaImg, TaskFactory, ThreadArchiveButton, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  RetinaImg = require('nylas-component-kit').RetinaImg;

  _ref = require('nylas-exports'), Actions = _ref.Actions, React = _ref.React, TaskFactory = _ref.TaskFactory, DOMUtils = _ref.DOMUtils, AccountStore = _ref.AccountStore, FocusedPerspectiveStore = _ref.FocusedPerspectiveStore;

  ThreadArchiveButton = (function(_super) {
    __extends(ThreadArchiveButton, _super);

    function ThreadArchiveButton() {
      this._onArchive = __bind(this._onArchive, this);
      this.render = __bind(this.render, this);
      return ThreadArchiveButton.__super__.constructor.apply(this, arguments);
    }

    ThreadArchiveButton.displayName = "ThreadArchiveButton";

    ThreadArchiveButton.containerRequired = false;

    ThreadArchiveButton.propTypes = {
      thread: React.PropTypes.object.isRequired
    };

    ThreadArchiveButton.prototype.render = function() {
      var canArchiveThreads;
      canArchiveThreads = FocusedPerspectiveStore.current().canArchiveThreads([this.props.thread]);
      if (!canArchiveThreads) {
        return React.createElement("span", null);
      }
      return React.createElement("button", {
        "className": "btn btn-toolbar btn-archive",
        "style": {
          order: -107
        },
        "title": "Archive",
        "onClick": this._onArchive
      }, React.createElement(RetinaImg, {
        "name": "toolbar-archive.png",
        "mode": RetinaImg.Mode.ContentIsMask
      }));
    };

    ThreadArchiveButton.prototype._onArchive = function(e) {
      var tasks;
      if (!DOMUtils.nodeIsVisible(e.currentTarget)) {
        return;
      }
      tasks = TaskFactory.tasksForArchiving({
        threads: [this.props.thread]
      });
      Actions.queueTasks(tasks);
      Actions.popSheet();
      return e.stopPropagation();
    };

    return ThreadArchiveButton;

  })(React.Component);

  module.exports = ThreadArchiveButton;

}).call(this);
