(function() {
  var Actions, ChangeStarredTask, React, RetinaImg, StarButton, Utils, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  _ref = require('nylas-exports'), Actions = _ref.Actions, Utils = _ref.Utils, ChangeStarredTask = _ref.ChangeStarredTask;

  RetinaImg = require('nylas-component-kit').RetinaImg;

  StarButton = (function(_super) {
    __extends(StarButton, _super);

    function StarButton() {
      this._onStarToggle = __bind(this._onStarToggle, this);
      this.render = __bind(this.render, this);
      return StarButton.__super__.constructor.apply(this, arguments);
    }

    StarButton.displayName = "StarButton";

    StarButton.containerRequired = false;

    StarButton.propTypes = {
      thread: React.PropTypes.object
    };

    StarButton.prototype.render = function() {
      var selected;
      selected = (this.props.thread != null) && this.props.thread.starred;
      return React.createElement("button", {
        "className": "btn btn-toolbar",
        "style": {
          order: -104
        },
        "title": (selected ? "Remove star" : "Add star"),
        "onClick": this._onStarToggle
      }, React.createElement(RetinaImg, {
        "name": "toolbar-star.png",
        "mode": RetinaImg.Mode.ContentIsMask,
        "selected": selected
      }));
    };

    StarButton.prototype._onStarToggle = function(e) {
      var task;
      task = new ChangeStarredTask({
        thread: this.props.thread,
        starred: !this.props.thread.starred
      });
      Actions.queueTask(task);
      return e.stopPropagation();
    };

    return StarButton;

  })(React.Component);

  module.exports = StarButton;

}).call(this);
