(function() {
  var AccountStore, Actions, DOMUtils, FocusedPerspectiveStore, React, RetinaImg, TaskFactory, ThreadTrashButton, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  _ref = require('nylas-exports'), Actions = _ref.Actions, DOMUtils = _ref.DOMUtils, TaskFactory = _ref.TaskFactory, AccountStore = _ref.AccountStore, FocusedPerspectiveStore = _ref.FocusedPerspectiveStore;

  RetinaImg = require('nylas-component-kit').RetinaImg;

  ThreadTrashButton = (function(_super) {
    __extends(ThreadTrashButton, _super);

    function ThreadTrashButton() {
      this._onRemove = __bind(this._onRemove, this);
      this.render = __bind(this.render, this);
      return ThreadTrashButton.__super__.constructor.apply(this, arguments);
    }

    ThreadTrashButton.displayName = "ThreadTrashButton";

    ThreadTrashButton.containerRequired = false;

    ThreadTrashButton.propTypes = {
      thread: React.PropTypes.object.isRequired
    };

    ThreadTrashButton.prototype.render = function() {
      var allowed;
      allowed = FocusedPerspectiveStore.current().canMoveThreadsTo([this.props.thread], 'trash');
      if (!allowed) {
        return React.createElement("span", null);
      }
      return React.createElement("button", {
        "className": "btn btn-toolbar",
        "style": {
          order: -106
        },
        "title": "Move to Trash",
        "onClick": this._onRemove
      }, React.createElement(RetinaImg, {
        "name": "toolbar-trash.png",
        "mode": RetinaImg.Mode.ContentIsMask
      }));
    };

    ThreadTrashButton.prototype._onRemove = function(e) {
      var tasks;
      if (!DOMUtils.nodeIsVisible(e.currentTarget)) {
        return;
      }
      tasks = TaskFactory.tasksForMovingToTrash({
        threads: [this.props.thread]
      });
      Actions.queueTasks(tasks);
      Actions.popSheet();
      return e.stopPropagation();
    };

    return ThreadTrashButton;

  })(React.Component);

  module.exports = ThreadTrashButton;

}).call(this);
