(function() {
  var Actions, ComponentRegistry, ModeToggle, React, RetinaImg, WorkspaceStore, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require("nylas-exports"), ComponentRegistry = _ref.ComponentRegistry, WorkspaceStore = _ref.WorkspaceStore, Actions = _ref.Actions;

  RetinaImg = require('nylas-component-kit').RetinaImg;

  React = require("react");

  _ = require("underscore");

  ModeToggle = (function(_super) {
    __extends(ModeToggle, _super);

    ModeToggle.displayName = 'ModeToggle';

    function ModeToggle(props) {
      this.props = props;
      this._onToggleMode = __bind(this._onToggleMode, this);
      this._getStateFromStores = __bind(this._getStateFromStores, this);
      this._onStateChanged = __bind(this._onStateChanged, this);
      this.render = __bind(this.render, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.column = WorkspaceStore.Location.MessageListSidebar;
      this.state = this._getStateFromStores();
    }

    ModeToggle.prototype.componentDidMount = function() {
      this._unsubscriber = WorkspaceStore.listen(this._onStateChanged);
      return this._mounted = true;
    };

    ModeToggle.prototype.componentWillUnmount = function() {
      this._mounted = false;
      return typeof this._unsubscriber === "function" ? this._unsubscriber() : void 0;
    };

    ModeToggle.prototype.render = function() {
      return React.createElement("button", {
        "className": "btn btn-toolbar mode-toggle mode-" + this.state.hidden,
        "style": {
          order: 500
        },
        "title": (this.state.hidden ? "Show sidebar" : "Hide sidebar"),
        "onClick": this._onToggleMode
      }, React.createElement(RetinaImg, {
        "name": "toolbar-person-sidebar.png",
        "mode": RetinaImg.Mode.ContentIsMask
      }));
    };

    ModeToggle.prototype._onStateChanged = function() {
      if (!this._mounted) {
        return;
      }
      return this.setState(this._getStateFromStores());
    };

    ModeToggle.prototype._getStateFromStores = function() {
      return {
        hidden: WorkspaceStore.isLocationHidden(this.column)
      };
    };

    ModeToggle.prototype._onToggleMode = function() {
      return Actions.toggleWorkspaceLocationHidden(this.column);
    };

    return ModeToggle;

  })(React.Component);

  module.exports = ModeToggle;

}).call(this);
