(function() {
  var Actions, LaunchServices, NOTIF_ACTION_NO, NOTIF_ACTION_YES, NOTIF_SETTINGS_KEY, _ref;

  _ref = require('nylas-exports'), Actions = _ref.Actions, LaunchServices = _ref.LaunchServices;

  NOTIF_ACTION_YES = 'mailto:set-default-yes';

  NOTIF_ACTION_NO = 'mailto:set-default-no';

  NOTIF_SETTINGS_KEY = 'nylas.mailto.prompted-about-default';

  module.exports = {
    activate: function(state) {
      this.state = state;
      this.services = new LaunchServices();
      if (!this.services.available()) {
        return;
      }
      if (NylasEnv.config.get(NOTIF_SETTINGS_KEY) === true) {
        return;
      }
      return this.services.isRegisteredForURLScheme('mailto', (function(_this) {
        return function(registered) {
          if (!registered) {
            _this._unlisten = Actions.notificationActionTaken.listen(_this._onNotificationActionTaken, _this);
            return Actions.postNotification({
              type: 'info',
              sticky: true,
              message: "Thanks for trying out N1! Would you like to make it your default mail client?",
              icon: 'fa-inbox',
              actions: [
                {
                  label: 'Not Now',
                  dismisses: true,
                  id: NOTIF_ACTION_NO
                }, {
                  label: 'Yes',
                  dismisses: true,
                  "default": true,
                  id: NOTIF_ACTION_YES
                }
              ]
            });
          }
        };
      })(this));
    },
    deactivate: function() {
      return typeof this._unlisten === "function" ? this._unlisten() : void 0;
    },
    serialize: function() {
      return this.state;
    },
    _onNotificationActionTaken: function(_arg) {
      var action, notification;
      notification = _arg.notification, action = _arg.action;
      if (action.id === NOTIF_ACTION_YES) {
        this.services.registerForURLScheme('mailto', function(err) {
          if (err) {
            return console.log(err);
          }
        });
      }
      if (action.id === NOTIF_ACTION_NO) {
        return NylasEnv.config.set(NOTIF_SETTINGS_KEY, true);
      }
    }
  };

}).call(this);
