(function() {
  var NotificationStore, NotificationsHeader, NotificationsItem, React,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  NotificationStore = require('../notifications-store');

  NotificationsItem = require('./notifications-item');

  NotificationsHeader = (function(_super) {
    __extends(NotificationsHeader, _super);

    NotificationsHeader.displayName = "NotificationsHeader";

    NotificationsHeader.containerRequired = false;

    function NotificationsHeader(props) {
      this.props = props;
      this._notificationComponents = __bind(this._notificationComponents, this);
      this.render = __bind(this.render, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this._onDataChanged = __bind(this._onDataChanged, this);
      this._getStateFromStores = __bind(this._getStateFromStores, this);
      this.state = this._getStateFromStores();
    }

    NotificationsHeader.prototype._getStateFromStores = function() {
      return {
        items: NotificationStore.stickyNotifications()
      };
    };

    NotificationsHeader.prototype._onDataChanged = function() {
      return this.setState(this._getStateFromStores());
    };

    NotificationsHeader.prototype.componentDidMount = function() {
      this._unlistener = NotificationStore.listen(this._onDataChanged, this);
      return this;
    };

    NotificationsHeader.prototype.componentWillUnmount = function() {
      if (this._unlistener) {
        this._unlistener();
      }
      return this;
    };

    NotificationsHeader.prototype.render = function() {
      return React.createElement("div", {
        "className": "notifications-sticky"
      }, this._notificationComponents());
    };

    NotificationsHeader.prototype._notificationComponents = function() {
      return this.state.items.map(function(notif) {
        return React.createElement(NotificationsItem, {
          "notification": notif,
          "key": notif.message
        });
      });
    };

    return NotificationsHeader;

  })(React.Component);

  module.exports = NotificationsHeader;

}).call(this);
