(function() {
  var Actions, NotificationsItem, React,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  Actions = require('nylas-exports').Actions;

  NotificationsItem = (function(_super) {
    __extends(NotificationsItem, _super);

    function NotificationsItem() {
      this._fireItemAction = __bind(this._fireItemAction, this);
      this.render = __bind(this.render, this);
      return NotificationsItem.__super__.constructor.apply(this, arguments);
    }

    NotificationsItem.displayName = "NotificationsItem";

    NotificationsItem.prototype.render = function() {
      var actionComponents, actionDefault, iconClass, notif, _ref;
      notif = this.props.notification;
      iconClass = notif.icon ? "fa " + notif.icon : "";
      actionDefault = null;
      actionComponents = (_ref = notif.actions) != null ? _ref.map((function(_this) {
        return function(action) {
          var actionClick, classname;
          classname = "action ";
          if (action["default"]) {
            actionDefault = action;
            classname += "default";
          }
          actionClick = function(event) {
            _this._fireItemAction(notif, action);
            event.stopPropagation();
            return event.preventDefault();
          };
          return React.createElement("a", {
            "className": classname,
            "key": action.label,
            "onClick": actionClick
          }, action.label);
        };
      })(this)) : void 0;
      if (actionDefault) {
        return React.createElement("div", {
          "className": "notifications-sticky-item notification-" + notif.type + " has-default-action",
          "onClick": ((function(_this) {
            return function() {
              return _this._fireItemAction(notif, actionDefault);
            };
          })(this))
        }, React.createElement("i", {
          "className": iconClass
        }), React.createElement("div", {
          "className": "message"
        }, notif.message), actionComponents);
      } else {
        return React.createElement("div", {
          "className": "notifications-sticky-item notification-" + notif.type
        }, React.createElement("i", {
          "className": iconClass
        }), React.createElement("div", {
          "className": "message"
        }, notif.message), actionComponents);
      }
    };

    NotificationsItem.prototype._fireItemAction = function(notification, action) {
      return Actions.notificationActionTaken({
        notification: notification,
        action: action
      });
    };

    return NotificationsItem;

  })(React.Component);

  module.exports = NotificationsItem;

}).call(this);
