(function() {
  var AccountStore, Actions, InitialSyncActivity, NylasSyncStatusStore, React, classNames, _, _ref, _str,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  _str = require('underscore.string');

  classNames = require('classnames');

  React = require('react');

  _ref = require('nylas-exports'), Actions = _ref.Actions, AccountStore = _ref.AccountStore, NylasSyncStatusStore = _ref.NylasSyncStatusStore;

  InitialSyncActivity = (function(_super) {
    __extends(InitialSyncActivity, _super);

    InitialSyncActivity.displayName = 'InitialSyncActivity';

    function InitialSyncActivity(props) {
      this.props = props;
      this._onTryAgain = __bind(this._onTryAgain, this);
      this._hideExpandedState = __bind(this._hideExpandedState, this);
      this.render = __bind(this.render, this);
      this._getStateFromStores = __bind(this._getStateFromStores, this);
      this._onDataChanged = __bind(this._onDataChanged, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = this._getStateFromStores();
    }

    InitialSyncActivity.prototype.componentDidMount = function() {
      return this._usub = NylasSyncStatusStore.listen(this._onDataChanged);
    };

    InitialSyncActivity.prototype.componentWillUnmount = function() {
      return typeof this._usub === "function" ? this._usub() : void 0;
    };

    InitialSyncActivity.prototype._onDataChanged = function() {
      return this.setState(this._getStateFromStores());
    };

    InitialSyncActivity.prototype._getStateFromStores = function() {
      return {
        sync: NylasSyncStatusStore.state()
      };
    };

    InitialSyncActivity.prototype.render = function() {
      var acctId, classSet, count, fetched, incomplete, modelName, modelState, state, totalProgress, _i, _len, _ref1, _ref2;
      count = 0;
      fetched = 0;
      totalProgress = 0;
      incomplete = 0;
      _ref1 = this.state.sync;
      for (acctId in _ref1) {
        state = _ref1[acctId];
        _ref2 = NylasSyncStatusStore.ModelsForSync;
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          modelName = _ref2[_i];
          modelState = state[modelName];
          if (!modelState) {
            continue;
          }
          if (!modelState.complete) {
            incomplete += 1;
          }
          if (modelState.count) {
            count += modelState.count / 1;
            fetched += modelState.fetched / 1;
          }
        }
      }
      if (count > 0) {
        totalProgress = (fetched / count) * 100;
      }
      classSet = classNames({
        'item': true,
        'expanded-sync': this.state.expandedSync
      });
      if (incomplete === 0) {
        return false;
      } else {
        return React.createElement("div", {
          "className": classSet,
          "key": "initial-sync",
          "onClick": ((function(_this) {
            return function() {
              return _this.setState({
                expandedSync: !_this.state.expandedSync
              });
            };
          })(this))
        }, this._renderProgressBar(totalProgress), React.createElement("div", {
          "className": "inner"
        }, "Syncing your mailbox\u2026"), this._expandedSyncState());
      }
    };

    InitialSyncActivity.prototype._expandedSyncState = function() {
      var account, accounts, acctId, modelStates, state, _ref1;
      accounts = [];
      _ref1 = this.state.sync;
      for (acctId in _ref1) {
        state = _ref1[acctId];
        account = _.findWhere(AccountStore.accounts(), {
          id: acctId
        });
        if (!account) {
          continue;
        }
        modelStates = _.map(state, (function(_this) {
          return function(modelState, model) {
            return _this._renderModelProgress(model, modelState, 100);
          };
        })(this));
        accounts.push(React.createElement("div", {
          "className": "account inner",
          "key": acctId
        }, React.createElement("h2", null, account.emailAddress), modelStates));
      }
      return React.createElement("div", {
        "className": "account-detail-area"
      }, accounts, React.createElement("a", {
        "className": "close-expanded",
        "onClick": this._hideExpandedState
      }, "Hide"));
    };

    InitialSyncActivity.prototype._hideExpandedState = function(event) {
      event.stopPropagation();
      event.preventDefault();
      this.setState({
        expandedSync: false
      });
    };

    InitialSyncActivity.prototype._renderModelProgress = function(model, modelState) {
      var percent, status;
      if (modelState.error) {
        status = "error";
      } else if (modelState.complete) {
        status = "complete";
      } else {
        status = "busy";
      }
      percent = (+modelState.fetched / +modelState.count) * 100;
      return React.createElement("div", {
        "className": "model-progress " + status,
        "key": model
      }, React.createElement("h3", null, _str.titleize(model), ":"), this._renderProgressBar(percent), React.createElement("div", {
        "className": "amount"
      }, _str.numberFormat(modelState.fetched), " \x2F ", _str.numberFormat(modelState.count)), React.createElement("div", {
        "className": "error-text"
      }, modelState.error));
    };

    InitialSyncActivity.prototype._renderProgressBar = function(percent) {
      return React.createElement("div", {
        "className": "progress-track"
      }, React.createElement("div", {
        "className": "progress",
        "style": {
          width: "" + percent + "%"
        }
      }));
    };

    InitialSyncActivity.prototype._onTryAgain = function() {
      return Actions.retrySync();
    };

    return InitialSyncActivity;

  })(React.Component);

  module.exports = InitialSyncActivity;

}).call(this);
