(function() {
  var Actions, React, RetinaImg, StreamingSyncActivity, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), Actions = _ref.Actions, React = _ref.React;

  RetinaImg = require('nylas-component-kit').RetinaImg;

  StreamingSyncActivity = (function(_super) {
    __extends(StreamingSyncActivity, _super);

    function StreamingSyncActivity(props) {
      this.props = props;
      this._onDeltaReceived = __bind(this._onDeltaReceived, this);
      this.render = __bind(this.render, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this._timeoutId = null;
      this.state = {
        receivingDelta: false
      };
    }

    StreamingSyncActivity.prototype.componentDidMount = function() {
      return this._unlistener = Actions.longPollReceivedRawDeltasPing.listen(this._onDeltaReceived);
    };

    StreamingSyncActivity.prototype.componentWillUnmount = function() {
      if (this._unlistener) {
        this._unlistener();
      }
      if (this._timeoutId) {
        return clearTimeout(this._timeoutId);
      }
    };

    StreamingSyncActivity.prototype.render = function() {
      if (!this.state.receivingDelta) {
        return false;
      }
      return React.createElement("div", {
        "className": "item",
        "key": "delta-sync-item"
      }, React.createElement("div", {
        "style": {
          padding: "9px 9px 0 12px",
          float: "left"
        }
      }, React.createElement(RetinaImg, {
        "name": "sending-spinner.gif",
        "width": 18.,
        "mode": RetinaImg.Mode.ContentPreserve
      })), React.createElement("div", {
        "className": "inner"
      }, "Syncing your mailbox\u2026"));
    };

    StreamingSyncActivity.prototype._onDeltaReceived = function(countDeltas) {
      var tooSmallForNotification;
      tooSmallForNotification = countDeltas <= 10;
      if (tooSmallForNotification) {
        return;
      }
      if (this._timeoutId) {
        clearTimeout(this._timeoutId);
      }
      this._timeoutId = setTimeout(((function(_this) {
        return function() {
          delete _this._timeoutId;
          return _this.setState({
            receivingDelta: false
          });
        };
      })(this)), 20000);
      return this.setState({
        receivingDelta: true
      });
    };

    return StreamingSyncActivity;

  })(React.Component);

  module.exports = StreamingSyncActivity;

}).call(this);
