(function() {
  var AccountStore, AppearanceModeOption, ConfigPropContainer, EdgehillAPI, Flexbox, InitialPreferencesOptions, InitialPreferencesPage, NewsletterSignup, OnboardingActions, React, RetinaImg, fs, path, _, _ref, _ref1,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  path = require('path');

  fs = require('fs');

  _ = require('underscore');

  _ref = require('nylas-component-kit'), RetinaImg = _ref.RetinaImg, Flexbox = _ref.Flexbox, ConfigPropContainer = _ref.ConfigPropContainer, NewsletterSignup = _ref.NewsletterSignup;

  _ref1 = require('nylas-exports'), EdgehillAPI = _ref1.EdgehillAPI, AccountStore = _ref1.AccountStore;

  OnboardingActions = require('./onboarding-actions')["default"];

  AppearanceModeOption = (function(_super) {
    __extends(AppearanceModeOption, _super);

    function AppearanceModeOption() {
      this.render = __bind(this.render, this);
      return AppearanceModeOption.__super__.constructor.apply(this, arguments);
    }

    AppearanceModeOption.propTypes = {
      mode: React.PropTypes.string.isRequired,
      active: React.PropTypes.bool,
      onClick: React.PropTypes.func
    };

    AppearanceModeOption.prototype.render = function() {
      var classname, label;
      classname = "appearance-mode";
      if (this.props.active) {
        classname += " active";
      }
      label = {
        'list': 'Single Panel',
        'split': 'Two Panel'
      }[this.props.mode];
      return React.createElement("div", {
        "className": classname,
        "onClick": this.props.onClick
      }, React.createElement(RetinaImg, {
        "name": "appearance-mode-" + this.props.mode + ".png",
        "mode": RetinaImg.Mode.ContentIsMask
      }), React.createElement("div", null, label));
    };

    return AppearanceModeOption;

  })(React.Component);

  InitialPreferencesOptions = (function(_super) {
    __extends(InitialPreferencesOptions, _super);

    InitialPreferencesOptions.propTypes = {
      config: React.PropTypes.object
    };

    function InitialPreferencesOptions(props) {
      this.props = props;
      this.render = __bind(this.render, this);
      this._setConfigDefaultsForAccount = __bind(this._setConfigDefaultsForAccount, this);
      this._loadTemplates = __bind(this._loadTemplates, this);
      this.state = {
        templates: []
      };
      this._loadTemplates();
    }

    InitialPreferencesOptions.prototype._loadTemplates = function() {
      var templatesDir;
      templatesDir = path.join(NylasEnv.getLoadSettings().resourcePath, 'keymaps', 'templates');
      return fs.readdir(templatesDir, (function(_this) {
        return function(err, files) {
          var templates;
          if (!(files && files instanceof Array)) {
            return;
          }
          templates = files.filter(function(filename) {
            return path.extname(filename) === '.cson' || path.extname(filename) === '.json';
          });
          templates = templates.map(function(filename) {
            return path.parse(filename).name;
          });
          _this.setState({
            templates: templates
          });
          return _this._setConfigDefaultsForAccount(templates);
        };
      })(this));
    };

    InitialPreferencesOptions.prototype._setConfigDefaultsForAccount = function(templates) {
      var templateWithBasename;
      if (!this.props.account) {
        return;
      }
      templateWithBasename = (function(_this) {
        return function(name) {
          return _.find(templates, function(t) {
            return t.indexOf(name) === 0;
          });
        };
      })(this);
      if (this.props.account.provider === 'gmail') {
        this.props.config.set('core.workspace.mode', 'list');
        return this.props.config.set('core.keymapTemplate', templateWithBasename('Gmail'));
      } else if (this.props.account.provider === 'eas') {
        this.props.config.set('core.workspace.mode', 'split');
        return this.props.config.set('core.keymapTemplate', templateWithBasename('Outlook'));
      } else {
        this.props.config.set('core.workspace.mode', 'split');
        if (process.platform === 'darwin') {
          return this.props.config.set('core.keymapTemplate', templateWithBasename('Apple Mail'));
        } else {
          return this.props.config.set('core.keymapTemplate', templateWithBasename('Outlook'));
        }
      }
    };

    InitialPreferencesOptions.prototype.render = function() {
      if (!this.props.config) {
        return false;
      }
      return React.createElement("div", {
        "style": {
          display: 'flex',
          width: 600,
          marginBottom: 50,
          marginLeft: 150,
          marginRight: 150,
          textAlign: 'left'
        }
      }, React.createElement("div", {
        "style": {
          flex: 1
        }
      }, React.createElement("p", null, "Do you prefer a single panel layout (like Gmail)\nor a two panel layout?"), React.createElement(Flexbox, {
        "direction": "row",
        "style": {
          alignItems: "center"
        }
      }, ['list', 'split'].map((function(_this) {
        return function(mode) {
          return React.createElement(AppearanceModeOption, {
            "mode": mode,
            "key": mode,
            "active": _this.props.config.get('core.workspace.mode') === mode,
            "onClick": (function() {
              return _this.props.config.set('core.workspace.mode', mode);
            })
          });
        };
      })(this)))), React.createElement("div", {
        "key": "divider",
        "style": {
          marginLeft: 20,
          marginRight: 20,
          borderLeft: '1px solid #ccc'
        }
      }), React.createElement("div", {
        "style": {
          flex: 1
        }
      }, React.createElement("p", null, "We\'ve picked a set of keyboard shortcuts based on your email\naccount and platform. You can also pick another set:"), React.createElement("select", {
        "style": {
          margin: 0
        },
        "value": this.props.config.get('core.keymapTemplate'),
        "onChange": ((function(_this) {
          return function(event) {
            return _this.props.config.set('core.keymapTemplate', event.target.value);
          };
        })(this))
      }, this.state.templates.map((function(_this) {
        return function(template) {
          return React.createElement("option", {
            "key": template,
            "value": template
          }, template);
        };
      })(this))), React.createElement("div", {
        "style": {
          paddingTop: 20
        }
      }, React.createElement(NewsletterSignup, {
        "emailAddress": this.props.account.emailAddress,
        "name": this.props.account.name
      }))));
    };

    return InitialPreferencesOptions;

  })(React.Component);

  InitialPreferencesPage = (function(_super) {
    __extends(InitialPreferencesPage, _super);

    InitialPreferencesPage.displayName = "InitialPreferencesPage";

    function InitialPreferencesPage(props) {
      this.props = props;
      this._onFinished = __bind(this._onFinished, this);
      this.render = __bind(this.render, this);
      this._onAccountStoreChange = __bind(this._onAccountStoreChange, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = {
        account: AccountStore.accounts()[0]
      };
    }

    InitialPreferencesPage.prototype.componentDidMount = function() {
      return this._unlisten = AccountStore.listen(this._onAccountStoreChange);
    };

    InitialPreferencesPage.prototype.componentWillUnmount = function() {
      return typeof this._unlisten === "function" ? this._unlisten() : void 0;
    };

    InitialPreferencesPage.prototype._onAccountStoreChange = function() {
      return this.setState({
        account: AccountStore.accounts()[0]
      });
    };

    InitialPreferencesPage.prototype.render = function() {
      return React.createElement("div", {
        "className": "page opaque",
        "style": {
          width: 900,
          height: 620
        }
      }, React.createElement("h1", {
        "style": {
          paddingTop: 100
        }
      }, "Welcome to N1"), React.createElement("h4", {
        "style": {
          marginBottom: 70
        }
      }, "Let\'s set things up to your liking."), React.createElement(ConfigPropContainer, null, React.createElement(InitialPreferencesOptions, {
        "account": this.state.account
      })), React.createElement("button", {
        "className": "btn btn-large btn-get-started",
        "style": {
          marginBottom: 60
        },
        "onClick": this._onFinished
      }, "Looks Good!"));
    };

    InitialPreferencesPage.prototype._onFinished = function() {
      return require('electron').ipcRenderer.send('account-setup-successful');
    };

    return InitialPreferencesPage;

  })(React.Component);

  module.exports = InitialPreferencesPage;

}).call(this);
