(function() {
  var DatabaseStore, Message, ObservableListDataSource, QueryResultSet, QuerySubscription, Rx, ThreadListDataSource, _, _flatMapJoiningMessages, _observableForThreadMessages, _ref,
    __slice = [].slice,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Rx = require('rx-lite');

  _ref = require('nylas-exports'), ObservableListDataSource = _ref.ObservableListDataSource, DatabaseStore = _ref.DatabaseStore, Message = _ref.Message, QueryResultSet = _ref.QueryResultSet, QuerySubscription = _ref.QuerySubscription;

  _flatMapJoiningMessages = (function(_this) {
    return function($threadsResultSet) {
      var $messagesResultSets;
      $messagesResultSets = {};
      return $threadsResultSet.flatMapLatest(function(threadsResultSet) {
        var missingIds, promise;
        missingIds = threadsResultSet.ids().filter(function(id) {
          return !$messagesResultSets[id];
        });
        if (missingIds.length === 0) {
          promise = Promise.resolve([threadsResultSet, []]);
        } else {
          promise = DatabaseStore.findAll(Message, {
            threadId: missingIds
          }).then(function(messages) {
            return Promise.resolve([threadsResultSet, messages]);
          });
        }
        return Rx.Observable.fromPromise(promise);
      }).flatMapLatest(function(_arg) {
        var message, messagesForNewThreads, messagesGrouped, oldSets, sets, threadsResultSet, _i, _len, _name;
        threadsResultSet = _arg[0], messagesForNewThreads = _arg[1];
        messagesGrouped = {};
        for (_i = 0, _len = messagesForNewThreads.length; _i < _len; _i++) {
          message = messagesForNewThreads[_i];
          if (messagesGrouped[_name = message.threadId] == null) {
            messagesGrouped[_name] = [];
          }
          messagesGrouped[message.threadId].push(message);
        }
        oldSets = $messagesResultSets;
        $messagesResultSets = {};
        sets = threadsResultSet.ids().map(function(id) {
          $messagesResultSets[id] = oldSets[id] || _observableForThreadMessages(id, messagesGrouped[id]);
          return $messagesResultSets[id];
        });
        sets.unshift(Rx.Observable.from([threadsResultSet]));
        return Rx.Observable.combineLatest(sets);
      }).flatMapLatest(function(_arg) {
        var messagesResultSets, threadsResultSet, threadsWithMetadata;
        threadsResultSet = _arg[0], messagesResultSets = 2 <= _arg.length ? __slice.call(_arg, 1) : [];
        threadsWithMetadata = {};
        threadsResultSet.models().map(function(thread, idx) {
          var _ref1;
          thread = new thread.constructor(thread);
          thread.metadata = (_ref1 = messagesResultSets[idx]) != null ? _ref1.models() : void 0;
          return threadsWithMetadata[thread.id] = thread;
        });
        return Rx.Observable.from([QueryResultSet.setByApplyingModels(threadsResultSet, threadsWithMetadata)]);
      });
    };
  })(this);

  _observableForThreadMessages = function(id, initialModels) {
    var subscription;
    subscription = new QuerySubscription(DatabaseStore.findAll(Message, {
      threadId: id
    }), {
      emitResultSet: true,
      initialModels: initialModels
    });
    return Rx.Observable.fromNamedQuerySubscription('message-' + id, subscription);
  };

  ThreadListDataSource = (function(_super) {
    __extends(ThreadListDataSource, _super);

    function ThreadListDataSource(subscription) {
      var $resultSetObservable;
      $resultSetObservable = Rx.Observable.fromNamedQuerySubscription('thread-list', subscription);
      $resultSetObservable = _flatMapJoiningMessages($resultSetObservable);
      ThreadListDataSource.__super__.constructor.call(this, $resultSetObservable, subscription.replaceRange.bind(subscription));
    }

    return ThreadListDataSource;

  })(ObservableListDataSource);

  module.exports = ThreadListDataSource;

}).call(this);
