(function() {
  var AccountStore, Actions, ChangeStarredTask, DraftHelpers, React, Thread, ThreadListIcon, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  _ref = require('nylas-exports'), DraftHelpers = _ref.DraftHelpers, Actions = _ref.Actions, Thread = _ref.Thread, ChangeStarredTask = _ref.ChangeStarredTask, AccountStore = _ref.AccountStore;

  ThreadListIcon = (function(_super) {
    __extends(ThreadListIcon, _super);

    function ThreadListIcon() {
      this._onToggleStar = __bind(this._onToggleStar, this);
      this.render = __bind(this.render, this);
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      this._nonDraftMessages = __bind(this._nonDraftMessages, this);
      this._iconType = __bind(this._iconType, this);
      return ThreadListIcon.__super__.constructor.apply(this, arguments);
    }

    ThreadListIcon.displayName = 'ThreadListIcon';

    ThreadListIcon.propTypes = {
      thread: React.PropTypes.object
    };

    ThreadListIcon.prototype._iconType = function() {
      var last, msgs, _ref1;
      if (!this.props.thread) {
        return 'thread-icon-star-on-hover';
      }
      if (this.props.thread.starred) {
        return 'thread-icon-star';
      }
      if (this.props.thread.unread) {
        return 'thread-icon-unread thread-icon-star-on-hover';
      }
      msgs = this._nonDraftMessages();
      last = msgs[msgs.length - 1];
      if (msgs.length > 1 && ((_ref1 = last.from[0]) != null ? _ref1.isMe() : void 0)) {
        if (DraftHelpers.isForwardedMessage(last)) {
          return 'thread-icon-forwarded thread-icon-star-on-hover';
        } else {
          return 'thread-icon-replied thread-icon-star-on-hover';
        }
      }
      return 'thread-icon-none thread-icon-star-on-hover';
    };

    ThreadListIcon.prototype._nonDraftMessages = function() {
      var msgs;
      msgs = this.props.thread.metadata;
      if (!(msgs && msgs instanceof Array)) {
        return [];
      }
      msgs = _.filter(msgs, function(m) {
        return m.serverId && !m.draft;
      });
      return msgs;
    };

    ThreadListIcon.prototype.shouldComponentUpdate = function(nextProps) {
      if (nextProps.thread === this.props.thread) {
        return false;
      }
      return true;
    };

    ThreadListIcon.prototype.render = function() {
      return React.createElement("div", {
        "className": "thread-icon " + (this._iconType()),
        "title": "Star",
        "onClick": this._onToggleStar
      });
    };

    ThreadListIcon.prototype._onToggleStar = function(event) {
      var task;
      task = new ChangeStarredTask({
        thread: this.props.thread,
        starred: !this.props.thread.starred
      });
      Actions.queueTask(task);
      return event.stopPropagation();
    };

    return ThreadListIcon;

  })(React.Component);

  module.exports = ThreadListIcon;

}).call(this);
