(function() {
  var AccountStore, Actions, CategoryStore, FocusedPerspectiveStore, React, TaskFactory, ThreadArchiveQuickAction, ThreadTrashQuickAction, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  _ref = require('nylas-exports'), Actions = _ref.Actions, CategoryStore = _ref.CategoryStore, TaskFactory = _ref.TaskFactory, AccountStore = _ref.AccountStore, FocusedPerspectiveStore = _ref.FocusedPerspectiveStore;

  ThreadArchiveQuickAction = (function(_super) {
    __extends(ThreadArchiveQuickAction, _super);

    function ThreadArchiveQuickAction() {
      this._onArchive = __bind(this._onArchive, this);
      this.render = __bind(this.render, this);
      return ThreadArchiveQuickAction.__super__.constructor.apply(this, arguments);
    }

    ThreadArchiveQuickAction.displayName = 'ThreadArchiveQuickAction';

    ThreadArchiveQuickAction.propTypes = {
      thread: React.PropTypes.object
    };

    ThreadArchiveQuickAction.prototype.render = function() {
      var allowed;
      allowed = FocusedPerspectiveStore.current().canArchiveThreads([this.props.thread]);
      if (!allowed) {
        return React.createElement("span", null);
      }
      return React.createElement("div", {
        "key": "archive",
        "title": "Archive",
        "style": {
          order: 100
        },
        "className": "btn action action-archive",
        "onClick": this._onArchive
      });
    };

    ThreadArchiveQuickAction.prototype.shouldComponentUpdate = function(newProps, newState) {
      var _ref1;
      return newProps.thread.id !== ((_ref1 = this.props) != null ? _ref1.thread.id : void 0);
    };

    ThreadArchiveQuickAction.prototype._onArchive = function(event) {
      var tasks;
      tasks = TaskFactory.tasksForArchiving({
        threads: [this.props.thread]
      });
      Actions.queueTasks(tasks);
      return event.stopPropagation();
    };

    return ThreadArchiveQuickAction;

  })(React.Component);

  ThreadTrashQuickAction = (function(_super) {
    __extends(ThreadTrashQuickAction, _super);

    function ThreadTrashQuickAction() {
      this._onRemove = __bind(this._onRemove, this);
      this.render = __bind(this.render, this);
      return ThreadTrashQuickAction.__super__.constructor.apply(this, arguments);
    }

    ThreadTrashQuickAction.displayName = 'ThreadTrashQuickAction';

    ThreadTrashQuickAction.propTypes = {
      thread: React.PropTypes.object
    };

    ThreadTrashQuickAction.prototype.render = function() {
      var allowed;
      allowed = FocusedPerspectiveStore.current().canMoveThreadsTo([this.props.thread], 'trash');
      if (!allowed) {
        return React.createElement("span", null);
      }
      return React.createElement("div", {
        "key": "remove",
        "title": "Trash",
        "style": {
          order: 110
        },
        "className": 'btn action action-trash',
        "onClick": this._onRemove
      });
    };

    ThreadTrashQuickAction.prototype.shouldComponentUpdate = function(newProps, newState) {
      var _ref1;
      return newProps.thread.id !== ((_ref1 = this.props) != null ? _ref1.thread.id : void 0);
    };

    ThreadTrashQuickAction.prototype._onRemove = function(event) {
      var tasks;
      tasks = TaskFactory.tasksForMovingToTrash({
        threads: [this.props.thread]
      });
      Actions.queueTasks(tasks);
      return event.stopPropagation();
    };

    return ThreadTrashQuickAction;

  })(React.Component);

  module.exports = {
    ThreadArchiveQuickAction: ThreadArchiveQuickAction,
    ThreadTrashQuickAction: ThreadTrashQuickAction
  };

}).call(this);
