(function() {
  var React, ThreadListScrollTooltip, ThreadListStore, Utils,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  Utils = require('nylas-exports').Utils;

  ThreadListStore = require('./thread-list-store');

  ThreadListScrollTooltip = (function(_super) {
    __extends(ThreadListScrollTooltip, _super);

    function ThreadListScrollTooltip() {
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      this.componentWillReceiveProps = __bind(this.componentWillReceiveProps, this);
      this.componentWillMount = __bind(this.componentWillMount, this);
      return ThreadListScrollTooltip.__super__.constructor.apply(this, arguments);
    }

    ThreadListScrollTooltip.displayName = 'ThreadListScrollTooltip';

    ThreadListScrollTooltip.propTypes = {
      viewportCenter: React.PropTypes.number.isRequired,
      totalHeight: React.PropTypes.number.isRequired
    };

    ThreadListScrollTooltip.prototype.componentWillMount = function() {
      return this.setupForProps(this.props);
    };

    ThreadListScrollTooltip.prototype.componentWillReceiveProps = function(newProps) {
      return this.setupForProps(newProps);
    };

    ThreadListScrollTooltip.prototype.shouldComponentUpdate = function(newProps, newState) {
      var _ref;
      return ((_ref = this.state) != null ? _ref.idx : void 0) !== newState.idx;
    };

    ThreadListScrollTooltip.prototype.setupForProps = function(props) {
      var idx;
      idx = Math.floor(ThreadListStore.dataSource().count() / this.props.totalHeight * this.props.viewportCenter);
      return this.setState({
        idx: idx,
        item: ThreadListStore.dataSource().get(idx)
      });
    };

    ThreadListScrollTooltip.prototype.render = function() {
      var content;
      if (this.state.item) {
        content = Utils.shortTimeString(this.state.item.lastMessageReceivedTimestamp);
      } else {
        content = "Loading...";
      }
      return React.createElement("div", {
        "className": "scroll-tooltip"
      }, content);
    };

    return ThreadListScrollTooltip;

  })(React.Component);

  module.exports = ThreadListScrollTooltip;

}).call(this);
