(function() {
  var Actions, DatabaseStore, FocusedContentStore, FocusedPerspectiveStore, ListTabular, Message, NylasStore, Rx, TaskQueueStatusStore, Thread, ThreadListDataSource, ThreadListStore, WorkspaceStore, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  NylasStore = require('nylas-store');

  _ref = require('nylas-exports'), Rx = _ref.Rx, Thread = _ref.Thread, Message = _ref.Message, Actions = _ref.Actions, DatabaseStore = _ref.DatabaseStore, WorkspaceStore = _ref.WorkspaceStore, FocusedContentStore = _ref.FocusedContentStore, TaskQueueStatusStore = _ref.TaskQueueStatusStore, FocusedPerspectiveStore = _ref.FocusedPerspectiveStore;

  ListTabular = require('nylas-component-kit').ListTabular;

  ThreadListDataSource = require('./thread-list-data-source');

  ThreadListStore = (function(_super) {
    __extends(ThreadListStore, _super);

    function ThreadListStore() {
      this._onDataChanged = __bind(this._onDataChanged, this);
      this._onPerspectiveChanged = __bind(this._onPerspectiveChanged, this);
      this.selectionObservable = __bind(this.selectionObservable, this);
      this.createListDataSource = __bind(this.createListDataSource, this);
      this.dataSource = __bind(this.dataSource, this);
      this.listenTo(FocusedPerspectiveStore, this._onPerspectiveChanged);
      this.createListDataSource();
    }

    ThreadListStore.prototype.dataSource = function() {
      return this._dataSource;
    };

    ThreadListStore.prototype.createListDataSource = function() {
      var threadsSubscription;
      if (typeof this._dataSourceUnlisten === "function") {
        this._dataSourceUnlisten();
      }
      this._dataSource = null;
      threadsSubscription = FocusedPerspectiveStore.current().threads();
      if (threadsSubscription) {
        this._dataSource = new ThreadListDataSource(threadsSubscription);
        this._dataSourceUnlisten = this._dataSource.listen(this._onDataChanged, this);
      } else {
        this._dataSource = new ListTabular.DataSource.Empty();
      }
      this.trigger(this);
      return Actions.setFocus({
        collection: 'thread',
        item: null
      });
    };

    ThreadListStore.prototype.selectionObservable = function() {
      return Rx.Observable.fromListSelection(this);
    };

    ThreadListStore.prototype._onPerspectiveChanged = function() {
      if (FocusedPerspectiveStore.current().searchQuery === void 0) {
        Actions.dismissNotificationsMatching({
          tag: 'search-error'
        });
      }
      return this.createListDataSource();
    };

    ThreadListStore.prototype._onDataChanged = function(_arg) {
      var focused, focusedIndex, keyboard, keyboardIndex, matchers, next, nextItemFromIndex, notInSet, previous, viewModeAutofocuses, _ref1, _ref2;
      _ref1 = _arg != null ? _arg : {}, previous = _ref1.previous, next = _ref1.next;
      if (previous && next) {
        focused = FocusedContentStore.focused('thread');
        keyboard = FocusedContentStore.keyboardCursor('thread');
        viewModeAutofocuses = WorkspaceStore.layoutMode() === 'split' || WorkspaceStore.topSheet().root === true;
        matchers = (_ref2 = next.query()) != null ? _ref2.matchers() : void 0;
        focusedIndex = focused ? previous.offsetOfId(focused.id) : -1;
        keyboardIndex = keyboard ? previous.offsetOfId(keyboard.id) : -1;
        nextItemFromIndex = (function(_this) {
          return function(i) {
            var nextIndex, _ref3;
            if (i > 0 && (((_ref3 = next.modelAtOffset(i - 1)) != null ? _ref3.unread : void 0) || i >= next.count())) {
              nextIndex = i - 1;
            } else {
              nextIndex = i;
            }
            return next.modelAtOffset(nextIndex);
          };
        })(this);
        notInSet = function(model) {
          if (matchers) {
            return model.matches(matchers) === false;
          } else {
            return next.offsetOfId(model.id) === -1;
          }
        };
        if (viewModeAutofocuses && focused && notInSet(focused)) {
          Actions.setFocus({
            collection: 'thread',
            item: nextItemFromIndex(focusedIndex)
          });
        }
        if (keyboard && notInSet(keyboard)) {
          return Actions.setCursorPosition({
            collection: 'thread',
            item: nextItemFromIndex(keyboardIndex)
          });
        }
      }
    };

    return ThreadListStore;

  })(NylasStore);

  module.exports = new ThreadListStore();

}).call(this);
