(function() {
  var Actions, FocusedPerspectiveStore, KeyCommandsRegion, Menu, React, ReactDOM, RetinaImg, SearchActions, SearchBar, SearchStore, WorkspaceStore, classNames, _, _ref, _ref1,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  ReactDOM = require('react-dom');

  classNames = require('classnames');

  _ref = require('nylas-exports'), Actions = _ref.Actions, WorkspaceStore = _ref.WorkspaceStore, FocusedPerspectiveStore = _ref.FocusedPerspectiveStore;

  _ref1 = require('nylas-component-kit'), Menu = _ref1.Menu, RetinaImg = _ref1.RetinaImg, KeyCommandsRegion = _ref1.KeyCommandsRegion;

  SearchStore = require('./search-store');

  SearchActions = require('./search-actions')["default"];

  SearchBar = (function(_super) {
    __extends(SearchBar, _super);

    SearchBar.displayName = 'SearchBar';

    function SearchBar(props) {
      this.props = props;
      this._getStateFromStores = __bind(this._getStateFromStores, this);
      this._onChange = __bind(this._onChange, this);
      this._doSearch = __bind(this._doSearch, this);
      this._onBlur = __bind(this._onBlur, this);
      this._onFocus = __bind(this._onFocus, this);
      this._clearAndBlur = __bind(this._clearAndBlur, this);
      this._onClearSearch = __bind(this._onClearSearch, this);
      this._onSelectSuggestion = __bind(this._onSelectSuggestion, this);
      this._onValueChange = __bind(this._onValueChange, this);
      this._containerClasses = __bind(this._containerClasses, this);
      this._onFocusSearch = __bind(this._onFocusSearch, this);
      this.render = __bind(this.render, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = _.extend({}, this._getStateFromStores(), {
        focused: false
      });
    }

    SearchBar.prototype.componentDidMount = function() {
      this.usub = [];
      this.usub.push(SearchStore.listen(this._onChange));
      return this.usub.push(WorkspaceStore.listen((function(_this) {
        return function() {
          if (_this.state.focused) {
            return _this.setState({
              focused: false
            });
          }
        };
      })(this)));
    };

    SearchBar.prototype.componentWillUnmount = function() {
      var usub, _i, _len, _ref2, _results;
      _ref2 = this.usub;
      _results = [];
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        usub = _ref2[_i];
        _results.push(usub());
      }
      return _results;
    };

    SearchBar.prototype._keymapHandlers = function() {
      return {
        'core:focus-search': this._onFocusSearch,
        'search-bar:escape-search': this._clearAndBlur
      };
    };

    SearchBar.prototype.render = function() {
      var headerComponents, inputClass, itemContentFunc, loupeImg;
      inputClass = classNames({
        'empty': this.state.query.length === 0
      });
      loupeImg = this.state.isSearching ? React.createElement(RetinaImg, {
        "className": "search-accessory search loading",
        "name": "inline-loading-spinner.gif",
        "key": "accessory",
        "mode": RetinaImg.Mode.ContentPreserve
      }) : React.createElement(RetinaImg, {
        "className": "search-accessory search",
        "name": "searchloupe.png",
        "key": "accessory",
        "mode": RetinaImg.Mode.ContentDark,
        "onClick": this._doSearch
      });
      headerComponents = [
        React.createElement("input", {
          "type": "text",
          "ref": "searchInput",
          "key": "input",
          "className": inputClass,
          "placeholder": "Search all email",
          "value": this.state.query,
          "onChange": this._onValueChange,
          "onFocus": this._onFocus,
          "onBlur": this._onBlur
        }), loupeImg, React.createElement(RetinaImg, {
          "className": "search-accessory clear",
          "name": "searchclear.png",
          "key": "clear",
          "mode": RetinaImg.Mode.ContentDark,
          "onClick": this._onClearSearch
        })
      ];
      itemContentFunc = (function(_this) {
        return function(item) {
          if (item.divider) {
            return React.createElement(Menu.Item, {
              "divider": item.divider
            });
          } else if (item.contact) {
            return React.createElement(Menu.NameEmailItem, {
              "name": item.contact.name,
              "email": item.contact.email
            });
          } else if (item.thread) {
            return item.thread.subject;
          } else {
            return item.label;
          }
        };
      })(this);
      return React.createElement(KeyCommandsRegion, {
        "className": "search-bar",
        "globalHandlers": this._keymapHandlers()
      }, React.createElement("div", null, React.createElement(Menu, {
        "ref": "menu",
        "className": this._containerClasses(),
        "headerComponents": headerComponents,
        "items": this.state.suggestions,
        "itemContent": itemContentFunc,
        "itemKey": (function(item) {
          var _ref2, _ref3;
          return item.label || ((_ref2 = item.contact) != null ? _ref2.id : void 0) || ((_ref3 = item.thread) != null ? _ref3.id : void 0);
        }),
        "onSelect": this._onSelectSuggestion
      })));
    };

    SearchBar.prototype._onFocusSearch = function() {
      return ReactDOM.findDOMNode(this.refs.searchInput).focus();
    };

    SearchBar.prototype._containerClasses = function() {
      var _ref2, _ref3;
      return classNames({
        'focused': this.state.focused,
        'showing-query': ((_ref2 = this.state.query) != null ? _ref2.length : void 0) > 0,
        'search-container': true,
        'showing-suggestions': ((_ref3 = this.state.suggestions) != null ? _ref3.length : void 0) > 0
      });
    };

    SearchBar.prototype._onValueChange = function(event) {
      SearchActions.queryChanged(event.target.value);
      if (event.target.value === '') {
        return this._onClearSearch();
      }
    };

    SearchBar.prototype._onSelectSuggestion = function(item) {
      if (item.thread != null) {
        return SearchActions.querySubmitted("\"" + item.thread.subject + "\"");
      } else {
        return SearchActions.querySubmitted(item.value);
      }
    };

    SearchBar.prototype._onClearSearch = function(event) {
      return SearchActions.querySubmitted("");
    };

    SearchBar.prototype._clearAndBlur = function() {
      var _ref2;
      this._onClearSearch();
      return (_ref2 = ReactDOM.findDOMNode(this.refs.searchInput)) != null ? _ref2.blur() : void 0;
    };

    SearchBar.prototype._onFocus = function() {
      return this.setState({
        focused: true
      });
    };

    SearchBar.prototype._onBlur = function() {
      return setTimeout((function(_this) {
        return function() {
          SearchActions.searchBlurred();
          return _this.setState({
            focused: false
          });
        };
      })(this), 150);
    };

    SearchBar.prototype._doSearch = function() {
      return SearchActions.querySubmitted(this.state.query);
    };

    SearchBar.prototype._onChange = function() {
      return this.setState(this._getStateFromStores());
    };

    SearchBar.prototype._getStateFromStores = function() {
      return {
        query: SearchStore.query(),
        suggestions: SearchStore.suggestions(),
        isSearching: SearchStore.isSearching()
      };
    };

    return SearchBar;

  })(React.Component);

  module.exports = SearchBar;

}).call(this);
