(function() {
  var React, ReactDOM, ReactTestUtils, SearchActions, SearchBar;

  React = require('react');

  ReactDOM = require('react-dom');

  ReactTestUtils = require('react-addons-test-utils');

  SearchBar = require('../lib/search-bar');

  SearchActions = require('../lib/search-actions')["default"];

  describe('SearchBar', function() {
    beforeEach(function() {
      spyOn(NylasEnv, "isMainWindow").andReturn(true);
      this.searchBar = ReactTestUtils.renderIntoDocument(React.createElement(SearchBar, null));
      return this.input = ReactDOM.findDOMNode(this.searchBar).querySelector("input");
    });
    it('supports search queries with a colon character', function() {
      var test;
      spyOn(SearchActions, "queryChanged");
      test = "::Hello: World::";
      ReactTestUtils.Simulate.change(this.input, {
        target: {
          value: test
        }
      });
      return expect(SearchActions.queryChanged).toHaveBeenCalledWith(test);
    });
    return it('preserves capitalization on searches', function() {
      var test;
      test = "HeLlO wOrLd";
      ReactTestUtils.Simulate.change(this.input, {
        target: {
          value: test
        }
      });
      waitsFor((function(_this) {
        return function() {
          return _this.input.value.length > 0;
        };
      })(this));
      return runs((function(_this) {
        return function() {
          return expect(_this.input.value).toBe(test);
        };
      })(this));
    });
  });

}).call(this);
