(function() {
  var ContactRankingsCache, NylasAPI, RefreshingJSONCache,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  RefreshingJSONCache = require('./refreshing-json-cache');

  NylasAPI = require('nylas-exports').NylasAPI;

  ContactRankingsCache = (function(_super) {
    __extends(ContactRankingsCache, _super);

    function ContactRankingsCache(accountId) {
      this.fetchData = __bind(this.fetchData, this);
      this._accountId = accountId;
      ContactRankingsCache.__super__.constructor.call(this, {
        key: "ContactRankingsFor" + accountId,
        version: 1,
        refreshInterval: 60 * 60 * 1000 * 24
      });
    }

    ContactRankingsCache.prototype.fetchData = function(callback) {
      if (NylasEnv.inSpecMode()) {
        return;
      }
      return NylasAPI.makeRequest({
        accountId: this._accountId,
        path: "/contacts/rankings",
        returnsModel: false
      }).then((function(_this) {
        return function(json) {
          var email, rank, rankings, _i, _len, _ref;
          if (!(json && json instanceof Array)) {
            return;
          }
          rankings = {};
          for (_i = 0, _len = json.length; _i < _len; _i++) {
            _ref = json[_i], email = _ref[0], rank = _ref[1];
            rankings[email.toLowerCase()] = rank;
          }
          return callback(rankings);
        };
      })(this))["catch"]((function(_this) {
        return function(err) {
          return console.warn("Request for Contact Rankings failed for account " + _this._accountId + ". " + err);
        };
      })(this));
    };

    return ContactRankingsCache;

  })(RefreshingJSONCache);

  module.exports = ContactRankingsCache;

}).call(this);
