(function() {
  var DeveloperBarCurlItem, React, classNames,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  classNames = require('classnames');

  React = require('react');

  DeveloperBarCurlItem = (function(_super) {
    __extends(DeveloperBarCurlItem, _super);

    function DeveloperBarCurlItem() {
      this._onRunCommand = __bind(this._onRunCommand, this);
      this._onCopyCommand = __bind(this._onCopyCommand, this);
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      this.render = __bind(this.render, this);
      return DeveloperBarCurlItem.__super__.constructor.apply(this, arguments);
    }

    DeveloperBarCurlItem.displayName = 'DeveloperBarCurlItem';

    DeveloperBarCurlItem.prototype.render = function() {
      var classes;
      classes = classNames({
        "item": true,
        "error-code": this._isError()
      });
      return React.createElement("div", {
        "className": classes
      }, React.createElement("div", {
        "className": "code"
      }, this.props.item.statusCode, this._errorMessage()), React.createElement("span", {
        "className": "timestamp"
      }, this.props.item.startMoment.format("HH:mm:ss"), "\u00a0\u00a0"), React.createElement("a", {
        "onClick": this._onRunCommand
      }, "Run"), React.createElement("a", {
        "onClick": this._onCopyCommand
      }, "Copy"), this.props.item.command);
    };

    DeveloperBarCurlItem.prototype.shouldComponentUpdate = function(nextProps) {
      return this.props.item !== nextProps.item;
    };

    DeveloperBarCurlItem.prototype._onCopyCommand = function() {
      var clipboard;
      clipboard = require('electron').clipboard;
      return clipboard.writeText(this.props.item.command);
    };

    DeveloperBarCurlItem.prototype._isError = function() {
      if (this.props.item.statusCode === "pending") {
        return false;
      }
      return !(parseInt(this.props.item.statusCode) <= 399);
    };

    DeveloperBarCurlItem.prototype._errorMessage = function() {
      var _ref;
      if (((_ref = this.props.item.errorMessage) != null ? _ref : "").length > 0) {
        return " | " + this.props.item.errorMessage;
      } else {
        return "";
      }
    };

    DeveloperBarCurlItem.prototype._onRunCommand = function() {
      var curlFile, fs, shell;
      curlFile = "" + (NylasEnv.getConfigDirPath()) + "/curl.command";
      fs = require('fs-plus');
      if (fs.existsSync(curlFile)) {
        fs.unlinkSync(curlFile);
      }
      fs.writeFileSync(curlFile, this.props.item.command);
      fs.chmodSync(curlFile, '777');
      shell = require('electron').shell;
      return shell.openItem(curlFile);
    };

    return DeveloperBarCurlItem;

  })(React.Component);

  module.exports = DeveloperBarCurlItem;

}).call(this);
