(function() {
  var DateUtils, DeveloperBarLongPollItem, React, Utils, moment, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  moment = require('moment');

  _ref = require('nylas-exports'), DateUtils = _ref.DateUtils, Utils = _ref.Utils;

  DeveloperBarLongPollItem = (function(_super) {
    __extends(DeveloperBarLongPollItem, _super);

    DeveloperBarLongPollItem.displayName = 'DeveloperBarLongPollItem';

    function DeveloperBarLongPollItem(props) {
      this.props = props;
      this.render = __bind(this.render, this);
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      this.state = {
        expanded: false
      };
    }

    DeveloperBarLongPollItem.prototype.shouldComponentUpdate = function(nextProps, nextState) {
      return !Utils.isEqualReact(nextProps, this.props) || !Utils.isEqualReact(nextState, this.state);
    };

    DeveloperBarLongPollItem.prototype.render = function() {
      var classname, itemId, itemVersion, payload, right, timeFormat, timestamp, _ref1;
      if (this.state.expanded) {
        payload = JSON.stringify(this.props.item);
      } else {
        payload = [];
      }
      itemId = this.props.item.id;
      itemVersion = this.props.item.version || ((_ref1 = this.props.item.attributes) != null ? _ref1.version : void 0);
      if (itemVersion) {
        itemId += " (version " + itemVersion + ")";
      }
      timeFormat = DateUtils.getTimeFormat({
        seconds: true
      });
      timestamp = moment(this.props.item.timestamp).format(timeFormat);
      classname = "item";
      right = this.props.item.cursor;
      if (this.props.ignoredBecause) {
        classname += " ignored";
        right = this.props.ignoredBecause + " - " + right;
      }
      return React.createElement("div", {
        "className": classname,
        "onClick": ((function(_this) {
          return function() {
            var _ref2;
            return _this.setState({
              expanded: !((_ref2 = _this.state) != null ? _ref2.expanded : void 0)
            });
          };
        })(this))
      }, React.createElement("div", {
        "className": "cursor"
      }, right), " " + timestamp + ": " + this.props.item.event + " " + this.props.item.object + " " + itemId, React.createElement("div", {
        "className": "payload",
        "onClick": (function(e) {
          return e.stopPropagation();
        })
      }, payload));
    };

    return DeveloperBarLongPollItem;

  })(React.Component);

  module.exports = DeveloperBarLongPollItem;

}).call(this);
