(function() {
  var Actions, DeveloperBarCurlRequest, DeveloperBarStore, NylasStore, NylasSyncStatusStore, moment, qs, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  NylasStore = require('nylas-store');

  _ref = require('nylas-exports'), Actions = _ref.Actions, NylasSyncStatusStore = _ref.NylasSyncStatusStore;

  qs = require('querystring');

  _ = require('underscore');

  moment = require('moment');

  DeveloperBarCurlRequest = (function() {
    function DeveloperBarCurlRequest(_arg) {
      var data, error, headers, k, postBody, request, statusCode, url, v, _ref1, _ref2, _ref3;
      this.id = _arg.id, request = _arg.request, statusCode = _arg.statusCode, error = _arg.error;
      url = request.url;
      if (request.auth) {
        url = url.replace('://', "://" + request.auth.user + ":" + request.auth.pass + "@");
      }
      if (request.qs) {
        url += "?" + (qs.stringify(request.qs));
      }
      postBody = "";
      if (request.body) {
        postBody = JSON.stringify(request.body).replace(/'/g, '\\u0027');
      }
      data = "";
      if (request.method !== 'GET') {
        data = "-d '" + postBody + "'";
      }
      headers = "";
      if (request.headers) {
        _ref1 = request.headers;
        for (k in _ref1) {
          v = _ref1[k];
          headers += "-H \"" + k + ": " + v + "\" ";
        }
      }
      this.command = "curl -X " + request.method + " " + headers + data + " \"" + url + "\"";
      this.statusCode = (_ref2 = statusCode != null ? statusCode : error != null ? error.code : void 0) != null ? _ref2 : "pending";
      this.errorMessage = (_ref3 = error != null ? error.message : void 0) != null ? _ref3 : error;
      this.startMoment = moment(request.startTime);
      this;
    }

    return DeveloperBarCurlRequest;

  })();

  DeveloperBarStore = (function(_super) {
    __extends(DeveloperBarStore, _super);

    function DeveloperBarStore() {
      this._onDidMakeAPIRequest = __bind(this._onDidMakeAPIRequest, this);
      this._onWillMakeAPIRequest = __bind(this._onWillMakeAPIRequest, this);
      this._setStoreDefaults();
      this._registerListeners();
    }

    DeveloperBarStore.prototype.curlHistory = function() {
      return this._curlHistory;
    };

    DeveloperBarStore.prototype.longPollState = function() {
      return this._longPollState;
    };

    DeveloperBarStore.prototype.longPollHistory = function() {
      return this._longPollHistory;
    };

    DeveloperBarStore.prototype.triggerThrottled = function() {
      if (this._triggerThrottled == null) {
        this._triggerThrottled = _.throttle(this.trigger, 150);
      }
      return this._triggerThrottled();
    };

    DeveloperBarStore.prototype._setStoreDefaults = function() {
      this._curlHistoryIds = [];
      this._curlHistory = [];
      this._longPollHistory = [];
      return this._longPollState = {};
    };

    DeveloperBarStore.prototype._registerListeners = function() {
      this.listenTo(NylasSyncStatusStore, this._onSyncStatusChanged);
      this.listenTo(Actions.willMakeAPIRequest, this._onWillMakeAPIRequest);
      this.listenTo(Actions.didMakeAPIRequest, this._onDidMakeAPIRequest);
      this.listenTo(Actions.longPollReceivedRawDeltas, this._onLongPollDeltas);
      this.listenTo(Actions.longPollProcessedDeltas, this._onLongPollProcessedDeltas);
      return this.listenTo(Actions.clearDeveloperConsole, this._onClear);
    };

    DeveloperBarStore.prototype._onClear = function() {
      this._curlHistoryIds = [];
      this._curlHistory = [];
      this._longPollHistory = [];
      return this.trigger(this);
    };

    DeveloperBarStore.prototype._onSyncStatusChanged = function() {
      this._longPollState = {};
      _.forEach(NylasSyncStatusStore.state(), (function(_this) {
        return function(state, accountId) {
          return _this._longPollState[accountId] = state.longConnectionStatus;
        };
      })(this));
      return this.trigger();
    };

    DeveloperBarStore.prototype._onLongPollDeltas = function(deltas) {
      var delta, now, _i, _len, _ref1;
      now = new Date();
      for (_i = 0, _len = deltas.length; _i < _len; _i++) {
        delta = deltas[_i];
        delta.timestamp = now;
      }
      (_ref1 = this._longPollHistory).unshift.apply(_ref1, deltas.reverse());
      if (this._longPollHistory.length > 200) {
        this._longPollHistory.length = 200;
      }
      return this.triggerThrottled(this);
    };

    DeveloperBarStore.prototype._onLongPollProcessedDeltas = function() {
      return this.triggerThrottled(this);
    };

    DeveloperBarStore.prototype._onLongPollStateChange = function(_arg) {
      var accountId, state;
      accountId = _arg.accountId, state = _arg.state;
      this._longPollState[accountId] = state;
      return this.triggerThrottled(this);
    };

    DeveloperBarStore.prototype._onWillMakeAPIRequest = function(_arg) {
      var item, request, requestId;
      requestId = _arg.requestId, request = _arg.request;
      item = new DeveloperBarCurlRequest({
        id: requestId,
        request: request
      });
      this._curlHistory.unshift(item);
      this._curlHistoryIds.unshift(requestId);
      if (this._curlHistory.length > 200) {
        this._curlHistory.pop();
        this._curlHistoryIds.pop();
      }
      return this.triggerThrottled(this);
    };

    DeveloperBarStore.prototype._onDidMakeAPIRequest = function(_arg) {
      var error, idx, item, request, requestId, statusCode;
      requestId = _arg.requestId, request = _arg.request, statusCode = _arg.statusCode, error = _arg.error;
      idx = this._curlHistoryIds.indexOf(requestId);
      if (idx === -1) {
        return;
      }
      item = new DeveloperBarCurlRequest({
        id: requestId,
        request: request,
        statusCode: statusCode,
        error: error
      });
      this._curlHistory[idx] = item;
      return this.triggerThrottled(this);
    };

    return DeveloperBarStore;

  })(NylasStore);

  module.exports = new DeveloperBarStore();

}).call(this);
