(function() {
  var DeveloperBarTask, React, Utils, classNames, _,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  classNames = require('classnames');

  _ = require('underscore');

  Utils = require('nylas-exports').Utils;

  DeveloperBarTask = (function(_super) {
    __extends(DeveloperBarTask, _super);

    DeveloperBarTask.displayName = 'DeveloperBarTask';

    function DeveloperBarTask(props) {
      this.props = props;
      this._classNames = __bind(this._classNames, this);
      this._taskSummary = __bind(this._taskSummary, this);
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      this.render = __bind(this.render, this);
      this.state = {
        expanded: false
      };
    }

    DeveloperBarTask.prototype.render = function() {
      var details;
      details = false;
      if (this.state.expanded) {
        details = React.createElement("div", {
          "className": "task-details"
        }, JSON.stringify(this.props.task.toJSON(), null, 2));
      }
      return React.createElement("div", {
        "className": this._classNames(),
        "onClick": ((function(_this) {
          return function() {
            return _this.setState({
              expanded: !_this.state.expanded
            });
          };
        })(this))
      }, React.createElement("div", {
        "className": "task-summary"
      }, this._taskSummary()), details);
    };

    DeveloperBarTask.prototype.shouldComponentUpdate = function(nextProps, nextState) {
      return !Utils.isEqualReact(nextProps, this.props) || !Utils.isEqualReact(nextState, this.state);
    };

    DeveloperBarTask.prototype._taskSummary = function() {
      var errCode, errMessage, errType, id, localError, qs, remoteError, status, _ref, _ref1, _ref2, _ref3, _ref4;
      qs = this.props.task.queueState;
      errType = "";
      errCode = "";
      errMessage = "";
      if (qs.localError != null) {
        localError = qs.localError;
        errType = localError.constructor.name;
        errMessage = (_ref = localError.message) != null ? _ref : JSON.stringify(localError);
      } else if (qs.remoteError != null) {
        remoteError = qs.remoteError;
        errType = remoteError.constructor.name;
        errCode = (_ref1 = remoteError.statusCode) != null ? _ref1 : "";
        errMessage = (_ref2 = (_ref3 = (_ref4 = remoteError.body) != null ? _ref4.message : void 0) != null ? _ref3 : remoteError != null ? remoteError.message : void 0) != null ? _ref2 : JSON.stringify(remoteError);
      }
      id = this.props.task.id.slice(-4);
      if (qs.status) {
        status = "" + qs.status + " (" + qs.debugStatus + ")";
      } else {
        status = "" + qs.debugStatus;
      }
      return "" + this.props.task.constructor.name + " (ID: " + id + ") " + status + " " + errType + " " + errCode + " " + errMessage;
    };

    DeveloperBarTask.prototype._classNames = function() {
      var qs, _ref;
      qs = (_ref = this.props.task.queueState) != null ? _ref : {};
      return classNames({
        "task": true,
        "task-queued": this.props.type === "queued",
        "task-completed": this.props.type === "completed",
        "task-expanded": this.state.expanded,
        "task-local-error": qs.localError,
        "task-remote-error": qs.remoteError,
        "task-is-processing": qs.isProcessing,
        "task-success": qs.localComplete && qs.remoteComplete
      });
    };

    return DeveloperBarTask;

  })(React.Component);

  module.exports = DeveloperBarTask;

}).call(this);
