(function() {
  var AccountStore, Actions, Contact, DatabaseStore, DeveloperBar, DeveloperBarCurlItem, DeveloperBarLongPollItem, DeveloperBarStore, DeveloperBarTask, Message, React, TaskQueue, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  _ref = require('nylas-exports'), DatabaseStore = _ref.DatabaseStore, AccountStore = _ref.AccountStore, TaskQueue = _ref.TaskQueue, Actions = _ref.Actions, Contact = _ref.Contact, Message = _ref.Message;

  DeveloperBarStore = require('./developer-bar-store');

  DeveloperBarTask = require('./developer-bar-task');

  DeveloperBarCurlItem = require('./developer-bar-curl-item');

  DeveloperBarLongPollItem = require('./developer-bar-long-poll-item');

  DeveloperBar = (function(_super) {
    __extends(DeveloperBar, _super);

    DeveloperBar.displayName = "DeveloperBar";

    DeveloperBar.containerRequired = false;

    function DeveloperBar(props) {
      this.props = props;
      this._getStateFromStores = __bind(this._getStateFromStores, this);
      this._onExpandSection = __bind(this._onExpandSection, this);
      this._onDequeueAll = __bind(this._onDequeueAll, this);
      this._onFilter = __bind(this._onFilter, this);
      this._onClear = __bind(this._onClear, this);
      this._onChange = __bind(this._onChange, this);
      this._sectionContent = __bind(this._sectionContent, this);
      this.render = __bind(this.render, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = _.extend(this._getStateFromStores(), {
        section: 'curl',
        filter: ''
      });
    }

    DeveloperBar.prototype.componentDidMount = function() {
      this.taskQueueUnsubscribe = TaskQueue.listen(this._onChange);
      return this.activityStoreUnsubscribe = DeveloperBarStore.listen(this._onChange);
    };

    DeveloperBar.prototype.componentWillUnmount = function() {
      if (this.taskQueueUnsubscribe) {
        this.taskQueueUnsubscribe();
      }
      if (this.activityStoreUnsubscribe) {
        return this.activityStoreUnsubscribe();
      }
    };

    DeveloperBar.prototype.render = function() {
      var _ref1;
      return React.createElement("div", {
        "className": "developer-bar"
      }, React.createElement("div", {
        "className": "controls"
      }, React.createElement("div", {
        "className": "btn-container pull-left"
      }, React.createElement("div", {
        "className": "btn",
        "onClick": ((function(_this) {
          return function() {
            return _this._onExpandSection('queue');
          };
        })(this))
      }, React.createElement("span", null, "Queue Length: ", ((_ref1 = this.state.queue) != null ? _ref1.length : void 0)))), React.createElement("div", {
        "className": "btn-container pull-left"
      }, React.createElement("div", {
        "className": "btn",
        "onClick": ((function(_this) {
          return function() {
            return _this._onExpandSection('long-polling');
          };
        })(this))
      }, _.map(this.state.longPollState, (function(_this) {
        return function(val, key) {
          return React.createElement("div", {
            "title": "Account ID " + key + " - State: " + val,
            "key": key,
            "className": "activity-status-bubble state-" + val
          });
        };
      })(this)), React.createElement("span", null, "Delta Streaming"))), React.createElement("div", {
        "className": "btn-container pull-left"
      }, React.createElement("div", {
        "className": "btn",
        "onClick": ((function(_this) {
          return function() {
            return _this._onExpandSection('curl');
          };
        })(this))
      }, React.createElement("span", null, "Requests: ", this.state.curlHistory.length)))), this._sectionContent(), React.createElement("div", {
        "className": "footer"
      }, React.createElement("div", {
        "className": "btn",
        "onClick": this._onClear
      }, "Clear"), React.createElement("input", {
        "className": "filter",
        "placeholder": "Filter...",
        "value": this.state.filter,
        "onChange": this._onFilter
      })));
    };

    DeveloperBar.prototype._sectionContent = function() {
      var expandedDiv, i, itemDivs, matchingFilter, queue, queueCompleted, queueCompletedDivs, queueDivs, status, task;
      expandedDiv = React.createElement("div", null);
      matchingFilter = (function(_this) {
        return function(item) {
          if (_this.state.filter === '') {
            return true;
          }
          return JSON.stringify(item).indexOf(_this.state.filter) >= 0;
        };
      })(this);
      if (this.state.section === 'curl') {
        itemDivs = this.state.curlHistory.filter(matchingFilter).map(function(item) {
          return React.createElement(DeveloperBarCurlItem, {
            "item": item,
            "key": item.id
          });
        });
        return expandedDiv = React.createElement("div", {
          "className": "expanded-section curl-history"
        }, itemDivs);
      } else if (this.state.section === 'long-polling') {
        itemDivs = this.state.longPollHistory.filter(matchingFilter).map(function(item) {
          return React.createElement(DeveloperBarLongPollItem, {
            "item": item,
            "ignoredBecause": item.ignoredBecause,
            "key": "" + item.cursor + "-" + item.timestamp
          });
        });
        return expandedDiv = React.createElement("div", {
          "className": "expanded-section long-polling"
        }, itemDivs);
      } else if (this.state.section === 'queue') {
        queue = this.state.queue.filter(matchingFilter);
        queueDivs = (function() {
          var _i, _ref1, _results;
          _results = [];
          for (i = _i = _ref1 = this.state.queue.length - 1; _i >= 0; i = _i += -1) {
            task = this.state.queue[i];
            status = this.state.queue[i].queueState.status;
            _results.push(React.createElement(DeveloperBarTask, {
              "task": task,
              "key": task.id,
              "status": status,
              "type": "queued"
            }));
          }
          return _results;
        }).call(this);
        queueCompleted = this.state.completed.filter(matchingFilter);
        queueCompletedDivs = (function() {
          var _i, _ref1, _results;
          _results = [];
          for (i = _i = _ref1 = this.state.completed.length - 1; _i >= 0; i = _i += -1) {
            task = this.state.completed[i];
            _results.push(React.createElement(DeveloperBarTask, {
              "task": task,
              "key": task.id,
              "type": "completed"
            }));
          }
          return _results;
        }).call(this);
        expandedDiv = React.createElement("div", {
          "className": "expanded-section queue"
        }, React.createElement("div", {
          "className": "btn queue-buttons",
          "onClick": this._onDequeueAll
        }, "Remove Queued Tasks"), React.createElement("div", {
          "className": "section-content"
        }, queueDivs, React.createElement("hr", null), queueCompletedDivs));
        return expandedDiv;
      }
    };

    DeveloperBar.prototype._onChange = function() {
      return this.setState(this._getStateFromStores());
    };

    DeveloperBar.prototype._onClear = function() {
      return Actions.clearDeveloperConsole();
    };

    DeveloperBar.prototype._onFilter = function(ev) {
      return this.setState({
        filter: ev.target.value
      });
    };

    DeveloperBar.prototype._onDequeueAll = function() {
      return Actions.dequeueAllTasks();
    };

    DeveloperBar.prototype._onExpandSection = function(section) {
      this.setState(this._getStateFromStores());
      return this.setState({
        section: section
      });
    };

    DeveloperBar.prototype._getStateFromStores = function() {
      return {
        queue: TaskQueue._queue,
        completed: TaskQueue._completed,
        curlHistory: DeveloperBarStore.curlHistory(),
        longPollHistory: DeveloperBarStore.longPollHistory(),
        longPollState: DeveloperBarStore.longPollState()
      };
    };

    return DeveloperBar;

  })(React.Component);

  module.exports = DeveloperBar;

}).call(this);
