(function() {
  var ChaosMonkey, NylasAPI, nock;

  NylasAPI = require('./flux/nylas-api');

  nock = require('nock');

  ChaosMonkey = (function() {
    function ChaosMonkey() {}

    ChaosMonkey.unleashOnAPI = function(_arg) {
      var errorCode, makeTimeout, nGet, nPost, nPut, numMonkeys, numTimes, _ref, _ref1;
      _ref = _arg != null ? _arg : {}, errorCode = _ref.errorCode, numMonkeys = _ref.numMonkeys, makeTimeout = _ref.makeTimeout;
      if (errorCode == null) {
        errorCode = 500;
      }
      if (numMonkeys == null) {
        numMonkeys = "all the monkeys";
      }
      if (makeTimeout == null) {
        makeTimeout = false;
      }
      nGet = nock(NylasAPI.APIRoot);
      nPut = nock(NylasAPI.APIRoot);
      nPost = nock(NylasAPI.APIRoot);
      numTimes = 1;
      if (numMonkeys.toLowerCase() === "all the monkeys") {
        nGet = nGet.persist();
        nPut = nPut.persist();
        nPost = nPost.persist();
      } else if (_.isNumber(numMonkeys)) {
        numTimes = numMonkeys;
      }
      nGet = nGet.filteringPath(function(path) {
        return '/*';
      }).get('/*');
      nPut = nPut.filteringRequestBody(function(body) {
        return '*';
      }).filteringPath(function(path) {
        return '/*';
      }).put('/*', '*');
      nPost = nPost.filteringRequestBody(function(body) {
        return '*';
      }).filteringPath(function(path) {
        return '/*';
      }).post('/*', '*');
      _ref1 = [nGet, nPut, nPost].map(function(n) {
        n = n.times(numTimes);
        if (makeTimeout) {
          return n.socketDelay(31000);
        } else {
          return n;
        }
      }), nGet = _ref1[0], nPut = _ref1[1], nPost = _ref1[2];
      if (makeTimeout) {
        return [nGet, nPut, nPost].forEach(function(n) {
          return n.reply(200, 'Timed out');
        });
      } else {
        nGet.replyWithError({
          message: 'Monkey GET error!',
          code: errorCode
        });
        nPut.replyWithError({
          message: 'Monkey PUT error!',
          code: errorCode
        });
        return nPost.replyWithError({
          message: 'Monkey POST error!',
          code: errorCode
        });
      }
    };

    ChaosMonkey.goHome = function() {
      nock.restore();
      return nock.cleanAll();
    };

    return ChaosMonkey;

  })();

  window.ChaosMonkey = ChaosMonkey;

  module.exports = ChaosMonkey;

}).call(this);
