(function() {
  var ButtonDropdown, React, ReactDOM, RetinaImg, Utils, classnames,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  RetinaImg = require('./retina-img')["default"];

  Utils = require('nylas-exports').Utils;

  classnames = require('classnames');

  React = require('react');

  ReactDOM = require('react-dom');

  ButtonDropdown = (function(_super) {
    __extends(ButtonDropdown, _super);

    ButtonDropdown.displayName = "ButtonDropdown";

    ButtonDropdown.propTypes = {
      primaryItem: React.PropTypes.element,
      primaryClick: React.PropTypes.func,
      bordered: React.PropTypes.bool,
      menu: React.PropTypes.element,
      style: React.PropTypes.object,
      closeOnMenuClick: React.PropTypes.bool
    };

    ButtonDropdown.defaultProps = {
      style: {}
    };

    function ButtonDropdown(props) {
      this.props = props;
      this._onBlur = __bind(this._onBlur, this);
      this._onMenuClick = __bind(this._onMenuClick, this);
      this.toggleDropdown = __bind(this.toggleDropdown, this);
      this.render = __bind(this.render, this);
      this.state = {
        open: false
      };
    }

    ButtonDropdown.prototype.render = function() {
      var classes, _ref, _ref1, _ref2, _ref3;
      classes = classnames({
        'button-dropdown': true,
        'open open-up': this.state.open === 'up',
        'open open-down': this.state.open === 'down',
        'bordered': this.props.bordered !== false
      });
      if (this.props.primaryClick) {
        return React.createElement("div", {
          "ref": "button",
          "onBlur": this._onBlur,
          "tabIndex": -1.,
          "className": "" + classes + " " + ((_ref = this.props.className) != null ? _ref : ''),
          "style": this.props.style
        }, React.createElement("div", {
          "className": "primary-item",
          "title": (_ref1 = this.props.primaryTitle) != null ? _ref1 : "",
          "onClick": this.props.primaryClick
        }, this.props.primaryItem), React.createElement("div", {
          "className": "secondary-picker",
          "onClick": this.toggleDropdown
        }, React.createElement(RetinaImg, {
          "name": "icon-thread-disclosure.png",
          "mode": RetinaImg.Mode.ContentIsMask
        })), React.createElement("div", {
          "ref": "secondaryItems",
          "className": "secondary-items",
          "onMouseDown": this._onMenuClick
        }, this.props.menu));
      } else {
        return React.createElement("div", {
          "ref": "button",
          "onBlur": this._onBlur,
          "tabIndex": -1.,
          "className": "" + classes + " " + ((_ref2 = this.props.className) != null ? _ref2 : ''),
          "style": this.props.style
        }, React.createElement("div", {
          "className": "only-item",
          "title": (_ref3 = this.props.primaryTitle) != null ? _ref3 : "",
          "onClick": this.toggleDropdown
        }, this.props.primaryItem, React.createElement(RetinaImg, {
          "name": "icon-thread-disclosure.png",
          "style": {
            marginLeft: 12
          },
          "mode": RetinaImg.Mode.ContentIsMask
        })), React.createElement("div", {
          "ref": "secondaryItems",
          "className": "secondary-items left",
          "onMouseDown": this._onMenuClick
        }, this.props.menu));
      }
    };

    ButtonDropdown.prototype.toggleDropdown = function() {
      var buttonBottom, openHeight;
      if (this.state.open !== false) {
        return this.setState({
          open: false
        });
      } else {
        buttonBottom = ReactDOM.findDOMNode(this).getBoundingClientRect().bottom;
        openHeight = ReactDOM.findDOMNode(this.refs.secondaryItems).getBoundingClientRect().height;
        if (buttonBottom + openHeight > window.innerHeight) {
          return this.setState({
            open: 'up'
          });
        } else {
          return this.setState({
            open: 'down'
          });
        }
      }
    };

    ButtonDropdown.prototype._onMenuClick = function(event) {
      if (this.props.closeOnMenuClick) {
        return this.setState({
          open: false
        });
      }
    };

    ButtonDropdown.prototype._onBlur = function(event) {
      var target;
      target = event.nativeEvent.relatedTarget;
      if ((target != null) && ReactDOM.findDOMNode(this.refs.button).contains(target)) {
        return;
      }
      return this.setState({
        open: false
      });
    };

    return ButtonDropdown;

  })(React.Component);

  module.exports = ButtonDropdown;

}).call(this);
