(function() {
  var ConfigPropContainer, React, _,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  React = require('react');

  _ = require('underscore');

  ConfigPropContainer = (function(_super) {
    __extends(ConfigPropContainer, _super);

    ConfigPropContainer.displayName = 'ConfigPropContainer';

    function ConfigPropContainer(props) {
      this.props = props;
      this.render = __bind(this.render, this);
      this.getConfigWithMutators = __bind(this.getConfigWithMutators, this);
      this.getStateFromStores = __bind(this.getStateFromStores, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = this.getStateFromStores();
    }

    ConfigPropContainer.prototype.componentDidMount = function() {
      return this.subscription = NylasEnv.config.onDidChange(null, (function(_this) {
        return function() {
          return _this.setState(_this.getStateFromStores());
        };
      })(this));
    };

    ConfigPropContainer.prototype.componentWillUnmount = function() {
      var _ref;
      return (_ref = this.subscription) != null ? _ref.dispose() : void 0;
    };

    ConfigPropContainer.prototype.getStateFromStores = function() {
      return {
        config: this.getConfigWithMutators()
      };
    };

    ConfigPropContainer.prototype.getConfigWithMutators = function() {
      return _.extend(NylasEnv.config.get(), {
        get: (function(_this) {
          return function(key) {
            return NylasEnv.config.get(key);
          };
        })(this),
        set: (function(_this) {
          return function(key, value) {
            NylasEnv.config.set(key, value);
          };
        })(this),
        toggle: (function(_this) {
          return function(key) {
            NylasEnv.config.set(key, !NylasEnv.config.get(key));
          };
        })(this),
        contains: (function(_this) {
          return function(key, val) {
            var vals;
            vals = NylasEnv.config.get(key);
            if (!(vals && vals instanceof Array)) {
              return false;
            }
            return __indexOf.call(vals, val) >= 0;
          };
        })(this),
        toggleContains: (function(_this) {
          return function(key, val) {
            var vals;
            vals = NylasEnv.config.get(key);
            if (!(vals && vals instanceof Array)) {
              vals = [];
            }
            if (__indexOf.call(vals, val) >= 0) {
              NylasEnv.config.set(key, _.without(vals, val));
            } else {
              NylasEnv.config.set(key, vals.concat([val]));
            }
          };
        })(this)
      });
    };

    ConfigPropContainer.prototype.render = function() {
      return React.cloneElement(this.props.children, {
        config: this.state.config,
        configSchema: NylasEnv.config.getSchema('core')
      });
    };

    return ConfigPropContainer;

  })(React.Component);

  module.exports = ConfigPropContainer;

}).call(this);
