(function() {
  var BlockquoteManager, ContenteditableExtension, DOMUtils, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), DOMUtils = _ref.DOMUtils, ContenteditableExtension = _ref.ContenteditableExtension;

  BlockquoteManager = (function(_super) {
    __extends(BlockquoteManager, _super);

    function BlockquoteManager() {
      return BlockquoteManager.__super__.constructor.apply(this, arguments);
    }

    BlockquoteManager.keyCommandHandlers = function() {
      return {
        "contenteditable:quote": this._onCreateBlockquote
      };
    };

    BlockquoteManager.onKeyDown = function(_arg) {
      var editor, event;
      editor = _arg.editor, event = _arg.event;
      if (event.key === "Backspace") {
        if (this._isInBlockquote(editor) && this._isAtStartOfLine(editor)) {
          editor.outdent();
          return event.preventDefault();
        }
      }
    };

    BlockquoteManager._onCreateBlockquote = function(_arg) {
      var editor, event;
      editor = _arg.editor, event = _arg.event;
      return editor.formatBlock("BLOCKQUOTE");
    };

    BlockquoteManager._isInBlockquote = function(editor) {
      var sel;
      sel = editor.currentSelection();
      if (!sel.isCollapsed) {
        return;
      }
      return DOMUtils.closest(sel.anchorNode, "blockquote") != null;
    };

    BlockquoteManager._isAtStartOfLine = function(editor) {
      var sel;
      sel = editor.currentSelection();
      if (!sel.anchorNode) {
        return false;
      }
      if (!sel.isCollapsed) {
        return false;
      }
      if (sel.anchorOffset !== 0) {
        return false;
      }
      return this._ancestorRelativeLooksLikeBlock(sel.anchorNode);
    };

    BlockquoteManager._ancestorRelativeLooksLikeBlock = function(node) {
      var sibling;
      if (DOMUtils.looksLikeBlockElement(node)) {
        return true;
      }
      sibling = node;
      while (sibling = sibling.previousSibling) {
        if (DOMUtils.looksLikeBlockElement(sibling)) {
          return true;
        }
        if (DOMUtils.looksLikeNonEmptyNode(sibling)) {
          return false;
        }
      }
      return this._ancestorRelativeLooksLikeBlock(node.parentNode);
    };

    return BlockquoteManager;

  })(ContenteditableExtension);

  module.exports = BlockquoteManager;

}).call(this);
