(function() {
  var ContenteditableExtension, DOMNormalizer, DOMUtils, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), ContenteditableExtension = _ref.ContenteditableExtension, DOMUtils = _ref.DOMUtils;

  DOMNormalizer = (function(_super) {
    __extends(DOMNormalizer, _super);

    function DOMNormalizer() {
      return DOMNormalizer.__super__.constructor.apply(this, arguments);
    }

    DOMNormalizer.onContentChanged = function(_arg) {
      var editor, mutations;
      editor = _arg.editor, mutations = _arg.mutations;
      this._cleanHTML(editor);
      return this._cleanSelection(editor);
    };

    DOMNormalizer._cleanHTML = function(editor) {
      if (!editor.rootNode) {
        return;
      }
      editor.normalize();
      return this._fixLeadingBRCondition(editor);
    };

    DOMNormalizer._fixLeadingBRCondition = function(editor) {
      var currentNode, newNode, treeWalker;
      treeWalker = document.createTreeWalker(editor.rootNode);
      while (treeWalker.nextNode()) {
        currentNode = treeWalker.currentNode;
        if (this._hasLeadingBRCondition(currentNode)) {
          newNode = document.createElement("div");
          newNode.appendChild(document.createElement("br"));
          currentNode.replaceChild(newNode, currentNode.childNodes[0]);
        }
      }
    };

    DOMNormalizer._hasLeadingBRCondition = function(node) {
      var childNodes;
      childNodes = node.childNodes;
      return childNodes.length >= 2 && childNodes[0].nodeName === "BR";
    };

    DOMNormalizer._cleanSelection = function(editor) {
      var currentNode, selection, treeWalker;
      selection = editor.currentSelection();
      if (!((selection.anchorNode != null) && (selection.focusNode != null))) {
        return;
      }
      if (selection.anchorOffset > 0 || selection.focusOffset > 0) {
        return;
      }
      if (selection.isCollapsed && this._unselectableNode(selection.focusNode)) {
        treeWalker = document.createTreeWalker(selection.focusNode);
        while (treeWalker.nextNode()) {
          currentNode = treeWalker.currentNode;
          if (this._unselectableNode(currentNode)) {
            selection.setBaseAndExtent(currentNode, 0, currentNode, 0);
            break;
          }
        }
      }
    };

    DOMNormalizer._unselectableNode = function(node) {
      var child, hasBr, hasText;
      if (!node) {
        return true;
      }
      if (node.nodeType === Node.TEXT_NODE && DOMUtils.isBlankTextNode(node)) {
        return true;
      } else if (node.nodeType === Node.ELEMENT_NODE) {
        child = node.firstChild;
        if (!child) {
          return true;
        }
        hasText = child.nodeType === Node.TEXT_NODE && !DOMUtils.isBlankTextNode(node);
        hasBr = child.nodeType === Node.ELEMENT_NODE && node.nodeName === "BR";
        return !hasText && !hasBr;
      } else {
        return false;
      }
    };

    return DOMNormalizer;

  })(ContenteditableExtension);

  module.exports = DOMNormalizer;

}).call(this);
