(function() {
  var ContenteditableExtension, EmphasisFormattingExtension,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  ContenteditableExtension = require('nylas-exports').ContenteditableExtension;

  EmphasisFormattingExtension = (function(_super) {
    __extends(EmphasisFormattingExtension, _super);

    function EmphasisFormattingExtension() {
      return EmphasisFormattingExtension.__super__.constructor.apply(this, arguments);
    }

    EmphasisFormattingExtension.keyCommandHandlers = function() {
      return {
        "contenteditable:bold": EmphasisFormattingExtension._onBold,
        "contenteditable:italic": EmphasisFormattingExtension._onItalic,
        "contenteditable:underline": EmphasisFormattingExtension._onUnderline,
        "contenteditable:strikeThrough": EmphasisFormattingExtension._onStrikeThrough
      };
    };

    EmphasisFormattingExtension.toolbarButtons = function() {
      return [
        {
          className: "btn-bold",
          onClick: EmphasisFormattingExtension._onBold,
          tooltip: "Bold",
          iconUrl: null
        }, {
          className: "btn-italic",
          onClick: EmphasisFormattingExtension._onItalic,
          tooltip: "Italic",
          iconUrl: null
        }, {
          className: "btn-underline",
          onClick: EmphasisFormattingExtension._onUnderline,
          tooltip: "Underline",
          iconUrl: null
        }
      ];
    };

    EmphasisFormattingExtension._onBold = function(_arg) {
      var editor, event;
      editor = _arg.editor, event = _arg.event;
      return editor.bold();
    };

    EmphasisFormattingExtension._onItalic = function(_arg) {
      var editor, event;
      editor = _arg.editor, event = _arg.event;
      return editor.italic();
    };

    EmphasisFormattingExtension._onUnderline = function(_arg) {
      var editor, event;
      editor = _arg.editor, event = _arg.event;
      return editor.underline();
    };

    EmphasisFormattingExtension._onStrikeThrough = function(_arg) {
      var editor, event;
      editor = _arg.editor, event = _arg.event;
      return editor.strikeThrough();
    };

    EmphasisFormattingExtension.toolbarComponentConfig = function() {
      return null;
    };

    return EmphasisFormattingExtension;

  })(ContenteditableExtension);

  module.exports = EmphasisFormattingExtension;

}).call(this);
