(function() {
  var ContenteditableExtension, DOMUtils, TabManager, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), DOMUtils = _ref.DOMUtils, ContenteditableExtension = _ref.ContenteditableExtension;

  TabManager = (function(_super) {
    __extends(TabManager, _super);

    function TabManager() {
      return TabManager.__super__.constructor.apply(this, arguments);
    }

    TabManager.onKeyDown = function(_arg) {
      var editor, event;
      editor = _arg.editor, event = _arg.event;
      if (event.defaultPrevented) {
        event.stopPropagation();
        return;
      }
      if (event.key === "Tab") {
        this._onTabDownDefaultBehavior(editor, event);
      }
    };

    TabManager._onTabDownDefaultBehavior = function(editor, event) {
      var selection;
      selection = editor.currentSelection();
      if (selection != null ? selection.isCollapsed : void 0) {
        if (event.shiftKey) {
          if (DOMUtils.isAtTabChar(selection)) {
            this._removeLastCharacter(editor);
          } else if (DOMUtils.isAtBeginningOfDocument(editor.rootNode, selection)) {
            return;
          }
        } else {
          editor.insertText("\t");
        }
      } else {
        if (event.shiftKey) {
          editor.insertText("");
        } else {
          editor.insertText("\t");
        }
      }
      event.preventDefault();
      return event.stopPropagation();
    };

    TabManager._removeLastCharacter = function(editor) {
      var node, offset;
      if (DOMUtils.isSelectionInTextNode(editor.currentSelection())) {
        node = editor.currentSelection().anchorNode;
        offset = editor.currentSelection().anchorOffset;
        editor.currentSelection().setBaseAndExtent(node, offset - 1, node, offset);
        return editor["delete"]();
      }
    };

    return TabManager;

  })(ContenteditableExtension);

  module.exports = TabManager;

}).call(this);
