(function() {
  var ContenteditableExtension, DOMUtils, ToolbarButtonManager, ToolbarButtons, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), DOMUtils = _ref.DOMUtils, ContenteditableExtension = _ref.ContenteditableExtension;

  ToolbarButtons = require('./toolbar-buttons');

  ToolbarButtonManager = (function(_super) {
    __extends(ToolbarButtonManager, _super);

    function ToolbarButtonManager() {
      return ToolbarButtonManager.__super__.constructor.apply(this, arguments);
    }

    ToolbarButtonManager.toolbarButtons = function() {
      return [];
    };

    ToolbarButtonManager.toolbarComponentConfig = function(_arg) {
      var buttonConfigs, locationRef, locationRefNode, range, toolbarState;
      toolbarState = _arg.toolbarState;
      if (toolbarState.dragging || toolbarState.doubleDown) {
        return null;
      }
      if (!toolbarState.selectionSnapshot) {
        return null;
      }
      if (toolbarState.selectionSnapshot.isCollapsed) {
        return null;
      }
      locationRef = DOMUtils.getRangeInScope(toolbarState.editableNode);
      if (!locationRef) {
        return null;
      }
      buttonConfigs = ToolbarButtonManager._toolbarButtonConfigs(toolbarState);
      range = DOMUtils.getRangeInScope(toolbarState.editableNode);
      if (!range || !range.startContainer) {
        return null;
      }
      if (range.startContainer.nodeType === Node.ELEMENT_NODE) {
        locationRefNode = range.startContainer.childNodes[range.startOffset];
        if (!locationRefNode) {
          locationRefNode = range;
        }
      } else {
        locationRefNode = range;
      }
      return {
        component: ToolbarButtons,
        props: {
          buttonConfigs: buttonConfigs
        },
        locationRefNode: locationRefNode,
        width: buttonConfigs.length * 28.5,
        height: 34
      };
    };

    ToolbarButtonManager._toolbarButtonConfigs = function(toolbarState) {
      var atomicEdit, buttonConfigs, error, extension, extensionConfigs, extensions, _i, _len, _ref1;
      extensions = toolbarState.extensions, atomicEdit = toolbarState.atomicEdit;
      buttonConfigs = [];
      for (_i = 0, _len = extensions.length; _i < _len; _i++) {
        extension = extensions[_i];
        try {
          extensionConfigs = (_ref1 = typeof extension.toolbarButtons === "function" ? extension.toolbarButtons({
            toolbarState: toolbarState
          }) : void 0) != null ? _ref1 : [];
          if (extensionConfigs.length === 0) {
            continue;
          }
          extensionConfigs.map(function(config) {
            var fn, _ref2;
            fn = (_ref2 = config.onClick) != null ? _ref2 : function() {};
            config.onClick = function(event) {
              return atomicEdit(fn, {
                event: event
              });
            };
            return config;
          });
          buttonConfigs = buttonConfigs.concat(extensionConfigs);
        } catch (_error) {
          error = _error;
          NylasEnv.reportError(error);
        }
      }
      return buttonConfigs;
    };

    return ToolbarButtonManager;

  })(ContenteditableExtension);

  module.exports = ToolbarButtonManager;

}).call(this);
