(function() {
  var React, RetinaImg, ToolbarButtons,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  RetinaImg = require('nylas-component-kit').RetinaImg;

  ToolbarButtons = (function(_super) {
    __extends(ToolbarButtons, _super);

    function ToolbarButtons() {
      return ToolbarButtons.__super__.constructor.apply(this, arguments);
    }

    ToolbarButtons.displayName = "ToolbarButtons";

    ToolbarButtons.propTypes = {
      buttonConfigs: React.PropTypes.array
    };

    ToolbarButtons.defaultProps = {
      buttonConfigs: []
    };

    ToolbarButtons.prototype.render = function() {
      return React.createElement("div", {
        "className": "toolbar-buttons"
      }, this._renderToolbarButtons());
    };

    ToolbarButtons.prototype._renderToolbarButtons = function() {
      return this.props.buttonConfigs.map(function(config, i) {
        var icon, _ref, _ref1;
        if (((_ref = config.iconUrl) != null ? _ref : "").length > 0) {
          icon = React.createElement(RetinaImg, {
            "mode": RetinaImg.Mode.ContentIsMask,
            "url": "" + config.iconUrl
          });
        } else {
          icon = "";
        }
        return React.createElement("button", {
          "className": "btn toolbar-btn " + ((_ref1 = config.className) != null ? _ref1 : ''),
          "key": "btn-" + i,
          "onClick": config.onClick,
          "title": "" + config.tooltip
        }, icon);
      });
    };

    return ToolbarButtons;

  })(React.Component);

  module.exports = ToolbarButtons;

}).call(this);
