(function() {
  var DraggableImg, React, ReactDOM,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  ReactDOM = require('react-dom');


  /*
  Public: Images are supposed to by default show a ghost image when dragging and
  dropping. Unfortunately this does not work in Electron. Since we're a
  desktop app we don't want all images draggable, but we do want some (like
  attachments) to be able to be dragged away with a preview image.
   */

  DraggableImg = (function(_super) {
    __extends(DraggableImg, _super);

    DraggableImg.displayName = 'DraggableImg';

    function DraggableImg(props) {
      this.props = props;
      this._onDragStart = __bind(this._onDragStart, this);
      this.render = __bind(this.render, this);
    }

    DraggableImg.prototype.render = function() {
      return React.createElement("img", React.__spread({
        "ref": "img",
        "draggable": "true",
        "onDragStart": this._onDragStart
      }, this.props));
    };

    DraggableImg.prototype._onDragStart = function(event) {
      var img, rect, x, y;
      img = ReactDOM.findDOMNode(this.refs.img);
      rect = img.getBoundingClientRect();
      y = event.clientY - rect.top;
      x = event.clientX - rect.left;
      event.dataTransfer.setDragImage(img, x, y);
    };

    return DraggableImg;

  })(React.Component);

  module.exports = DraggableImg;

}).call(this);
