(function() {
  var DropZone, React, _,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  _ = require('underscore');

  DropZone = (function(_super) {
    __extends(DropZone, _super);

    DropZone.propTypes = {
      shouldAcceptDrop: React.PropTypes.func.isRequired,
      onDrop: React.PropTypes.func.isRequired,
      onDragOver: React.PropTypes.func,
      onDragStateChange: React.PropTypes.func
    };

    DropZone.defaultProps = {
      onDragOver: function() {}
    };

    function DropZone() {
      this._onDrop = __bind(this._onDrop, this);
      this._onDragLeave = __bind(this._onDragLeave, this);
      this._onDragEnter = __bind(this._onDragEnter, this);
    }

    DropZone.prototype.render = function() {
      var otherProps;
      otherProps = _.omit(this.props, Object.keys(this.constructor.propTypes));
      return React.createElement("div", React.__spread({}, otherProps, {
        "onDragOver": this.props.onDragOver,
        "onDragEnter": this._onDragEnter,
        "onDragLeave": this._onDragLeave,
        "onDrop": this._onDrop
      }), this.props.children);
    };

    DropZone.prototype._onDragEnter = function(e) {
      if (!this.props.shouldAcceptDrop(e)) {
        return;
      }
      if (this._dragCounter == null) {
        this._dragCounter = 0;
      }
      this._dragCounter += 1;
      if (this._dragCounter === 1 && this.props.onDragStateChange) {
        this.props.onDragStateChange({
          isDropping: true
        });
      }
      e.stopPropagation();
    };

    DropZone.prototype._onDragLeave = function(e) {
      if (!this.props.shouldAcceptDrop(e)) {
        return;
      }
      this._dragCounter -= 1;
      if (this._dragCounter === 0 && this.props.onDragStateChange) {
        this.props.onDragStateChange({
          isDropping: false
        });
      }
      e.stopPropagation();
    };

    DropZone.prototype._onDrop = function(e) {
      if (!this.props.shouldAcceptDrop(e)) {
        return;
      }
      if (this.props.onDragStateChange) {
        this.props.onDragStateChange({
          isDropping: false
        });
      }
      this._dragCounter = 0;
      this.props.onDrop(e);
      e.stopPropagation();
    };

    return DropZone;

  })(React.Component);

  module.exports = DropZone;

}).call(this);
