(function() {
  var EmptyInboxState, EmptyListState, EmptyPerspectiveState, EventedIFrame, FocusedPerspectiveStore, INBOX_ZERO_ANIMATIONS, NylasSyncStatusStore, React, ReactDOM, RetinaImg, classNames, _, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  _ = require('underscore');

  React = require('react');

  ReactDOM = require('react-dom');

  classNames = require('classnames');

  RetinaImg = require('./retina-img')["default"];

  EventedIFrame = require('./evented-iframe');

  _ref = require('nylas-exports'), NylasSyncStatusStore = _ref.NylasSyncStatusStore, FocusedPerspectiveStore = _ref.FocusedPerspectiveStore;

  INBOX_ZERO_ANIMATIONS = ['gem', 'oasis', 'tron', 'airstrip', 'galaxy'];

  EmptyPerspectiveState = (function(_super) {
    __extends(EmptyPerspectiveState, _super);

    function EmptyPerspectiveState() {
      return EmptyPerspectiveState.__super__.constructor.apply(this, arguments);
    }

    EmptyPerspectiveState.displayName = "EmptyPerspectiveState";

    EmptyPerspectiveState.propTypes = {
      perspective: React.PropTypes.object,
      messageOverride: React.PropTypes.string
    };

    EmptyPerspectiveState.prototype.render = function() {
      var messageOverride, name, perspective, _ref1;
      _ref1 = this.props, messageOverride = _ref1.messageOverride, perspective = _ref1.perspective;
      name = perspective.categoriesSharedName();
      if (perspective.isArchive()) {
        name = 'archive';
      }
      if (!name) {
        name = perspective.name;
      }
      if (name) {
        name = name.toLowerCase();
      }
      return React.createElement("div", {
        "className": "perspective-empty-state"
      }, (name ? React.createElement(RetinaImg, {
        "name": "ic-emptystate-" + name + ".png",
        "mode": RetinaImg.Mode.ContentIsMask
      }) : void 0), React.createElement("div", {
        "className": "message"
      }, messageOverride));
    };

    return EmptyPerspectiveState;

  })(React.Component);

  EmptyInboxState = (function(_super) {
    __extends(EmptyInboxState, _super);

    function EmptyInboxState() {
      this._getAnimationName = __bind(this._getAnimationName, this);
      this._getScalingFactor = __bind(this._getScalingFactor, this);
      return EmptyInboxState.__super__.constructor.apply(this, arguments);
    }

    EmptyInboxState.displayName = "EmptyInboxState";

    EmptyInboxState.propTypes = {
      containerRect: React.PropTypes.object
    };

    EmptyInboxState.prototype._getScalingFactor = function() {
      var width;
      width = this.props.containerRect.width;
      if (!width) {
        return null;
      }
      if (width > 600) {
        return null;
      }
      return (width + 100) / 1000;
    };

    EmptyInboxState.prototype._getAnimationName = function(now) {
      var daysSinceEpoch, idx, msInADay, msSinceEpoch;
      if (now == null) {
        now = new Date();
      }
      msInADay = 8.64e7;
      msSinceEpoch = now.getTime() - (now.getTimezoneOffset() * 1000 * 60);
      daysSinceEpoch = Math.floor(msSinceEpoch / msInADay);
      idx = daysSinceEpoch % INBOX_ZERO_ANIMATIONS.length;
      return INBOX_ZERO_ANIMATIONS[idx];
    };

    EmptyInboxState.prototype.render = function() {
      var animationName, factor, style;
      animationName = this._getAnimationName();
      factor = this._getScalingFactor();
      style = factor ? {
        transform: "scale(" + factor + ")"
      } : {};
      return React.createElement("div", {
        "className": "inbox-zero-animation"
      }, React.createElement("div", {
        "className": "animation-wrapper",
        "style": style
      }, React.createElement("iframe", {
        "src": "animations/inbox-zero/" + animationName + "/" + animationName + ".html"
      }), React.createElement("div", {
        "className": "message"
      }, "Hooray! You\u2019re done.")));
    };

    return EmptyInboxState;

  })(React.Component);

  EmptyListState = (function(_super) {
    __extends(EmptyListState, _super);

    EmptyListState.displayName = 'EmptyListState';

    EmptyListState.propTypes = {
      visible: React.PropTypes.bool.isRequired
    };

    function EmptyListState(props) {
      this.props = props;
      this._onResize = __bind(this._onResize, this);
      this._getDimensions = __bind(this._getDimensions, this);
      this._mounted = false;
      this.state = {
        syncing: NylasSyncStatusStore.busy(),
        active: false,
        rect: {}
      };
    }

    EmptyListState.prototype.componentDidMount = function() {
      var rect;
      this._mounted = true;
      this._unlisteners = [];
      this._unlisteners.push(NylasSyncStatusStore.listen(this._onChange, this));
      window.addEventListener('resize', this._onResize);
      if (this.props.visible && !this.state.active) {
        rect = this._getDimensions();
        return this.setState({
          active: true,
          rect: rect
        });
      }
    };

    EmptyListState.prototype.shouldComponentUpdate = function(nextProps, nextState) {
      if (nextProps.visible !== this.props.visible) {
        return true;
      }
      return !_.isEqual(nextState, this.state);
    };

    EmptyListState.prototype.componentWillUnmount = function() {
      var unlisten, _i, _len, _ref1;
      this._mounted = false;
      _ref1 = this._unlisteners;
      for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
        unlisten = _ref1[_i];
        unlisten();
      }
      return window.removeEventListener('resize', this._onResize);
    };

    EmptyListState.prototype.componentDidUpdate = function() {
      var rect;
      if (this.props.visible && !this.state.active) {
        rect = this._getDimensions();
        return this.setState({
          active: true,
          rect: rect
        });
      }
    };

    EmptyListState.prototype.componentWillReceiveProps = function(newProps) {
      if (newProps.visible === false) {
        return this.setState({
          active: false
        });
      }
    };

    EmptyListState.prototype.render = function() {
      var ContentComponent, classes, current, messageOverride;
      if (!this.props.visible) {
        return React.createElement("span", null);
      }
      ContentComponent = EmptyPerspectiveState;
      current = FocusedPerspectiveStore.current();
      messageOverride = current.emptyMessage();
      if (this.state.syncing) {
        messageOverride = "Please wait while we prepare your mailbox.";
      } else if (current.isInbox()) {
        ContentComponent = EmptyInboxState;
      }
      classes = classNames({
        'empty-state': true,
        'active': this.state.active
      });
      return React.createElement("div", {
        "className": classes
      }, React.createElement(ContentComponent, {
        "perspective": current,
        "containerRect": this.state.rect,
        "messageOverride": messageOverride
      }));
    };

    EmptyListState.prototype._getDimensions = function() {
      var node, rect;
      if (!this._mounted) {
        return null;
      }
      node = ReactDOM.findDOMNode(this);
      rect = node.getBoundingClientRect();
      return {
        width: rect.width,
        height: rect.height
      };
    };

    EmptyListState.prototype._onResize = function() {
      var rect;
      rect = this._getDimensions();
      if (rect) {
        return this.setState({
          rect: rect
        });
      }
    };

    EmptyListState.prototype._onChange = function() {
      return this.setState({
        syncing: NylasSyncStatusStore.busy()
      });
    };

    return EmptyListState;

  })(React.Component);

  module.exports = EmptyListState;

}).call(this);
