(function() {
  var Actions, ComponentRegistry, Flexbox, React, Utils, _, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  _ = require('underscore');

  _ref = require("nylas-exports"), Actions = _ref.Actions, ComponentRegistry = _ref.ComponentRegistry, Utils = _ref.Utils;


  /*
  Public: A simple wrapper that provides a Flexbox layout with the given direction and style.
  Any additional props you set on the Flexbox are rendered.
  
  Section: Component Kit
   */

  Flexbox = (function(_super) {
    __extends(Flexbox, _super);

    function Flexbox() {
      return Flexbox.__super__.constructor.apply(this, arguments);
    }

    Flexbox.displayName = 'Flexbox';


    /*
    Public: React `props` supported by Flexbox:
    
     - `direction` (optional) A {String} Flexbox direction: either `column` or `row`.
     - `style` (optional) An {Object} with styles to apply to the flexbox.
     */

    Flexbox.propTypes = {
      direction: React.PropTypes.string,
      inline: React.PropTypes.bool,
      style: React.PropTypes.object,
      height: React.PropTypes.string
    };

    Flexbox.defaultProps = {
      height: '100%'
    };

    Flexbox.prototype.render = function() {
      var otherProps, style;
      style = _.extend({}, {
        'flexDirection': this.props.direction,
        'position': 'relative',
        'display': 'flex',
        'height': this.props.height
      }, this.props.style || {});
      if (this.props.inline === true) {
        style.display = 'inline-flex';
      }
      otherProps = Utils.fastOmit(this.props, Object.keys(this.constructor.propTypes));
      return React.createElement("div", React.__spread({
        "style": style
      }, otherProps), this.props.children);
    };

    return Flexbox;

  })(React.Component);

  module.exports = Flexbox;

}).call(this);
