(function() {
  var FluxContainer, React, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  _ = require('underscore');

  FluxContainer = (function(_super) {
    __extends(FluxContainer, _super);

    FluxContainer.displayName = 'FluxContainer';

    FluxContainer.propTypes = {
      children: React.PropTypes.element,
      stores: React.PropTypes.array.isRequired,
      getStateFromStores: React.PropTypes.func.isRequired
    };

    function FluxContainer(props) {
      this.props = props;
      this._unlisteners = [];
      this.state = this.props.getStateFromStores();
    }

    FluxContainer.prototype.componentDidMount = function() {
      return this.setupListeners();
    };

    FluxContainer.prototype.componentWillReceiveProps = function(nextProps) {
      this.setState(nextProps.getStateFromStores());
      return this.setupListeners(nextProps);
    };

    FluxContainer.prototype.setupListeners = function(props) {
      var unlisten, _i, _len, _ref;
      if (props == null) {
        props = this.props;
      }
      _ref = this._unlisteners;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        unlisten = _ref[_i];
        unlisten();
      }
      return this._unlisteners = props.stores.map((function(_this) {
        return function(store) {
          return store.listen(function() {
            return _this.setState(props.getStateFromStores());
          });
        };
      })(this));
    };

    FluxContainer.prototype.componentWillUnmount = function() {
      var unlisten, _i, _len, _ref;
      _ref = this._unlisteners;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        unlisten = _ref[_i];
        unlisten();
      }
      return this._unlisteners = [];
    };

    FluxContainer.prototype.render = function() {
      var otherProps;
      otherProps = _.omit(this.props, Object.keys(this.constructor.propTypes));
      return React.cloneElement(this.props.children, _.extend({}, otherProps, this.state));
    };

    return FluxContainer;

  })(React.Component);

  module.exports = FluxContainer;

}).call(this);
