(function() {
  var Actions, FluxContainer, FocusContainer, FocusedContentStore, React, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  _ref = require('nylas-exports'), FocusedContentStore = _ref.FocusedContentStore, Actions = _ref.Actions;

  FluxContainer = require('nylas-component-kit').FluxContainer;

  FocusContainer = (function(_super) {
    __extends(FocusContainer, _super);

    function FocusContainer() {
      this.getStateFromStores = __bind(this.getStateFromStores, this);
      return FocusContainer.__super__.constructor.apply(this, arguments);
    }

    FocusContainer.displayName = 'FocusContainer';

    FocusContainer.propTypes = {
      children: React.PropTypes.element,
      collection: React.PropTypes.string
    };

    FocusContainer.prototype.getStateFromStores = function() {
      return {
        focused: FocusedContentStore.focused(this.props.collection),
        focusedId: FocusedContentStore.focusedId(this.props.collection),
        keyboardCursor: FocusedContentStore.keyboardCursor(this.props.collection),
        keyboardCursorId: FocusedContentStore.keyboardCursorId(this.props.collection),
        onFocusItem: (function(_this) {
          return function(item) {
            return Actions.setFocus({
              collection: _this.props.collection,
              item: item
            });
          };
        })(this),
        onSetCursorPosition: (function(_this) {
          return function(item) {
            return Actions.setCursorPosition({
              collection: _this.props.collection,
              item: item
            });
          };
        })(this)
      };
    };

    FocusContainer.prototype.render = function() {
      return React.createElement(FluxContainer, React.__spread({}, this.props, {
        "stores": [FocusedContentStore],
        "getStateFromStores": this.getStateFromStores
      }), this.props.children);
    };

    return FocusContainer;

  })(React.Component);

  module.exports = FocusContainer;

}).call(this);
