(function() {
  var EmptyListDataSource, EventEmitter, ListDataSource, ListSelection, _,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  EventEmitter = require('events').EventEmitter;

  ListSelection = require('./list-selection');

  ListDataSource = (function() {
    function ListDataSource() {
      this.trigger = __bind(this.trigger, this);
      this._emitter = new EventEmitter();
      this._cleanedup = false;
      this.selection = new ListSelection(this, this.trigger);
      this;
    }

    ListDataSource.prototype.trigger = function(arg) {
      return this._emitter.emit('trigger', arg);
    };

    ListDataSource.prototype.listen = function(callback, bindContext) {
      var eventHandler;
      if (!(callback instanceof Function)) {
        throw new Error("ListDataSource: You must pass a function to `listen`");
      }
      if (this._cleanedup === true) {
        throw new Error("ListDataSource: You cannot listen again after removing the last listener. This is an implementation detail.");
      }
      eventHandler = function() {
        return callback.apply(bindContext, arguments);
      };
      this._emitter.addListener('trigger', eventHandler);
      return (function(_this) {
        return function() {
          _this._emitter.removeListener('trigger', eventHandler);
          if (_this._emitter.listenerCount('trigger') === 0) {
            _this._cleanedup = true;
            return _this.cleanup();
          }
        };
      })(this);
    };

    ListDataSource.prototype.loaded = function() {
      throw new Error("ListDataSource base class does not implement loaded()");
    };

    ListDataSource.prototype.empty = function() {
      throw new Error("ListDataSource base class does not implement empty()");
    };

    ListDataSource.prototype.get = function(idx) {
      throw new Error("ListDataSource base class does not implement get()");
    };

    ListDataSource.prototype.getById = function(id) {
      throw new Error("ListDataSource base class does not implement getById()");
    };

    ListDataSource.prototype.indexOfId = function(id) {
      throw new Error("ListDataSource base class does not implement indexOfId()");
    };

    ListDataSource.prototype.count = function() {
      throw new Error("ListDataSource base class does not implement count()");
    };

    ListDataSource.prototype.itemsCurrentlyInViewMatching = function(matchFn) {
      throw new Error("ListDataSource base class does not implement itemsCurrentlyInViewMatching()");
    };

    ListDataSource.prototype.setRetainedRange = function(_arg) {
      var end, start;
      start = _arg.start, end = _arg.end;
      throw new Error("ListDataSource base class does not implement setRetainedRange()");
    };

    ListDataSource.prototype.cleanup = function() {
      return this.selection.cleanup();
    };

    return ListDataSource;

  })();

  EmptyListDataSource = (function(_super) {
    __extends(EmptyListDataSource, _super);

    function EmptyListDataSource() {
      return EmptyListDataSource.__super__.constructor.apply(this, arguments);
    }

    EmptyListDataSource.prototype.loaded = function() {
      return true;
    };

    EmptyListDataSource.prototype.empty = function() {
      return true;
    };

    EmptyListDataSource.prototype.get = function(idx) {
      return null;
    };

    EmptyListDataSource.prototype.getById = function(id) {
      return null;
    };

    EmptyListDataSource.prototype.indexOfId = function(id) {
      return -1;
    };

    EmptyListDataSource.prototype.count = function() {
      return 0;
    };

    EmptyListDataSource.prototype.itemsCurrentlyInViewMatching = function(matchFn) {
      return [];
    };

    EmptyListDataSource.prototype.setRetainedRange = function(_arg) {
      var end, start;
      start = _arg.start, end = _arg.end;
    };

    return EmptyListDataSource;

  })(ListDataSource);

  ListDataSource.Empty = EmptyListDataSource;

  module.exports = ListDataSource;

}).call(this);
