(function() {
  var ListTabularItem, React, SwipeContainer, Utils, _,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  React = require('react');

  SwipeContainer = require('./swipe-container')["default"];

  Utils = require('nylas-exports').Utils;

  ListTabularItem = (function(_super) {
    __extends(ListTabularItem, _super);

    function ListTabularItem() {
      this._onClick = __bind(this._onClick, this);
      this._columns = __bind(this._columns, this);
      this.render = __bind(this.render, this);
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      return ListTabularItem.__super__.constructor.apply(this, arguments);
    }

    ListTabularItem.displayName = 'ListTabularItem';

    ListTabularItem.propTypes = {
      metrics: React.PropTypes.object,
      columns: React.PropTypes.arrayOf(React.PropTypes.object).isRequired,
      item: React.PropTypes.object.isRequired,
      itemProps: React.PropTypes.object,
      onSelect: React.PropTypes.func,
      onClick: React.PropTypes.func,
      onDoubleClick: React.PropTypes.func
    };

    ListTabularItem.prototype.shouldComponentUpdate = function(nextProps, nextState) {
      if (!Utils.isEqualReact(this.props.item, nextProps.item) || this.props.columns !== nextProps.columns) {
        this._columnCache = null;
        return true;
      }
      if (!Utils.isEqualReact(Utils.fastOmit(this.props, ['item']), Utils.fastOmit(nextProps, ['item']))) {
        return true;
      }
      return false;
    };

    ListTabularItem.prototype.render = function() {
      var className, props, _ref, _ref1;
      className = "list-item list-tabular-item " + ((_ref = this.props.itemProps) != null ? _ref.className : void 0);
      props = Utils.fastOmit((_ref1 = this.props.itemProps) != null ? _ref1 : {}, ['className']);
      if (this._columnCache == null) {
        this._columnCache = this._columns();
      }
      return React.createElement(SwipeContainer, React.__spread({}, props, {
        "onClick": this._onClick,
        "style": {
          position: 'absolute',
          top: this.props.metrics.top,
          width: '100%',
          height: this.props.metrics.height
        }
      }), React.createElement("div", {
        "className": className,
        "style": {
          height: this.props.metrics.height
        }
      }, this._columnCache));
    };

    ListTabularItem.prototype._columns = function() {
      var column, names, _i, _len, _ref, _ref1, _results;
      names = {};
      _ref1 = (_ref = this.props.columns) != null ? _ref : [];
      _results = [];
      for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
        column = _ref1[_i];
        if (names[column.name]) {
          console.warn("ListTabular: Columns do not have distinct names, will cause React error! `" + column.name + "` twice.");
        }
        names[column.name] = true;
        _results.push(React.createElement("div", {
          "key": column.name,
          "displayName": column.name,
          "style": {
            flex: column.flex,
            width: column.width
          },
          "className": "list-column list-column-" + column.name
        }, column.resolver(this.props.item, this)));
      }
      return _results;
    };

    ListTabularItem.prototype._onClick = function(event) {
      var _base, _base1, _base2;
      if (typeof (_base = this.props).onSelect === "function") {
        _base.onSelect(this.props.item, event);
      }
      if (typeof (_base1 = this.props).onClick === "function") {
        _base1.onClick(this.props.item, event);
      }
      if ((this._lastClickTime != null) && Date.now() - this._lastClickTime < 350) {
        if (typeof (_base2 = this.props).onDoubleClick === "function") {
          _base2.onDoubleClick(this.props.item, event);
        }
      }
      return this._lastClickTime = Date.now();
    };

    return ListTabularItem;

  })(React.Component);

  module.exports = ListTabularItem;

}).call(this);
