(function() {
  var CategoryStore, LabelColorizer, MailLabel, React, RetinaImg,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  RetinaImg = require('./retina-img')["default"];

  CategoryStore = require('../flux/stores/category-store');

  LabelColorizer = {
    color: function(label) {
      return "hsl(" + (label.hue()) + ", 50%, 34%)";
    },
    backgroundColor: function(label) {
      return "hsl(" + (label.hue()) + ", 62%, 87%)";
    },
    backgroundColorDark: function(label) {
      return "hsl(" + (label.hue()) + ", 62%, 57%)";
    },
    styles: function(label) {
      var styles;
      styles = {
        color: LabelColorizer.color(label),
        backgroundColor: LabelColorizer.backgroundColor(label),
        boxShadow: "inset 0 0 1px hsl(" + (label.hue()) + ", 62%, 47%), inset 0 1px 1px rgba(255,255,255,0.5), 0 0.5px 0 rgba(255,255,255,0.5)"
      };
      if (process.platform !== "win32") {
        styles["backgroundImage"] = 'linear-gradient(rgba(255,255,255, 0.4), rgba(255,255,255,0))';
      }
      return styles;
    }
  };

  MailLabel = (function(_super) {
    __extends(MailLabel, _super);

    function MailLabel() {
      return MailLabel.__super__.constructor.apply(this, arguments);
    }

    MailLabel.propTypes = {
      label: React.PropTypes.object.isRequired,
      onRemove: React.PropTypes.func
    };

    MailLabel.prototype.shouldComponentUpdate = function(nextProps, nextState) {
      if (nextProps.label.id === this.props.label.id) {
        return false;
      }
      return true;
    };

    MailLabel.prototype.render = function() {
      var classname, content, x;
      classname = 'mail-label';
      content = this.props.label.displayName;
      x = null;
      if (this._removable()) {
        classname += ' removable';
        content = React.createElement("span", {
          "className": "inner"
        }, content);
        x = React.createElement(RetinaImg, {
          "className": "x",
          "name": "label-x.png",
          "style": {
            backgroundColor: LabelColorizer.color(this.props.label)
          },
          "mode": RetinaImg.Mode.ContentIsMask,
          "onClick": this.props.onRemove
        });
      }
      return React.createElement("div", {
        "className": classname,
        "style": LabelColorizer.styles(this.props.label)
      }, content, x);
    };

    MailLabel.prototype._removable = function() {
      var isLockedLabel;
      isLockedLabel = this.props.label.isLockedCategory();
      return this.props.onRemove && !isLockedLabel;
    };

    return MailLabel;

  })(React.Component);

  module.exports = {
    MailLabel: MailLabel,
    LabelColorizer: LabelColorizer
  };

}).call(this);
