(function() {
  var EdgehillAPI, Flexbox, NewsletterSignup, React, RetinaImg, Utils, request, _, _ref, _ref1,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  request = require('request');

  React = require('react');

  _ref = require("nylas-exports"), Utils = _ref.Utils, EdgehillAPI = _ref.EdgehillAPI;

  _ref1 = require('nylas-component-kit'), RetinaImg = _ref1.RetinaImg, Flexbox = _ref1.Flexbox;

  NewsletterSignup = (function(_super) {
    __extends(NewsletterSignup, _super);

    NewsletterSignup.displayName = 'NewsletterSignup';

    NewsletterSignup.propTypes = {
      name: React.PropTypes.string,
      emailAddress: React.PropTypes.string
    };

    function NewsletterSignup(props) {
      this.props = props;
      this.render = __bind(this.render, this);
      this._path = __bind(this._path, this);
      this._onUnsubscribe = __bind(this._onUnsubscribe, this);
      this._onSubscribe = __bind(this._onSubscribe, this);
      this._onGetStatus = __bind(this._onGetStatus, this);
      this._setState = __bind(this._setState, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.componentWillReceiveProps = __bind(this.componentWillReceiveProps, this);
      this.state = {
        status: 'Pending'
      };
    }

    NewsletterSignup.prototype.componentWillReceiveProps = function(nextProps) {
      if (!_.isEqual(this.props, nextProps)) {
        return this._onGetStatus(nextProps);
      }
    };

    NewsletterSignup.prototype.componentDidMount = function() {
      this._mounted = true;
      return this._onGetStatus();
    };

    NewsletterSignup.prototype.componentWillUnmount = function() {
      return this._mounted = false;
    };

    NewsletterSignup.prototype._setState = function(state) {
      if (!this._mounted) {
        return;
      }
      return this.setState(state);
    };

    NewsletterSignup.prototype._onGetStatus = function(props) {
      if (props == null) {
        props = this.props;
      }
      this._setState({
        status: 'Pending'
      });
      return EdgehillAPI.makeRequest({
        method: 'GET',
        path: this._path(props),
        success: (function(_this) {
          return function(status) {
            if (status === 'Never Subscribed') {
              return _this._onSubscribe();
            } else {
              return _this._setState({
                status: status
              });
            }
          };
        })(this),
        error: (function(_this) {
          return function() {
            return _this._setState({
              status: "Error"
            });
          };
        })(this)
      });
    };

    NewsletterSignup.prototype._onSubscribe = function() {
      this._setState({
        status: 'Pending'
      });
      return EdgehillAPI.makeRequest({
        method: 'POST',
        path: this._path(),
        success: (function(_this) {
          return function(status) {
            return _this._setState({
              status: status
            });
          };
        })(this),
        error: (function(_this) {
          return function() {
            return _this._setState({
              status: "Error"
            });
          };
        })(this)
      });
    };

    NewsletterSignup.prototype._onUnsubscribe = function() {
      this._setState({
        status: 'Pending'
      });
      return EdgehillAPI.makeRequest({
        method: 'DELETE',
        path: this._path(),
        success: (function(_this) {
          return function(status) {
            return _this._setState({
              status: status
            });
          };
        })(this),
        error: (function(_this) {
          return function() {
            return _this._setState({
              status: "Error"
            });
          };
        })(this)
      });
    };

    NewsletterSignup.prototype._path = function(props) {
      if (props == null) {
        props = this.props;
      }
      return "/newsletter-subscription/" + (encodeURIComponent(props.emailAddress)) + "?name=" + (encodeURIComponent(props.name));
    };

    NewsletterSignup.prototype.render = function() {
      return React.createElement(Flexbox, {
        "direction": 'row',
        "height": 'auto',
        "style": {
          textAlign: 'left'
        }
      }, React.createElement("div", {
        "style": {
          minWidth: 15
        }
      }, this._renderControl()), React.createElement("label", {
        "htmlFor": "subscribe-check",
        "style": {
          paddingLeft: 4,
          flex: 1
        }
      }, "Notify me about new features and plugins via this email address."));
    };

    NewsletterSignup.prototype._renderControl = function() {
      var _ref2;
      if (this.state.status === 'Pending') {
        return React.createElement(RetinaImg, {
          "name": 'inline-loading-spinner.gif',
          "mode": RetinaImg.Mode.ContentDark,
          "style": {
            width: 14,
            height: 14
          }
        });
      } else if (this.state.status === 'Error') {
        return React.createElement("button", {
          "onClick": this._onGetStatus,
          "className": "btn"
        }, "Retry");
      } else if ((_ref2 = this.state.status) === 'Subscribed' || _ref2 === 'Active') {
        return React.createElement("input", {
          "id": "subscribe-check",
          "type": "checkbox",
          "checked": true,
          "style": {
            marginTop: 3
          },
          "onChange": this._onUnsubscribe
        });
      } else {
        return React.createElement("input", {
          "id": "subscribe-check",
          "type": "checkbox",
          "checked": false,
          "style": {
            marginTop: 3
          },
          "onChange": this._onSubscribe
        });
      }
    };

    return NewsletterSignup;

  })(React.Component);

  module.exports = NewsletterSignup;

}).call(this);
