(function() {
  var Actions, CategoryStore, Comparator, Flexbox, React, RetinaImg, Rx, SOURCE_SELECT_NULL, ScenarioEditorRow, SourceSelect, Template, Utils, _, _ref, _ref1, _ref2,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  _ = require('underscore');

  Rx = require('rx-lite');

  _ref = require('nylas-component-kit'), RetinaImg = _ref.RetinaImg, Flexbox = _ref.Flexbox;

  _ref1 = require('nylas-exports'), CategoryStore = _ref1.CategoryStore, Actions = _ref1.Actions, Utils = _ref1.Utils;

  _ref2 = require('./scenario-editor-models'), Comparator = _ref2.Comparator, Template = _ref2.Template;

  SOURCE_SELECT_NULL = 'NULL';

  SourceSelect = (function(_super) {
    __extends(SourceSelect, _super);

    SourceSelect.displayName = 'SourceSelect';

    SourceSelect.propTypes = {
      value: React.PropTypes.string,
      onChange: React.PropTypes.func.isRequired,
      options: React.PropTypes.oneOfType([React.PropTypes.object, React.PropTypes.array]).isRequired
    };

    function SourceSelect(props) {
      this.props = props;
      this._onChange = __bind(this._onChange, this);
      this.render = __bind(this.render, this);
      this._setupValuesSubscription = __bind(this._setupValuesSubscription, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentWillReceiveProps = __bind(this.componentWillReceiveProps, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = {
        options: []
      };
    }

    SourceSelect.prototype.componentDidMount = function() {
      return this._setupValuesSubscription();
    };

    SourceSelect.prototype.componentWillReceiveProps = function(nextProps) {
      return this._setupValuesSubscription(nextProps);
    };

    SourceSelect.prototype.componentWillUnmount = function() {
      var _ref3;
      if ((_ref3 = this._subscription) != null) {
        _ref3.dispose();
      }
      return this._subscription = null;
    };

    SourceSelect.prototype._setupValuesSubscription = function(props) {
      var _ref3;
      if (props == null) {
        props = this.props;
      }
      if ((_ref3 = this._subscription) != null) {
        _ref3.dispose();
      }
      this._subscription = null;
      if (props.options instanceof Rx.Observable) {
        return this._subscription = props.options.subscribe((function(_this) {
          return function(options) {
            return _this.setState({
              options: options
            });
          };
        })(this));
      } else {
        return this.setState({
          options: props.options
        });
      }
    };

    SourceSelect.prototype.render = function() {
      var options;
      options = this.state.options;
      return React.createElement("select", {
        "value": this.props.value || SOURCE_SELECT_NULL,
        "onChange": this._onChange
      }, React.createElement("option", {
        "key": SOURCE_SELECT_NULL,
        "value": SOURCE_SELECT_NULL
      }), this.state.options.map((function(_this) {
        return function(_arg) {
          var name, value;
          value = _arg.value, name = _arg.name;
          return React.createElement("option", {
            "key": value,
            "value": value
          }, name);
        };
      })(this)));
    };

    SourceSelect.prototype._onChange = function(event) {
      var value;
      value = event.target.value;
      if (value === SOURCE_SELECT_NULL) {
        value = null;
      }
      return this.props.onChange({
        target: {
          value: value
        }
      });
    };

    return SourceSelect;

  })(React.Component);

  ScenarioEditorRow = (function(_super) {
    __extends(ScenarioEditorRow, _super);

    ScenarioEditorRow.displayName = 'ScenarioEditorRow';

    ScenarioEditorRow.propTypes = {
      instance: React.PropTypes.object.isRequired,
      removable: React.PropTypes.bool,
      templates: React.PropTypes.array.isRequired,
      onChange: React.PropTypes.func,
      onInsert: React.PropTypes.func,
      onRemove: React.PropTypes.func
    };

    function ScenarioEditorRow(props) {
      this.props = props;
      this._onChangeTemplate = __bind(this._onChangeTemplate, this);
      this._onChangeComparator = __bind(this._onChangeComparator, this);
      this._onChangeValue = __bind(this._onChangeValue, this);
      this._renderActions = __bind(this._renderActions, this);
      this._renderValue = __bind(this._renderValue, this);
      this._renderComparator = __bind(this._renderComparator, this);
      this._renderTemplateSelect = __bind(this._renderTemplateSelect, this);
      this.render = __bind(this.render, this);
    }

    ScenarioEditorRow.prototype.render = function() {
      var template;
      template = _.findWhere(this.props.templates, {
        key: this.props.instance.templateKey
      });
      if (!template) {
        return React.createElement("span", null, " Could not find template for instance key: ", this.props.instance.templateKey);
      }
      return React.createElement(Flexbox, {
        "direction": "row",
        "className": "well-row"
      }, React.createElement("span", null, this._renderTemplateSelect(template), this._renderComparator(template), React.createElement("span", null, template.valueLabel), this._renderValue(template)), React.createElement("div", {
        "style": {
          flex: 1
        }
      }), this._renderActions());
    };

    ScenarioEditorRow.prototype._renderTemplateSelect = function(template) {
      var options;
      options = this.props.templates.map((function(_this) {
        return function(_arg) {
          var key, name;
          key = _arg.key, name = _arg.name;
          return React.createElement("option", {
            "value": key,
            "key": key
          }, name);
        };
      })(this));
      return React.createElement("select", {
        "value": this.props.instance.templateKey,
        "onChange": this._onChangeTemplate
      }, options);
    };

    ScenarioEditorRow.prototype._renderComparator = function(template) {
      var options;
      options = _.map(template.comparators, (function(_this) {
        return function(_arg, key) {
          var name;
          name = _arg.name;
          return React.createElement("option", {
            "key": key,
            "value": key
          }, name);
        };
      })(this));
      if (!(options.length > 0)) {
        return false;
      }
      return React.createElement("select", {
        "value": this.props.instance.comparatorKey,
        "onChange": this._onChangeComparator
      }, options);
    };

    ScenarioEditorRow.prototype._renderValue = function(template) {
      if (template.type === Template.Type.Enum) {
        return React.createElement(SourceSelect, {
          "value": this.props.instance.value,
          "onChange": this._onChangeValue,
          "options": template.values
        });
      } else if (template.type === Template.Type.String) {
        return React.createElement("input", {
          "type": "text",
          "value": this.props.instance.value,
          "onChange": this._onChangeValue
        });
      } else {
        return false;
      }
    };

    ScenarioEditorRow.prototype._renderActions = function() {
      return React.createElement("div", {
        "className": "actions"
      }, (this.props.removable ? React.createElement("div", {
        "className": "btn",
        "onClick": this.props.onRemove
      }, "\u2212") : void 0), React.createElement("div", {
        "className": "btn",
        "onClick": this.props.onInsert
      }, "+"));
    };

    ScenarioEditorRow.prototype._onChangeValue = function(event) {
      var instance;
      instance = _.clone(this.props.instance);
      instance.value = event.target.value;
      return this.props.onChange(instance);
    };

    ScenarioEditorRow.prototype._onChangeComparator = function(event) {
      var instance;
      instance = _.clone(this.props.instance);
      instance.comparatorKey = event.target.value;
      return this.props.onChange(instance);
    };

    ScenarioEditorRow.prototype._onChangeTemplate = function(event) {
      var existingTemplate, instance, newTemplate;
      instance = _.clone(this.props.instance);
      existingTemplate = _.findWhere(this.props.templates, {
        key: instance.key
      });
      newTemplate = _.findWhere(this.props.templates, {
        key: event.target.value
      });
      instance = newTemplate.coerceInstance(instance);
      return this.props.onChange(instance);
    };

    return ScenarioEditorRow;

  })(React.Component);

  module.exports = ScenarioEditorRow;

}).call(this);
