(function() {
  var React, ReactDOM, TabGroupRegion,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  React = require('react');

  ReactDOM = require('react-dom');

  TabGroupRegion = (function(_super) {
    __extends(TabGroupRegion, _super);

    function TabGroupRegion() {
      this.getChildContext = __bind(this.getChildContext, this);
      this.shiftFocus = __bind(this.shiftFocus, this);
      this._onKeyDown = __bind(this._onKeyDown, this);
      return TabGroupRegion.__super__.constructor.apply(this, arguments);
    }

    TabGroupRegion.childContextTypes = {
      parentTabGroup: React.PropTypes.object
    };

    TabGroupRegion.prototype._onKeyDown = function(event) {
      var dir;
      if (event.key === "Tab" && !event.defaultPrevented) {
        dir = event.shiftKey ? -1 : 1;
        this.shiftFocus(dir);
        event.preventDefault();
        event.stopPropagation();
      }
    };

    TabGroupRegion.prototype.shiftFocus = function(dir) {
      var current, i, idx, nodes, _i, _ref;
      nodes = ReactDOM.findDOMNode(this).querySelectorAll('input, textarea, [contenteditable], [tabIndex]');
      current = document.activeElement;
      idx = Array.from(nodes).indexOf(current);
      for (i = _i = 0, _ref = nodes.length; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
        idx = idx + dir;
        if (idx < 0) {
          idx = nodes.length - 1;
        } else {
          idx = idx % nodes.length;
        }
        if (nodes[idx].tabIndex === -1) {
          continue;
        }
        nodes[idx].focus();
        if (this._shouldSelectEnd(nodes[idx])) {
          nodes[idx].setSelectionRange(nodes[idx].value.length, nodes[idx].value.length);
        }
        return;
      }
    };

    TabGroupRegion.prototype._shouldSelectEnd = function(node) {
      return node.nodeName === "INPUT" && node.type === "text" && __indexOf.call(node.classList, "no-select-end") < 0;
    };

    TabGroupRegion.prototype.getChildContext = function() {
      return {
        parentTabGroup: this
      };
    };

    TabGroupRegion.prototype.render = function() {
      return React.createElement("div", React.__spread({}, this.props, {
        "onKeyDown": this._onKeyDown
      }), this.props.children);
    };

    return TabGroupRegion;

  })(React.Component);

  module.exports = TabGroupRegion;

}).call(this);
