(function() {
  var CompositeDisposable, Contact, React, ReactDOM, RegExpUtils, RetinaImg, SizeToFitInput, Token, TokenizingTextField, Utils, classNames, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  React = require('react');

  ReactDOM = require('react-dom');

  classNames = require('classnames');

  _ = require('underscore');

  CompositeDisposable = require('event-kit').CompositeDisposable;

  _ref = require('nylas-exports'), Utils = _ref.Utils, Contact = _ref.Contact, RegExpUtils = _ref.RegExpUtils;

  RetinaImg = require('./retina-img')["default"];

  SizeToFitInput = (function(_super) {
    __extends(SizeToFitInput, _super);

    function SizeToFitInput(props) {
      this.props = props;
      this.focus = __bind(this.focus, this);
      this.select = __bind(this.select, this);
      this.render = __bind(this.render, this);
      this._sizeToFit = __bind(this._sizeToFit, this);
      this.componentDidUpdate = __bind(this.componentDidUpdate, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = {};
    }

    SizeToFitInput.prototype.componentDidMount = function() {
      return this._sizeToFit();
    };

    SizeToFitInput.prototype.componentDidUpdate = function() {
      return this._sizeToFit();
    };

    SizeToFitInput.prototype._sizeToFit = function() {
      var input, measure;
      if (this.props.value.length === 0) {
        return;
      }
      input = ReactDOM.findDOMNode(this.refs.input);
      measure = ReactDOM.findDOMNode(this.refs.measure);
      measure.innerText = input.value;
      measure.style.top = input.offsetTop + "px";
      measure.style.left = input.offsetLeft + "px";
      return input.style.width = "" + (measure.offsetWidth + 10) + "px";
    };

    SizeToFitInput.prototype.render = function() {
      return React.createElement("span", null, React.createElement("span", {
        "ref": "measure",
        "style": {
          visibility: 'hidden',
          position: 'absolute'
        }
      }), React.createElement("input", React.__spread({
        "ref": "input",
        "type": "text",
        "style": {
          width: 1
        }
      }, this.props)));
    };

    SizeToFitInput.prototype.select = function() {
      return ReactDOM.findDOMNode(this.refs.input).select();
    };

    SizeToFitInput.prototype.focus = function() {
      return ReactDOM.findDOMNode(this.refs.input).focus();
    };

    return SizeToFitInput;

  })(React.Component);

  Token = (function(_super) {
    __extends(Token, _super);

    Token.displayName = "Token";

    Token.propTypes = {
      className: React.PropTypes.string,
      selected: React.PropTypes.bool,
      valid: React.PropTypes.bool,
      item: React.PropTypes.object,
      onSelected: React.PropTypes.func.isRequired,
      onEdited: React.PropTypes.func,
      onAction: React.PropTypes.func
    };

    Token.defaultProps = {
      className: ''
    };

    function Token(props) {
      this.props = props;
      this._onAction = __bind(this._onAction, this);
      this._onEditFinished = __bind(this._onEditFinished, this);
      this._onEditKeydown = __bind(this._onEditKeydown, this);
      this._onDoubleClick = __bind(this._onDoubleClick, this);
      this._onSelect = __bind(this._onSelect, this);
      this._onDragEnd = __bind(this._onDragEnd, this);
      this._onDragStart = __bind(this._onDragStart, this);
      this._renderViewing = __bind(this._renderViewing, this);
      this._renderEditing = __bind(this._renderEditing, this);
      this.componentWillReceiveProps = __bind(this.componentWillReceiveProps, this);
      this.componentDidUpdate = __bind(this.componentDidUpdate, this);
      this.render = __bind(this.render, this);
      this.state = {
        editing: false,
        editingValue: this.props.item.toString()
      };
    }

    Token.prototype.render = function() {
      if (this.state.editing) {
        return this._renderEditing();
      } else {
        return this._renderViewing();
      }
    };

    Token.prototype.componentDidUpdate = function(prevProps, prevState) {
      if (this.state.editing && !prevState.editing) {
        return this.refs.input.select();
      }
    };

    Token.prototype.componentWillReceiveProps = function(props) {
      if (this.state.editing) {
        return;
      }
      return this.setState({
        editingValue: this.props.item.toString()
      });
    };

    Token.prototype._renderEditing = function() {
      return React.createElement(SizeToFitInput, {
        "ref": "input",
        "className": "token-editing-input",
        "spellCheck": "false",
        "value": this.state.editingValue,
        "onKeyDown": this._onEditKeydown,
        "onBlur": this._onEditFinished,
        "onChange": ((function(_this) {
          return function(event) {
            return _this.setState({
              editingValue: event.target.value
            });
          };
        })(this))
      });
    };

    Token.prototype._renderViewing = function() {
      var classes;
      classes = classNames({
        "token": true,
        "dragging": this.state.dragging,
        "invalid": !this.props.valid,
        "selected": this.props.selected
      });
      return React.createElement("div", {
        "className": "" + classes + " " + this.props.className,
        "onDragStart": this._onDragStart,
        "onDragEnd": this._onDragEnd,
        "draggable": "true",
        "onDoubleClick": this._onDoubleClick,
        "onClick": this._onSelect
      }, (this.props.onAction ? React.createElement("button", {
        "className": "action",
        "onClick": this._onAction,
        "tabIndex": -1.
      }, React.createElement(RetinaImg, {
        "mode": RetinaImg.Mode.ContentIsMask,
        "name": "composer-caret.png"
      })) : void 0), this.props.children);
    };

    Token.prototype._onDragStart = function(event) {
      var json;
      json = JSON.stringify(this.props.item, Utils.registeredObjectReplacer);
      event.dataTransfer.setData('nylas-token-item', json);
      event.dataTransfer.setData('text/plain', this.props.item.toString());
      event.dataTransfer.dropEffect = "move";
      event.dataTransfer.effectAllowed = "move";
      return this.setState({
        dragging: true
      });
    };

    Token.prototype._onDragEnd = function(event) {
      return this.setState({
        dragging: false
      });
    };

    Token.prototype._onSelect = function(event) {
      return this.props.onSelected(this.props.item);
    };

    Token.prototype._onDoubleClick = function(event) {
      if (this.props.onEdited) {
        return this.setState({
          editing: true
        });
      }
    };

    Token.prototype._onEditKeydown = function(event) {
      var _ref1;
      if ((_ref1 = event.key) === 'Escape' || _ref1 === 'Enter') {
        return this._onEditFinished();
      }
    };

    Token.prototype._onEditFinished = function(event) {
      var _base;
      if (typeof (_base = this.props).onEdited === "function") {
        _base.onEdited(this.props.item, this.state.editingValue);
      }
      return this.setState({
        editing: false
      });
    };

    Token.prototype._onAction = function(event) {
      this.props.onAction(this.props.item);
      return event.preventDefault();
    };

    return Token;

  })(React.Component);


  /*
  The TokenizingTextField component displays a list of options as you type
  and converts them into stylable tokens.
  
  It wraps the Menu component, which takes care of the typing and keyboard
  interactions.
  
  See documentation on the propTypes for usage info.
  
  Section: Component Kit
   */

  TokenizingTextField = (function(_super) {
    __extends(TokenizingTextField, _super);

    TokenizingTextField.displayName = "TokenizingTextField";

    TokenizingTextField.containerRequired = false;

    TokenizingTextField.Token = Token;

    TokenizingTextField.propTypes = {
      className: React.PropTypes.string,
      tokens: React.PropTypes.arrayOf(React.PropTypes.object),
      maxTokens: React.PropTypes.number,
      tokenKey: React.PropTypes.func.isRequired,
      tokenIsValid: React.PropTypes.func,
      tokenRenderer: React.PropTypes.func.isRequired,
      tokenClassNames: React.PropTypes.func,
      onRequestCompletions: React.PropTypes.func.isRequired,
      completionNode: React.PropTypes.func.isRequired,
      onAdd: React.PropTypes.func.isRequired,
      onRemove: React.PropTypes.func.isRequired,
      onEdit: React.PropTypes.func,
      onEmptied: React.PropTypes.func,
      onTokenAction: React.PropTypes.oneOfType([React.PropTypes.func, React.PropTypes.bool]),
      onFocus: React.PropTypes.func,
      menuPrompt: React.PropTypes.string,
      menuClassSet: React.PropTypes.object
    };

    TokenizingTextField.defaultProps = {
      className: '',
      tokenClassNames: function() {
        return '';
      }
    };

    function TokenizingTextField(props) {
      this.props = props;
      this._refreshCompletions = __bind(this._refreshCompletions, this);
      this._onPaste = __bind(this._onPaste, this);
      this._onCopy = __bind(this._onCopy, this);
      this._onCut = __bind(this._onCut, this);
      this._showDefaultTokenMenu = __bind(this._showDefaultTokenMenu, this);
      this._removeToken = __bind(this._removeToken, this);
      this._addToken = __bind(this._addToken, this);
      this._selectedToken = __bind(this._selectedToken, this);
      this._selectToken = __bind(this._selectToken, this);
      this._addInputValue = __bind(this._addInputValue, this);
      this.focus = __bind(this.focus, this);
      this._clearInput = __bind(this._clearInput, this);
      this._onInputBlurred = __bind(this._onInputBlurred, this);
      this._onInputChanged = __bind(this._onInputChanged, this);
      this._onInputTrySubmit = __bind(this._onInputTrySubmit, this);
      this._onInputKeydown = __bind(this._onInputKeydown, this);
      this._onInputFocused = __bind(this._onInputFocused, this);
      this._onDrop = __bind(this._onDrop, this);
      this._onClick = __bind(this._onClick, this);
      this._fieldComponents = __bind(this._fieldComponents, this);
      this._renderPrompt = __bind(this._renderPrompt, this);
      this._atMaxTokens = __bind(this._atMaxTokens, this);
      this._placeholder = __bind(this._placeholder, this);
      this._inputEl = __bind(this._inputEl, this);
      this._fieldComponent = __bind(this._fieldComponent, this);
      this.render = __bind(this.render, this);
      this.state = {
        inputValue: "",
        completions: [],
        selectedTokenKey: null
      };
    }

    TokenizingTextField.prototype.componentDidMount = function() {
      return this._mounted = true;
    };

    TokenizingTextField.prototype.componentWillUnmount = function() {
      return this._mounted = false;
    };

    TokenizingTextField.prototype.render = function() {
      var Menu, classSet, classes, _ref1, _ref2;
      Menu = require('nylas-component-kit').Menu;
      classSet = {};
      classSet[this.props.className] = true;
      classes = classNames(_.extend({}, classSet, (_ref1 = this.props.menuClassSet) != null ? _ref1 : {}, {
        "tokenizing-field": true,
        "focused": this.state.focus,
        "empty": ((_ref2 = this.state.inputValue) != null ? _ref2 : "").trim().length === 0
      }));
      return React.createElement(Menu, {
        "className": classes,
        "ref": "completions",
        "items": this.state.completions,
        "itemKey": (function(item) {
          return item.id;
        }),
        "itemContent": this.props.completionNode,
        "headerComponents": [this._fieldComponent()],
        "onFocus": this._onInputFocused,
        "onBlur": this._onInputBlurred,
        "onSelect": this._addToken
      });
    };

    TokenizingTextField.prototype._fieldComponent = function() {
      return React.createElement("div", {
        "key": "field-component",
        "ref": "field-drop-target",
        "onClick": this._onClick,
        "onDrop": this._onDrop
      }, this._renderPrompt(), React.createElement("div", {
        "className": "tokenizing-field-input"
      }, this._placeholder(), this._fieldComponents(), this._inputEl()));
    };

    TokenizingTextField.prototype._inputEl = function() {
      var props;
      props = {
        onCopy: this._onCopy,
        onCut: this._onCut,
        onPaste: this._onPaste,
        onKeyDown: this._onInputKeydown,
        onBlur: this._onInputBlurred,
        onFocus: this._onInputFocused,
        onChange: this._onInputChanged,
        disabled: this.props.disabled,
        tabIndex: 0,
        value: this.state.inputValue
      };
      if (this._atMaxTokens()) {
        props.className = "noop-input";
        props.onFocus = (function(_this) {
          return function() {
            return _this._onInputFocused({
              noCompletions: true
            });
          };
        })(this);
        props.onPaste = (function(_this) {
          return function() {
            return 'noop-input';
          };
        })(this);
        props.onChange = (function(_this) {
          return function() {
            return 'noop';
          };
        })(this);
        props.value = '';
      }
      return React.createElement(SizeToFitInput, React.__spread({
        "ref": "input",
        "spellCheck": "false"
      }, props));
    };

    TokenizingTextField.prototype._placeholder = function() {
      if (!this.state.focus && (this.props.placeholder != null)) {
        return React.createElement("div", {
          "className": "placeholder"
        }, this.props.placeholder);
      } else {
        return React.createElement("span", null);
      }
    };

    TokenizingTextField.prototype._atMaxTokens = function() {
      if (this.props.maxTokens) {
        return this.props.tokens.length >= this.props.maxTokens;
      } else {
        return false;
      }
    };

    TokenizingTextField.prototype._renderPrompt = function() {
      if (this.props.menuPrompt) {
        return React.createElement("div", {
          "className": "tokenizing-field-label"
        }, "" + this.props.menuPrompt + ":");
      } else {
        return React.createElement("div", null);
      }
    };

    TokenizingTextField.prototype._fieldComponents = function() {
      return this.props.tokens.map((function(_this) {
        return function(item) {
          var TokenRenderer, key, onAction, valid;
          key = _this.props.tokenKey(item);
          valid = true;
          if (_this.props.tokenIsValid) {
            valid = _this.props.tokenIsValid(item);
          }
          TokenRenderer = _this.props.tokenRenderer;
          onAction = _this.props.onTokenAction === false ? null : _this.props.onTokenAction || _this._showDefaultTokenMenu;
          return React.createElement(Token, {
            "className": _this.props.tokenClassNames(item),
            "item": item,
            "key": key,
            "valid": valid,
            "selected": _this.state.selectedTokenKey === key,
            "onSelected": _this._selectToken,
            "onEdited": _this.props.onEdit,
            "onAction": onAction
          }, React.createElement(TokenRenderer, {
            "token": item
          }));
        };
      })(this));
    };

    TokenizingTextField.prototype._onClick = function(event) {
      if (event.target.tagName === 'INPUT' && ReactDOM.findDOMNode(this).contains(event.target)) {
        return;
      }
      return this.focus();
    };

    TokenizingTextField.prototype._onDrop = function(event) {
      var data, err, item;
      if (__indexOf.call(event.dataTransfer.types, 'nylas-token-item') < 0) {
        return;
      }
      try {
        data = event.dataTransfer.getData('nylas-token-item');
        item = JSON.parse(data, Utils.registeredObjectReviver);
      } catch (_error) {
        err = _error;
        console.error(err);
        item = null;
      }
      if (item) {
        return this._addToken(item);
      }
    };

    TokenizingTextField.prototype._onInputFocused = function(_arg) {
      var noCompletions, _base;
      noCompletions = (_arg != null ? _arg : {}).noCompletions;
      this.setState({
        focus: true
      });
      if (typeof (_base = this.props).onFocus === "function") {
        _base.onFocus();
      }
      if (!noCompletions) {
        return this._refreshCompletions();
      }
    };

    TokenizingTextField.prototype._onInputKeydown = function(event) {
      var _ref1, _ref2, _ref3;
      if ((_ref1 = event.key) === "Backspace" || _ref1 === "Delete") {
        return this._removeToken();
      } else if ((_ref2 = event.key) === "Escape") {
        return this._refreshCompletions("", {
          clear: true
        });
      } else if ((_ref3 = event.key) === "Tab" || _ref3 === "Enter") {
        return this._onInputTrySubmit(event);
      } else if (event.keyCode === 188) {
        event.preventDefault();
        return this._onInputTrySubmit(event);
      }
    };

    TokenizingTextField.prototype._onInputTrySubmit = function(event) {
      var _ref1;
      if (((_ref1 = this.state.inputValue) != null ? _ref1 : "").trim().length === 0) {
        return;
      }
      event.preventDefault();
      event.stopPropagation();
      if (this.state.completions.length > 0) {
        return this._addToken(this.refs.completions.getSelectedItem() || this.state.completions[0]);
      } else {
        return this._addInputValue();
      }
    };

    TokenizingTextField.prototype._onInputChanged = function(event) {
      var val;
      val = event.target.value.trimLeft();
      this.setState({
        selectedTokenKey: null,
        inputValue: val
      });
      if (RegExpUtils.emailRegex().test(val) && _.last(val) === " ") {
        return this._addInputValue(val.slice(0, -1), {
          skipNameLookup: true
        });
      } else {
        return this._refreshCompletions(val);
      }
    };

    TokenizingTextField.prototype._onInputBlurred = function(event) {
      if (!event.relatedTarget) {
        return;
      }
      if (event.relatedTarget === ReactDOM.findDOMNode(this)) {
        return;
      }
      this._addInputValue();
      this._refreshCompletions("", {
        clear: true
      });
      return this.setState({
        selectedTokenKey: null,
        focus: false
      });
    };

    TokenizingTextField.prototype._clearInput = function() {
      this.setState({
        inputValue: ""
      });
      return this._refreshCompletions("", {
        clear: true
      });
    };

    TokenizingTextField.prototype.focus = function() {
      return this.refs.input.focus();
    };

    TokenizingTextField.prototype._addInputValue = function(input, options) {
      if (options == null) {
        options = {};
      }
      if (this._atMaxTokens()) {
        return;
      }
      if (input == null) {
        input = this.state.inputValue;
      }
      if (input.length === 0) {
        return;
      }
      this.props.onAdd(input, options);
      return this._clearInput();
    };

    TokenizingTextField.prototype._selectToken = function(token) {
      return this.setState({
        selectedTokenKey: this.props.tokenKey(token)
      });
    };

    TokenizingTextField.prototype._selectedToken = function() {
      return _.find(this.props.tokens, (function(_this) {
        return function(t) {
          return _this.props.tokenKey(t) === _this.state.selectedTokenKey;
        };
      })(this));
    };

    TokenizingTextField.prototype._addToken = function(token) {
      if (!token) {
        return;
      }
      this.props.onAdd([token]);
      this._clearInput();
      return this.focus();
    };

    TokenizingTextField.prototype._removeToken = function(token) {
      var tokenToDelete;
      if (token == null) {
        token = null;
      }
      if (this.state.inputValue.trim().length === 0 && this.props.tokens.length === 0 && (this.props.onEmptied != null)) {
        this.props.onEmptied();
      }
      if (token) {
        tokenToDelete = token;
      } else if (this.state.selectedTokenKey) {
        tokenToDelete = this._selectedToken();
      } else if (this.props.tokens.length > 0) {
        this._selectToken(this.props.tokens[this.props.tokens.length - 1]);
      }
      if (tokenToDelete) {
        this.props.onRemove([tokenToDelete]);
        if (this.props.tokenKey(tokenToDelete) === this.state.selectedTokenKey) {
          return this.setState({
            selectedTokenKey: null
          });
        }
      }
    };

    TokenizingTextField.prototype._showDefaultTokenMenu = function(token) {
      var Menu, MenuItem, menu, remote;
      remote = require('electron').remote;
      Menu = remote.Menu, MenuItem = remote.MenuItem;
      menu = new Menu();
      menu.append(new MenuItem({
        label: 'Remove',
        click: (function(_this) {
          return function() {
            return _this._removeToken(token);
          };
        })(this)
      }));
      return menu.popup(remote.getCurrentWindow());
    };

    TokenizingTextField.prototype._onCut = function(event) {
      var _ref1;
      if (this.state.selectedTokenKey) {
        if ((_ref1 = event.clipboardData) != null) {
          _ref1.setData('text/plain', this.props.tokenKey(this._selectedToken()));
        }
        event.preventDefault();
        return this._removeToken(this._selectedToken());
      }
    };

    TokenizingTextField.prototype._onCopy = function(event) {
      if (this.state.selectedTokenKey) {
        event.clipboardData.setData('text/plain', this.props.tokenKey(this._selectedToken()));
        return event.preventDefault();
      }
    };

    TokenizingTextField.prototype._onPaste = function(event) {
      var data;
      data = event.clipboardData.getData('text/plain');
      this._addInputValue(data);
      return event.preventDefault();
    };

    TokenizingTextField.prototype._refreshCompletions = function(val, _arg) {
      var clear, existingKeys, filterTokens, tokensOrPromise;
      if (val == null) {
        val = this.state.inputValue;
      }
      clear = (_arg != null ? _arg : {}).clear;
      existingKeys = _.map(this.props.tokens, this.props.tokenKey);
      filterTokens = (function(_this) {
        return function(tokens) {
          return _.reject(tokens, function(t) {
            var _ref1;
            return _ref1 = _this.props.tokenKey(t), __indexOf.call(existingKeys, _ref1) >= 0;
          });
        };
      })(this);
      tokensOrPromise = this.props.onRequestCompletions(val, {
        clear: clear
      });
      if (_.isArray(tokensOrPromise)) {
        return this.setState({
          completions: filterTokens(tokensOrPromise)
        });
      } else if (tokensOrPromise instanceof Promise) {
        return tokensOrPromise.then((function(_this) {
          return function(tokens) {
            if (!_this._mounted) {
              return;
            }
            return _this.setState({
              completions: filterTokens(tokens)
            });
          };
        })(this));
      } else {
        console.warn("onRequestCompletions returned an invalid type. It must return an Array of tokens or a Promise that resolves to an array of tokens");
        return this.setState({
          completions: []
        });
      }
    };

    return TokenizingTextField;

  })(React.Component);

  module.exports = TokenizingTextField;

}).call(this);
