(function() {
  var DeprecateUtils;

  DeprecateUtils = (function() {
    function DeprecateUtils() {}

    DeprecateUtils.parseStack = function(stackString) {
      var stack;
      stack = stackString.replace(/^[^\(]+?[\n$]/gm, '').replace(/^\s+at\s+/gm, '').replace(/^Object.<anonymous>\s*\(/gm, '{anonymous}()@').split('\n');
      return stack;
    };

    DeprecateUtils.warn = function(condition, message) {
      if (condition) {
        return console.warn(message);
      }
    };

    DeprecateUtils.deprecate = function(fnName, newName, ctx, fn) {
      var newFn, warn;
      if (NylasEnv.inDevMode() && !NylasEnv.inSpecMode()) {
        warn = true;
        newFn = (function(_this) {
          return function() {
            var stack;
            stack = DeprecateUtils.parseStack((new Error()).stack);
            DeprecateUtils.warn(warn, "Deprecation warning! " + fnName + " is deprecated and will be removed soon. Use " + newName + " instead.\nCheck your code at " + stack[1]);
            warn = false;
            return fn.apply(ctx, arguments);
          };
        })(this);
        return Object.assign(newFn, fn);
      }
      return fn;
    };

    return DeprecateUtils;

  })();

  module.exports = DeprecateUtils;

}).call(this);
