(function() {
  var Attribute, AttributeBoolean, AttributeCollection, AttributeDateTime, AttributeJoinedData, AttributeNumber, AttributeObject, AttributeServerId, AttributeString, Matcher, SortOrder;

  Matcher = require('./attributes/matcher');

  SortOrder = require('./attributes/sort-order');

  Attribute = require('./attributes/attribute');

  AttributeNumber = require('./attributes/attribute-number');

  AttributeString = require('./attributes/attribute-string');

  AttributeObject = require('./attributes/attribute-object');

  AttributeBoolean = require('./attributes/attribute-boolean');

  AttributeDateTime = require('./attributes/attribute-datetime');

  AttributeCollection = require('./attributes/attribute-collection');

  AttributeJoinedData = require('./attributes/attribute-joined-data');

  AttributeServerId = require('./attributes/attribute-serverid');

  module.exports = {
    Matcher: Matcher,
    SortOrder: SortOrder,
    Number: function() {
      return (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(AttributeNumber, arguments, function(){});
    },
    String: function() {
      return (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(AttributeString, arguments, function(){});
    },
    Object: function() {
      return (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(AttributeObject, arguments, function(){});
    },
    Boolean: function() {
      return (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(AttributeBoolean, arguments, function(){});
    },
    DateTime: function() {
      return (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(AttributeDateTime, arguments, function(){});
    },
    Collection: function() {
      return (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(AttributeCollection, arguments, function(){});
    },
    JoinedData: function() {
      return (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(AttributeJoinedData, arguments, function(){});
    },
    ServerId: function() {
      return (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(AttributeServerId, arguments, function(){});
    },
    AttributeNumber: AttributeNumber,
    AttributeString: AttributeString,
    AttributeObject: AttributeObject,
    AttributeBoolean: AttributeBoolean,
    AttributeDateTime: AttributeDateTime,
    AttributeCollection: AttributeCollection,
    AttributeJoinedData: AttributeJoinedData,
    AttributeServerId: AttributeServerId
  };

}).call(this);
