(function() {
  var Attribute, AttributeBoolean, tableNameForJoin, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  tableNameForJoin = require('../models/utils').tableNameForJoin;

  Attribute = require('./attribute');


  /*
  Public: The value of this attribute is always a boolean. Null values are coerced to false.
  
  String attributes can be queries using `equal` and `not`. Matching on
  `greaterThan` and `lessThan` is not supported.
  
  Section: Database
   */

  AttributeBoolean = (function(_super) {
    __extends(AttributeBoolean, _super);

    function AttributeBoolean() {
      return AttributeBoolean.__super__.constructor.apply(this, arguments);
    }

    AttributeBoolean.prototype.toJSON = function(val) {
      return val;
    };

    AttributeBoolean.prototype.fromJSON = function(val) {
      return (val === 'true' || val === true) || false;
    };

    AttributeBoolean.prototype.columnSQL = function() {
      return "" + this.jsonKey + " INTEGER";
    };

    return AttributeBoolean;

  })(Attribute);

  module.exports = AttributeBoolean;

}).call(this);
