(function() {
  var Attribute, AttributeDateTime, Matcher, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Attribute = require('./attribute');

  Matcher = require('./matcher');


  /*
  Public: The value of this attribute is always a Javascript `Date`, or `null`.
  
  Section: Database
   */

  AttributeDateTime = (function(_super) {
    __extends(AttributeDateTime, _super);

    function AttributeDateTime() {
      return AttributeDateTime.__super__.constructor.apply(this, arguments);
    }

    AttributeDateTime.prototype.toJSON = function(val) {
      if (!val) {
        return null;
      }
      if (!(val instanceof Date)) {
        throw new Error("Attempting to toJSON AttributeDateTime which is not a date: " + this.modelKey + " = " + val);
      }
      return val.getTime() / 1000.0;
    };

    AttributeDateTime.prototype.fromJSON = function(val) {
      if (!val) {
        return null;
      }
      return new Date(val * 1000);
    };

    AttributeDateTime.prototype.columnSQL = function() {
      return "" + this.jsonKey + " INTEGER";
    };

    AttributeDateTime.prototype.greaterThan = function(val) {
      if (val == null) {
        throw new Error("AttributeDateTime::greaterThan (" + this.modelKey + ") - you must provide a value");
      }
      if (!this.queryable) {
        throw new Error("AttributeDateTime::greaterThan (" + this.modelKey + ") - this field cannot be queried against");
      }
      return new Matcher(this, '>', val);
    };

    AttributeDateTime.prototype.lessThan = function(val) {
      if (val == null) {
        throw new Error("AttributeDateTime::lessThan (" + this.modelKey + ") - you must provide a value");
      }
      if (!this.queryable) {
        throw new Error("AttributeDateTime::lessThan (" + this.modelKey + ") - this field cannot be queried against");
      }
      return new Matcher(this, '<', val);
    };

    AttributeDateTime.prototype.greaterThanOrEqualTo = function(val) {
      if (val == null) {
        throw new Error("AttributeNumber::greaterThanOrEqualTo (" + this.modelKey + ") - you must provide a value");
      }
      if (!this.queryable) {
        throw new Error("AttributeNumber::greaterThanOrEqualTo (" + this.modelKey + ") - this field cannot be queried against");
      }
      return new Matcher(this, '>=', val);
    };

    AttributeDateTime.prototype.lessThanOrEqualTo = function(val) {
      if (val == null) {
        throw new Error("AttributeNumber::lessThanOrEqualTo (" + this.modelKey + ") - you must provide a value");
      }
      if (!this.queryable) {
        throw new Error("AttributeNumber::lessThanOrEqualTo (" + this.modelKey + ") - this field cannot be queried against");
      }
      return new Matcher(this, '<=', val);
    };

    return AttributeDateTime;

  })(Attribute);

  module.exports = AttributeDateTime;

}).call(this);
