(function() {
  var Attribute, AttributeNumber, Matcher, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Attribute = require('./attribute');

  Matcher = require('./matcher');


  /*
  Public: The value of this attribute is always a number, or null.
  
  Section: Database
   */

  AttributeNumber = (function(_super) {
    __extends(AttributeNumber, _super);

    function AttributeNumber() {
      return AttributeNumber.__super__.constructor.apply(this, arguments);
    }

    AttributeNumber.prototype.toJSON = function(val) {
      return val;
    };

    AttributeNumber.prototype.fromJSON = function(val) {
      if (!isNaN(val)) {
        return Number(val);
      } else {
        return null;
      }
    };

    AttributeNumber.prototype.columnSQL = function() {
      return "" + this.jsonKey + " INTEGER";
    };

    AttributeNumber.prototype.greaterThan = function(val) {
      if (val == null) {
        throw new Error("AttributeNumber::greaterThan (" + this.modelKey + ") - you must provide a value");
      }
      if (!this.queryable) {
        throw new Error("AttributeNumber::greaterThan (" + this.modelKey + ") - this field cannot be queried against");
      }
      return new Matcher(this, '>', val);
    };

    AttributeNumber.prototype.lessThan = function(val) {
      if (val == null) {
        throw new Error("AttributeNumber::lessThan (" + this.modelKey + ") - you must provide a value");
      }
      if (!this.queryable) {
        throw new Error("AttributeNumber::lessThan (" + this.modelKey + ") - this field cannot be queried against");
      }
      return new Matcher(this, '<', val);
    };

    AttributeNumber.prototype.greaterThanOrEqualTo = function(val) {
      if (val == null) {
        throw new Error("AttributeNumber::greaterThanOrEqualTo (" + this.modelKey + ") - you must provide a value");
      }
      if (!this.queryable) {
        throw new Error("AttributeNumber::greaterThanOrEqualTo (" + this.modelKey + ") - this field cannot be queried against");
      }
      return new Matcher(this, '>=', val);
    };

    AttributeNumber.prototype.lessThanOrEqualTo = function(val) {
      if (val == null) {
        throw new Error("AttributeNumber::lessThanOrEqualTo (" + this.modelKey + ") - you must provide a value");
      }
      if (!this.queryable) {
        throw new Error("AttributeNumber::lessThanOrEqualTo (" + this.modelKey + ") - this field cannot be queried against");
      }
      return new Matcher(this, '<=', val);
    };

    AttributeNumber.prototype.gt = AttributeNumber.prototype.greaterThan;

    AttributeNumber.prototype.lt = AttributeNumber.prototype.lessThan;

    AttributeNumber.prototype.gte = AttributeNumber.prototype.greaterThanOrEqualTo;

    AttributeNumber.prototype.lte = AttributeNumber.prototype.lessThanOrEqualTo;

    return AttributeNumber;

  })(Attribute);

  module.exports = AttributeNumber;

}).call(this);
