(function() {
  var Attribute, AttributeString, Matcher,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Attribute = require('./attribute');

  Matcher = require('./matcher');


  /*
  Public: The value of this attribute is always a string or `null`.
  
  String attributes can be queries using `equal`, `not`, and `startsWith`. Matching on
  `greaterThan` and `lessThan` is not supported.
  
  Section: Database
   */

  AttributeString = (function(_super) {
    __extends(AttributeString, _super);

    function AttributeString() {
      return AttributeString.__super__.constructor.apply(this, arguments);
    }

    AttributeString.prototype.toJSON = function(val) {
      return val;
    };

    AttributeString.prototype.fromJSON = function(val) {
      if (val === null || val === void 0 || val === false) {
        return null;
      }
      return val + "";
    };

    AttributeString.prototype.startsWith = function(val) {
      return new Matcher(this, 'startsWith', val);
    };

    AttributeString.prototype.columnSQL = function() {
      return "" + this.jsonKey + " TEXT";
    };

    AttributeString.prototype.like = function(val) {
      if (val == null) {
        throw new Error("AttributeString::like (" + this.modelKey + ") - you must provide a value");
      }
      if (!this.queryable) {
        throw new Error("AttributeString::like (" + this.modelKey + ") - this field cannot be queried against");
      }
      return new Matcher(this, 'like', val);
    };

    return AttributeString;

  })(Attribute);

  module.exports = AttributeString;

}).call(this);
