(function() {
  var CoffeeHelpers, _;

  _ = require('underscore');

  module.exports = CoffeeHelpers = {
    includeModule: function(mixin) {
      var funct, methodName, tmpSuper, _ref;
      if (!mixin) {
        throw new Error('Supplied mixin was not found');
      }
      if (!_) {
        throw new Error('Underscore was not found');
      }
      if (_.isFunction(mixin)) {
        mixin = mixin.prototype;
      }
      if (this.__super__) {
        tmpSuper = _.extend({}, this.__super__);
        tmpSuper.constructor = this.__super__.constructor;
      }
      this.__super__ = tmpSuper || {};
      for (methodName in mixin) {
        funct = mixin[methodName];
        if (!(methodName !== 'included')) {
          continue;
        }
        this.__super__[methodName] = funct;
        if (!this.prototype.hasOwnProperty(methodName)) {
          this.prototype[methodName] = funct;
        }
      }
      if ((_ref = mixin.included) != null) {
        _ref.apply(this);
      }
      return this;
    },
    extendModule: function(module) {
      var key, value;
      if (module == null) {
        console.warn("The module you are trying to extend does not exist. Ensure you have put it on this page's manifest.");
      }
      if (_.isFunction(module)) {
        module = module();
      }
      for (key in module) {
        value = module[key];
        this[key] = value;
      }
      return this;
    },
    simpleInclude: function(module) {
      var key, value;
      if (module == null) {
        console.warn("The module you are trying to include does not exist. Ensure you have put it on this page's manifest.");
      }
      if (_.isFunction(module)) {
        module = module();
      }
      for (key in module) {
        value = module[key];
        this.prototype[key] = value;
      }
      return this;
    },
    boundInclude: function(module, _super) {
      var key, value, _ref;
      if (module == null) {
        console.warn("The module you are trying to include does not exist. Ensure you have put it on this page's manifest.");
        return;
      }
      if (!_.isFunction(module)) {
        console.warn("To do a scoped include the Module must be a function instead of a plain old javascript object thereby allowing `this` to be bound properly.");
        return;
      }
      _ref = module.call(this, _super);
      for (key in _ref) {
        value = _ref[key];
        if (this[key] == null) {
          this[key] = value;
        }
      }
      return this;
    }
  };

}).call(this);
