(function() {
  var Attributes, Calendar, Model, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Model = require('./model');

  Attributes = require('../attributes');

  _ = require('underscore');


  /*
  Public: The Calendar model represents a Calendar object served by the
  Nylas Platform API.  For more information about Calendar on the Nylas
  Platform, read the [Calendar API
  Documentation](https://nylas.com/docs/api#calendar)
  
   *# Attributes
  
  `name`: {AttributeString} The name of the calendar.
  
  `description`: {AttributeString} The description of the calendar.
  
  This class also inherits attributes from {Model}
  
  Section: Models
   */

  Calendar = (function(_super) {
    __extends(Calendar, _super);

    function Calendar() {
      return Calendar.__super__.constructor.apply(this, arguments);
    }

    Calendar.attributes = _.extend({}, Model.attributes, {
      'name': Attributes.String({
        modelKey: 'name',
        jsonKey: 'name'
      }),
      'description': Attributes.String({
        modelKey: 'description',
        jsonKey: 'description'
      }),
      'readOnly': Attributes.Boolean({
        modelKey: 'readOnly',
        jsonKey: 'read_only'
      })
    });

    return Calendar;

  })(Model);

  module.exports = Calendar;

}).call(this);
