(function() {
  var AccountStore, DatabaseStore, NylasStore, Rx, TaskQueue, TaskQueueStatusStore, _,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Rx = require('rx-lite');

  NylasStore = require('nylas-store');

  DatabaseStore = require('./database-store');

  AccountStore = require('./account-store');

  TaskQueue = require('./task-queue');

  TaskQueueStatusStore = (function(_super) {
    __extends(TaskQueueStatusStore, _super);

    function TaskQueueStatusStore() {
      this.waitForPerformRemote = __bind(this.waitForPerformRemote, this);
      this.waitForPerformLocal = __bind(this.waitForPerformLocal, this);
      var query;
      this._queue = [];
      this._waitingLocals = [];
      this._waitingRemotes = [];
      query = DatabaseStore.findJSONBlob(TaskQueue.JSONBlobStorageKey);
      Rx.Observable.fromQuery(query).subscribe((function(_this) {
        return function(json) {
          _this._queue = json || [];
          _this._waitingLocals = _this._waitingLocals.filter(function(_arg) {
            var queuedTask, resolve, task;
            task = _arg.task, resolve = _arg.resolve;
            queuedTask = _.findWhere(_this._queue, {
              id: task.id
            });
            if (!queuedTask || queuedTask.queueState.localComplete) {
              resolve(task);
              return false;
            }
            return true;
          });
          _this._waitingRemotes = _this._waitingRemotes.filter(function(_arg) {
            var queuedTask, resolve, task;
            task = _arg.task, resolve = _arg.resolve;
            queuedTask = _.findWhere(_this._queue, {
              id: task.id
            });
            if (!queuedTask) {
              resolve(task);
              return false;
            }
            return true;
          });
          return _this.trigger();
        };
      })(this));
    }

    TaskQueueStatusStore.prototype.queue = function() {
      return this._queue;
    };

    TaskQueueStatusStore.prototype.waitForPerformLocal = function(task) {
      return new Promise((function(_this) {
        return function(resolve, reject) {
          return _this._waitingLocals.push({
            task: task,
            resolve: resolve
          });
        };
      })(this));
    };

    TaskQueueStatusStore.prototype.waitForPerformRemote = function(task) {
      return new Promise((function(_this) {
        return function(resolve, reject) {
          return _this._waitingRemotes.push({
            task: task,
            resolve: resolve
          });
        };
      })(this));
    };

    TaskQueueStatusStore.prototype.tasksMatching = function(type, matching) {
      if (matching == null) {
        matching = {};
      }
      if (!_.isString(type)) {
        type = type.name;
      }
      return this._queue.filter(function(task) {
        return task.constructor.name === type && _.isMatch(task, matching);
      });
    };

    return TaskQueueStatusStore;

  })(NylasStore);

  module.exports = new TaskQueueStatusStore();

}).call(this);
