(function() {
  var NylasComponentKit;

  NylasComponentKit = (function() {
    function NylasComponentKit() {}

    NylasComponentKit["default"] = function(requireValue) {
      var _ref;
      return (_ref = requireValue["default"]) != null ? _ref : requireValue;
    };

    NylasComponentKit.load = function(prop, path) {
      return Object.defineProperty(this.prototype, prop, {
        get: function() {
          return NylasComponentKit["default"](require("../components/" + path));
        }
      });
    };

    NylasComponentKit.loadFrom = function(prop, path) {
      return Object.defineProperty(this.prototype, prop, {
        get: function() {
          var exported;
          exported = require("../components/" + path);
          return exported[prop];
        }
      });
    };

    NylasComponentKit.loadDeprecated = function(prop, path, _arg) {
      var deprecate, instead;
      instead = (_arg != null ? _arg : {}).instead;
      deprecate = require('../deprecate-utils').deprecate;
      return Object.defineProperty(this.prototype, prop, {
        get: deprecate(prop, instead, this, function() {
          var exported;
          exported = NylasComponentKit["default"](require("../components/" + path));
          return exported;
        }),
        enumerable: true
      });
    };

    NylasComponentKit.load("Menu", 'menu');

    NylasComponentKit.load("DropZone", 'drop-zone');

    NylasComponentKit.load("Spinner", 'spinner');

    NylasComponentKit.load("Switch", 'switch');

    NylasComponentKit.loadDeprecated("Popover", 'popover', {
      instead: 'Actions.openPopover'
    });

    NylasComponentKit.load("FixedPopover", 'fixed-popover');

    NylasComponentKit.load("Modal", 'modal');

    NylasComponentKit.load("Flexbox", 'flexbox');

    NylasComponentKit.load("RetinaImg", 'retina-img');

    NylasComponentKit.load("SwipeContainer", 'swipe-container');

    NylasComponentKit.load("FluxContainer", 'flux-container');

    NylasComponentKit.load("FocusContainer", 'focus-container');

    NylasComponentKit.load("EmptyListState", 'empty-list-state');

    NylasComponentKit.load("ListTabular", 'list-tabular');

    NylasComponentKit.load("DraggableImg", 'draggable-img');

    NylasComponentKit.load("NylasCalendar", 'nylas-calendar/nylas-calendar');

    NylasComponentKit.load("MiniMonthView", 'nylas-calendar/mini-month-view');

    NylasComponentKit.load("EventedIFrame", 'evented-iframe');

    NylasComponentKit.load("ButtonDropdown", 'button-dropdown');

    NylasComponentKit.load("Contenteditable", 'contenteditable/contenteditable');

    NylasComponentKit.load("MultiselectList", 'multiselect-list');

    NylasComponentKit.load("KeyCommandsRegion", 'key-commands-region');

    NylasComponentKit.load("TabGroupRegion", 'tab-group-region');

    NylasComponentKit.load("InjectedComponent", 'injected-component');

    NylasComponentKit.load("TokenizingTextField", 'tokenizing-text-field');

    NylasComponentKit.load("ParticipantsTextField", 'participants-text-field');

    NylasComponentKit.loadDeprecated("MultiselectActionBar", 'multiselect-action-bar', {
      instead: 'MultiselectToolbar'
    });

    NylasComponentKit.load("MultiselectToolbar", 'multiselect-toolbar');

    NylasComponentKit.load("InjectedComponentSet", 'injected-component-set');

    NylasComponentKit.load("MetadataComposerToggleButton", 'metadata-composer-toggle-button');

    NylasComponentKit.load("ConfigPropContainer", "config-prop-container");

    NylasComponentKit.load("DisclosureTriangle", "disclosure-triangle");

    NylasComponentKit.load("EditableList", "editable-list");

    NylasComponentKit.load("OutlineViewItem", "outline-view-item");

    NylasComponentKit.load("OutlineView", "outline-view");

    NylasComponentKit.load("DateInput", "date-input");

    NylasComponentKit.load("DatePicker", "date-picker");

    NylasComponentKit.load("TimePicker", "time-picker");

    NylasComponentKit.load("Table", "table/table");

    NylasComponentKit.loadFrom("TableRow", "table/table");

    NylasComponentKit.loadFrom("TableCell", "table/table");

    NylasComponentKit.load("SelectableTable", "selectable-table");

    NylasComponentKit.loadFrom("SelectableTableRow", "selectable-table");

    NylasComponentKit.loadFrom("SelectableTableCell", "selectable-table");

    NylasComponentKit.load("EditableTable", "editable-table");

    NylasComponentKit.loadFrom("EditableTableCell", "editable-table");

    NylasComponentKit.load("LazyRenderedList", "lazy-rendered-list");

    NylasComponentKit.load("OverlaidComponents", "overlaid-components/overlaid-components");

    NylasComponentKit.load("OverlaidComposerExtension", "overlaid-components/overlaid-composer-extension");

    NylasComponentKit.load("ScrollRegion", 'scroll-region');

    NylasComponentKit.load("ResizableRegion", 'resizable-region');

    NylasComponentKit.loadFrom("MailLabel", "mail-label");

    NylasComponentKit.loadFrom("LabelColorizer", "mail-label");

    NylasComponentKit.load("MailLabelSet", "mail-label-set");

    NylasComponentKit.load("MailImportantIcon", 'mail-important-icon');

    NylasComponentKit.loadFrom("FormItem", "generated-form");

    NylasComponentKit.loadFrom("GeneratedForm", "generated-form");

    NylasComponentKit.loadFrom("GeneratedFieldset", "generated-form");

    NylasComponentKit.load("ScenarioEditor", 'scenario-editor');

    NylasComponentKit.load("NewsletterSignup", 'newsletter-signup');

    NylasComponentKit.load("ListensToObservable", 'decorators/listens-to-observable');

    NylasComponentKit.load("ListensToFluxStore", 'decorators/listens-to-flux-store');

    NylasComponentKit.load("ListensToMovementKeys", 'decorators/listens-to-movement-keys');

    return NylasComponentKit;

  })();

  module.exports = new NylasComponentKit();

}).call(this);
