(function() {
  var DatabaseObjectRegistry, NylasExports, RequireCache, StoreRegistry, TaskRegistry;

  TaskRegistry = require('../task-registry')["default"];

  StoreRegistry = require('../store-registry')["default"];

  DatabaseObjectRegistry = require('../database-object-registry')["default"];

  RequireCache = {};

  NylasExports = (function() {
    function NylasExports() {}

    NylasExports["default"] = function(requireValue) {
      var _ref;
      return (_ref = requireValue["default"]) != null ? _ref : requireValue;
    };

    NylasExports.lazyLoad = function(prop, path) {
      return Object.defineProperty(this, prop, {
        get: function() {
          var key;
          key = "" + prop + path;
          RequireCache[key] = RequireCache[key] || NylasExports["default"](require("../" + path));
          return RequireCache[key];
        },
        enumerable: true
      });
    };

    NylasExports.lazyLoadCustomGetter = function(prop, get) {
      return Object.defineProperty(this, prop, {
        get: get,
        enumerable: true
      });
    };

    NylasExports.lazyLoadAndRegisterStore = function(klassName, path) {
      var constructorFactory;
      constructorFactory = function() {
        return NylasExports["default"](require("../flux/stores/" + path));
      };
      StoreRegistry.register(klassName, constructorFactory);
      return this.lazyLoad(klassName, "flux/stores/" + path);
    };

    NylasExports.lazyLoadAndRegisterModel = function(klassName, path) {
      var constructorFactory;
      constructorFactory = function() {
        return NylasExports["default"](require("../flux/models/" + path));
      };
      DatabaseObjectRegistry.register(klassName, constructorFactory);
      return this.lazyLoad(klassName, "flux/models/" + path);
    };

    NylasExports.lazyLoadAndRegisterTask = function(klassName, path) {
      var constructorFactory;
      constructorFactory = function() {
        return NylasExports["default"](require("../flux/tasks/" + path));
      };
      TaskRegistry.register(klassName, constructorFactory);
      return this.lazyLoad(klassName, "flux/tasks/" + path);
    };

    NylasExports.lazyLoadDeprecated = function(prop, path, _arg) {
      var deprecate, instead;
      instead = (_arg != null ? _arg : {}).instead;
      deprecate = require('../deprecate-utils').deprecate;
      return Object.defineProperty(this, prop, {
        get: deprecate(prop, instead, this, function() {
          return NylasExports["default"](require("../" + path));
        }),
        enumerable: true
      });
    };

    NylasExports.lazyLoad("Actions", 'flux/actions');

    NylasExports.lazyLoad("NylasAPI", 'flux/nylas-api');

    NylasExports.lazyLoad("EdgehillAPI", 'flux/edgehill-api');

    NylasExports.lazyLoad("NylasSyncStatusStore", 'flux/stores/nylas-sync-status-store');

    NylasExports.lazyLoad("Matcher", 'flux/attributes/matcher');

    NylasExports.lazyLoad("DatabaseStore", 'flux/stores/database-store');

    NylasExports.lazyLoad("QueryResultSet", 'flux/models/query-result-set');

    NylasExports.lazyLoad("QuerySubscription", 'flux/models/query-subscription');

    NylasExports.lazyLoad("CalendarDataSource", 'components/nylas-calendar/calendar-data-source');

    NylasExports.lazyLoad("DatabaseTransaction", 'flux/stores/database-transaction');

    NylasExports.lazyLoad("MutableQueryResultSet", 'flux/models/mutable-query-result-set');

    NylasExports.lazyLoad("QuerySubscriptionPool", 'flux/models/query-subscription-pool');

    NylasExports.lazyLoad("ObservableListDataSource", 'flux/stores/observable-list-data-source');

    NylasExports.lazyLoad("MutableQuerySubscription", 'flux/models/mutable-query-subscription');

    NylasExports.DatabaseObjectRegistry = DatabaseObjectRegistry;

    NylasExports.lazyLoad("Model", 'flux/models/model');

    NylasExports.lazyLoad("Attributes", 'flux/attributes');

    NylasExports.lazyLoadAndRegisterModel("File", 'file');

    NylasExports.lazyLoadAndRegisterModel("Event", 'event');

    NylasExports.lazyLoadAndRegisterModel("Label", 'label');

    NylasExports.lazyLoadAndRegisterModel("Folder", 'folder');

    NylasExports.lazyLoadAndRegisterModel("Thread", 'thread');

    NylasExports.lazyLoadAndRegisterModel("Account", 'account');

    NylasExports.lazyLoadAndRegisterModel("Message", 'message');

    NylasExports.lazyLoadAndRegisterModel("Contact", 'contact');

    NylasExports.lazyLoadAndRegisterModel("Category", 'category');

    NylasExports.lazyLoadAndRegisterModel("Calendar", 'calendar');

    NylasExports.lazyLoadAndRegisterModel("JSONBlob", 'json-blob');

    NylasExports.TaskRegistry = TaskRegistry;

    NylasExports.lazyLoad("Task", 'flux/tasks/task');

    NylasExports.lazyLoad("TaskFactory", 'flux/tasks/task-factory');

    NylasExports.lazyLoadAndRegisterTask("EventRSVPTask", 'event-rsvp-task');

    NylasExports.lazyLoadAndRegisterTask("BaseDraftTask", 'base-draft-task');

    NylasExports.lazyLoadAndRegisterTask("SendDraftTask", 'send-draft-task');

    NylasExports.lazyLoadAndRegisterTask("MultiSendToIndividualTask", 'multi-send-to-individual-task');

    NylasExports.lazyLoadAndRegisterTask("MultiSendSessionCloseTask", 'multi-send-session-close-task');

    NylasExports.lazyLoadAndRegisterTask("ChangeMailTask", 'change-mail-task');

    NylasExports.lazyLoadAndRegisterTask("DestroyDraftTask", 'destroy-draft-task');

    NylasExports.lazyLoadAndRegisterTask("ChangeLabelsTask", 'change-labels-task');

    NylasExports.lazyLoadAndRegisterTask("ChangeFolderTask", 'change-folder-task');

    NylasExports.lazyLoadAndRegisterTask("ChangeUnreadTask", 'change-unread-task');

    NylasExports.lazyLoadAndRegisterTask("DestroyModelTask", 'destroy-model-task');

    NylasExports.lazyLoadAndRegisterTask("SyncbackDraftTask", 'syncback-draft-task');

    NylasExports.lazyLoadAndRegisterTask("ChangeStarredTask", 'change-starred-task');

    NylasExports.lazyLoadAndRegisterTask("SyncbackModelTask", 'syncback-model-task');

    NylasExports.lazyLoadAndRegisterTask("DestroyCategoryTask", 'destroy-category-task');

    NylasExports.lazyLoadAndRegisterTask("SyncbackCategoryTask", 'syncback-category-task');

    NylasExports.lazyLoadAndRegisterTask("SyncbackMetadataTask", 'syncback-metadata-task');

    NylasExports.lazyLoadAndRegisterTask("SyncbackDraftFilesTask", 'syncback-draft-files-task');

    NylasExports.lazyLoadAndRegisterTask("ReprocessMailRulesTask", 'reprocess-mail-rules-task');

    NylasExports.lazyLoadAndRegisterTask("NotifyPluginsOfSendTask", 'notify-plugins-of-send-task');

    NylasExports.lazyLoadAndRegisterStore("TaskQueue", 'task-queue');

    NylasExports.lazyLoadAndRegisterStore("BadgeStore", 'badge-store');

    NylasExports.lazyLoadAndRegisterStore("DraftStore", 'draft-store');

    NylasExports.lazyLoadAndRegisterStore("ModalStore", 'modal-store');

    NylasExports.lazyLoadAndRegisterStore("OutboxStore", 'outbox-store');

    NylasExports.lazyLoadAndRegisterStore("PopoverStore", 'popover-store');

    NylasExports.lazyLoadAndRegisterStore("AccountStore", 'account-store');

    NylasExports.lazyLoadAndRegisterStore("MessageStore", 'message-store');

    NylasExports.lazyLoadAndRegisterStore("ContactStore", 'contact-store');

    NylasExports.lazyLoadAndRegisterStore("IdentityStore", 'identity-store');

    NylasExports.lazyLoadAndRegisterStore("MetadataStore", 'metadata-store');

    NylasExports.lazyLoadAndRegisterStore("CategoryStore", 'category-store');

    NylasExports.lazyLoadAndRegisterStore("UndoRedoStore", 'undo-redo-store');

    NylasExports.lazyLoadAndRegisterStore("WorkspaceStore", 'workspace-store');

    NylasExports.lazyLoadAndRegisterStore("MailRulesStore", 'mail-rules-store');

    NylasExports.lazyLoadAndRegisterStore("FileUploadStore", 'file-upload-store');

    NylasExports.lazyLoadAndRegisterStore("ThreadCountsStore", 'thread-counts-store');

    NylasExports.lazyLoadAndRegisterStore("FileDownloadStore", 'file-download-store');

    NylasExports.lazyLoadAndRegisterStore("PreferencesUIStore", 'preferences-ui-store');

    NylasExports.lazyLoadAndRegisterStore("FocusedContentStore", 'focused-content-store');

    NylasExports.lazyLoadAndRegisterStore("MessageBodyProcessor", 'message-body-processor');

    NylasExports.lazyLoadAndRegisterStore("FocusedContactsStore", 'focused-contacts-store');

    NylasExports.lazyLoadAndRegisterStore("TaskQueueStatusStore", 'task-queue-status-store');

    NylasExports.lazyLoadAndRegisterStore("FocusedPerspectiveStore", 'focused-perspective-store');

    NylasExports.lazyLoadAndRegisterStore("SearchableComponentStore", 'searchable-component-store');

    NylasExports.lazyLoad("CustomContenteditableComponents", 'components/overlaid-components/custom-contenteditable-components');

    NylasExports.lazyLoad("InflatesDraftClientId", 'decorators/inflates-draft-client-id');

    NylasExports.lazyLoad("ExtensionRegistry", 'extension-registry');

    NylasExports.lazyLoad("ComposerExtension", 'extensions/composer-extension');

    NylasExports.lazyLoad("MessageViewExtension", 'extensions/message-view-extension');

    NylasExports.lazyLoad("ContenteditableExtension", 'extensions/contenteditable-extension');

    NylasExports.lazyLoadCustomGetter("Rx", function() {
      return require('rx-lite');
    });

    NylasExports.lazyLoadCustomGetter("React", function() {
      return require('react');
    });

    NylasExports.lazyLoadCustomGetter("Reflux", function() {
      return require('reflux');
    });

    NylasExports.lazyLoadCustomGetter("ReactDOM", function() {
      return require('react-dom');
    });

    NylasExports.lazyLoadCustomGetter("ReactTestUtils", function() {
      return require('react-addons-test-utils');
    });

    NylasExports.lazyLoadCustomGetter("Keytar", function() {
      return require('keytar');
    });

    NylasExports.lazyLoad("ComponentRegistry", 'component-registry');

    NylasExports.lazyLoad("PriorityUICoordinator", 'priority-ui-coordinator');

    NylasExports.lazyLoad("Utils", 'flux/models/utils');

    NylasExports.lazyLoad("DOMUtils", 'dom-utils');

    NylasExports.lazyLoad("DateUtils", 'date-utils');

    NylasExports.lazyLoad("CanvasUtils", 'canvas-utils');

    NylasExports.lazyLoad("RegExpUtils", 'regexp-utils');

    NylasExports.lazyLoad("MenuHelpers", 'menu-helpers');

    NylasExports.lazyLoad("DeprecateUtils", 'deprecate-utils');

    NylasExports.lazyLoad("VirtualDOMUtils", 'virtual-dom-utils');

    NylasExports.lazyLoad("NylasSpellchecker", 'nylas-spellchecker');

    NylasExports.lazyLoad("DraftHelpers", 'flux/stores/draft-helpers');

    NylasExports.lazyLoad("MessageUtils", 'flux/models/message-utils');

    NylasExports.lazyLoad("EditorAPI", 'components/contenteditable/editor-api');

    NylasExports.lazyLoad("SoundRegistry", 'sound-registry');

    NylasExports.lazyLoad("MailRulesTemplates", 'mail-rules-templates');

    NylasExports.lazyLoad("MailRulesProcessor", 'mail-rules-processor');

    NylasExports.lazyLoad("MailboxPerspective", 'mailbox-perspective');

    NylasExports.lazyLoad("NativeNotifications", 'native-notifications');

    NylasExports.lazyLoad("SanitizeTransformer", 'services/sanitize-transformer');

    NylasExports.lazyLoad("QuotedHTMLTransformer", 'services/quoted-html-transformer');

    NylasExports.lazyLoad("InlineStyleTransformer", 'services/inline-style-transformer');

    NylasExports.lazyLoad("SearchableComponentMaker", 'searchable-components/searchable-component-maker');

    NylasExports.lazyLoad("QuotedPlainTextTransformer", 'services/quoted-plain-text-transformer');

    NylasExports.lazyLoadCustomGetter("APIError", function() {
      return require('../flux/errors').APIError;
    });

    NylasExports.lazyLoadCustomGetter("TimeoutError", function() {
      return require('../flux/errors').TimeoutError;
    });

    NylasExports.lazyLoad("LaunchServices", 'launch-services');

    NylasExports.lazyLoad("BufferedProcess", 'buffered-process');

    NylasExports.lazyLoad("SystemStartService", 'system-start-service');

    NylasExports.lazyLoadCustomGetter("APMWrapper", function() {
      return require('../apm-wrapper');
    });

    NylasExports.lazyLoadCustomGetter("NylasTestUtils", function() {
      return require('../../spec/nylas-test-utils');
    });

    NylasExports.lazyLoadDeprecated("QuotedHTMLParser", 'services/quoted-html-transformer', {
      instead: 'QuotedHTMLTransformer'
    });

    NylasExports.lazyLoadDeprecated("DraftStoreExtension", 'flux/stores/draft-store-extension', {
      instead: 'ComposerExtension'
    });

    NylasExports.lazyLoadDeprecated("MessageStoreExtension", 'flux/stores/message-store-extension', {
      instead: 'MessageViewExtension'
    });

    return NylasExports;

  })();

  window.$n = NylasExports;

  module.exports = NylasExports;

}).call(this);
