(function() {
  var LessCache, LessCompileCache, path, _;

  _ = require('underscore');

  path = require('path');

  LessCache = require('less-cache');

  module.exports = LessCompileCache = (function() {
    function LessCompileCache(_arg) {
      var configDirPath, importPaths, resourcePath;
      configDirPath = _arg.configDirPath, resourcePath = _arg.resourcePath, importPaths = _arg.importPaths;
      this.lessSearchPaths = [path.join(resourcePath, 'static', 'variables'), path.join(resourcePath, 'static')];
      if (importPaths != null) {
        importPaths = importPaths.concat(this.lessSearchPaths);
      } else {
        importPaths = this.lessSearchPaths;
      }
      this.cache = new LessCache({
        cacheDir: path.join(configDirPath, 'compile-cache', 'less'),
        importPaths: importPaths,
        resourcePath: resourcePath,
        fallbackDir: path.join(resourcePath, 'less-compile-cache')
      });
    }

    LessCompileCache.prototype.setImportPaths = function(importPaths) {
      var fullImportPaths;
      if (importPaths == null) {
        importPaths = [];
      }
      fullImportPaths = importPaths.concat(this.lessSearchPaths);
      if (!_.isEqual(fullImportPaths, this.cache.importPaths)) {
        return this.cache.setImportPaths(fullImportPaths);
      }
    };

    LessCompileCache.prototype.read = function(stylesheetPath) {
      return this.cache.readFileSync(stylesheetPath);
    };

    LessCompileCache.prototype.cssForFile = function(stylesheetPath, lessContent) {
      return this.cache.cssForFile(stylesheetPath, lessContent);
    };

    return LessCompileCache;

  })();

}).call(this);
