(function() {
  var MultiRequestProgressMonitor,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  MultiRequestProgressMonitor = (function() {
    function MultiRequestProgressMonitor() {
      this.value = __bind(this.value, this);
      this.requests = __bind(this.requests, this);
      this.remove = __bind(this.remove, this);
      this.add = __bind(this.add, this);
      this._requests = {};
      this._expected = {};
    }

    MultiRequestProgressMonitor.prototype.add = function(filepath, filesize, request) {
      var _ref;
      this._requests[filepath] = request;
      return this._expected[filepath] = (_ref = filesize != null ? filesize : fs.statSync(filepath)["size"]) != null ? _ref : 0;
    };

    MultiRequestProgressMonitor.prototype.remove = function(filepath) {
      delete this._requests[filepath];
      return delete this._expected[filepath];
    };

    MultiRequestProgressMonitor.prototype.requests = function() {
      return _.values(this._requests);
    };

    MultiRequestProgressMonitor.prototype.value = function() {
      var expected, filepath, request, sent, _ref, _ref1, _ref2, _ref3;
      sent = 0;
      expected = 1;
      _ref = this._requests;
      for (filepath in _ref) {
        request = _ref[filepath];
        sent += (_ref1 = (_ref2 = request.req) != null ? (_ref3 = _ref2.connection) != null ? _ref3._bytesDispatched : void 0 : void 0) != null ? _ref1 : 0;
        expected += this._expected[filepath];
      }
      return sent / expected;
    };

    return MultiRequestProgressMonitor;

  })();

  module.exports = MultiRequestProgressMonitor;

}).call(this);
