(function() {
  var Actions, Category, ComponentRegistry, Flexbox, FocusedPerspectiveStore, React, ReactDOM, RetinaImg, Sheet, Toolbar, ToolbarBack, ToolbarMenuControl, ToolbarSpacer, ToolbarWindowControls, Utils, WindowTitle, WorkspaceStore, remote, _, _ref, _str,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  React = require('react');

  ReactDOM = require('react-dom');

  Sheet = require('./sheet');

  Flexbox = require('./components/flexbox');

  RetinaImg = require('./components/retina-img')["default"];

  Utils = require('./flux/models/utils');

  remote = require('electron').remote;

  _str = require('underscore.string');

  _ = require('underscore');

  _ref = require("nylas-exports"), Actions = _ref.Actions, ComponentRegistry = _ref.ComponentRegistry, WorkspaceStore = _ref.WorkspaceStore;

  ToolbarSpacer = (function(_super) {
    __extends(ToolbarSpacer, _super);

    function ToolbarSpacer() {
      this.render = __bind(this.render, this);
      return ToolbarSpacer.__super__.constructor.apply(this, arguments);
    }

    ToolbarSpacer.displayName = 'ToolbarSpacer';

    ToolbarSpacer.propTypes = {
      order: React.PropTypes.number
    };

    ToolbarSpacer.prototype.render = function() {
      var _ref1;
      return React.createElement("div", {
        "className": "item-spacer",
        "style": {
          flex: 1,
          order: (_ref1 = this.props.order) != null ? _ref1 : 0
        }
      });
    };

    return ToolbarSpacer;

  })(React.Component);

  WindowTitle = (function(_super) {
    __extends(WindowTitle, _super);

    WindowTitle.displayName = "WindowTitle";

    function WindowTitle(props) {
      this.props = props;
      this.state = NylasEnv.getLoadSettings();
    }

    WindowTitle.prototype.componentDidMount = function() {
      return this.unlisten = NylasEnv.onWindowPropsReceived((function(_this) {
        return function(windowProps) {
          return _this.setState(NylasEnv.getLoadSettings());
        };
      })(this));
    };

    WindowTitle.prototype.componentWillUnmount = function() {
      return typeof this.unlisten === "function" ? this.unlisten() : void 0;
    };

    WindowTitle.prototype.render = function() {
      return React.createElement("div", {
        "className": "window-title"
      }, this.state.title);
    };

    return WindowTitle;

  })(React.Component);

  Category = null;

  FocusedPerspectiveStore = null;

  ToolbarBack = (function(_super) {
    __extends(ToolbarBack, _super);

    ToolbarBack.displayName = 'ToolbarBack';

    function ToolbarBack(props) {
      this.props = props;
      this._onClick = __bind(this._onClick, this);
      this.render = __bind(this.render, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      if (Category == null) {
        Category = require('./flux/models/category');
      }
      if (FocusedPerspectiveStore == null) {
        FocusedPerspectiveStore = require('./flux/stores/focused-perspective-store');
      }
      this.state = {
        categoryName: FocusedPerspectiveStore.current().name
      };
    }

    ToolbarBack.prototype.componentDidMount = function() {
      return this._unsubscriber = FocusedPerspectiveStore.listen((function(_this) {
        return function() {
          return _this.setState({
            categoryName: FocusedPerspectiveStore.current().name
          });
        };
      })(this));
    };

    ToolbarBack.prototype.componentWillUnmount = function() {
      if (this._unsubscriber) {
        return this._unsubscriber();
      }
    };

    ToolbarBack.prototype.render = function() {
      var title;
      if (this.state.categoryName === Category.AllMailName) {
        title = 'All Mail';
      } else if (this.state.categoryName) {
        title = _str.titleize(this.state.categoryName);
      } else {
        title = "Back";
      }
      return React.createElement("div", {
        "className": "item-back",
        "onClick": this._onClick,
        "title": "Return to " + title
      }, React.createElement(RetinaImg, {
        "name": "sheet-back.png",
        "mode": RetinaImg.Mode.ContentIsMask
      }), React.createElement("div", {
        "className": "item-back-title"
      }, title));
    };

    ToolbarBack.prototype._onClick = function() {
      return Actions.popSheet();
    };

    return ToolbarBack;

  })(React.Component);

  ToolbarWindowControls = (function(_super) {
    __extends(ToolbarWindowControls, _super);

    ToolbarWindowControls.displayName = 'ToolbarWindowControls';

    function ToolbarWindowControls(props) {
      this.props = props;
      this._onMaximize = __bind(this._onMaximize, this);
      this._onAlt = __bind(this._onAlt, this);
      this.render = __bind(this.render, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.state = {
        alt: false
      };
    }

    ToolbarWindowControls.prototype.componentDidMount = function() {
      if (process.platform === 'darwin') {
        window.addEventListener('keydown', this._onAlt);
        return window.addEventListener('keyup', this._onAlt);
      }
    };

    ToolbarWindowControls.prototype.componentWillUnmount = function() {
      if (process.platform === 'darwin') {
        window.removeEventListener('keydown', this._onAlt);
        return window.removeEventListener('keyup', this._onAlt);
      }
    };

    ToolbarWindowControls.prototype.render = function() {
      return React.createElement("div", {
        "name": "ToolbarWindowControls",
        "className": "toolbar-window-controls alt-" + this.state.alt
      }, React.createElement("button", {
        "tabIndex": -1.,
        "className": "close",
        "onClick": (function() {
          return NylasEnv.close();
        })
      }), React.createElement("button", {
        "tabIndex": -1.,
        "className": "minimize",
        "onClick": (function() {
          return NylasEnv.minimize();
        })
      }), React.createElement("button", {
        "tabIndex": -1.,
        "className": "maximize",
        "onClick": this._onMaximize
      }));
    };

    ToolbarWindowControls.prototype._onAlt = function(event) {
      if (this.state.alt !== event.altKey) {
        return this.setState({
          alt: event.altKey
        });
      }
    };

    ToolbarWindowControls.prototype._onMaximize = function(event) {
      if (process.platform === 'darwin' && !event.altKey) {
        return NylasEnv.setFullScreen(!NylasEnv.isFullScreen());
      } else {
        return NylasEnv.maximize();
      }
    };

    return ToolbarWindowControls;

  })(React.Component);

  ToolbarMenuControl = (function(_super) {
    __extends(ToolbarMenuControl, _super);

    function ToolbarMenuControl() {
      this._openMenu = __bind(this._openMenu, this);
      this.render = __bind(this.render, this);
      return ToolbarMenuControl.__super__.constructor.apply(this, arguments);
    }

    ToolbarMenuControl.displayName = 'ToolbarMenuControl';

    ToolbarMenuControl.prototype.render = function() {
      return React.createElement("div", {
        "className": "toolbar-menu-control"
      }, React.createElement("button", {
        "tabIndex": -1.,
        "className": "btn btn-toolbar",
        "onClick": this._openMenu
      }, React.createElement(RetinaImg, {
        "name": "windows-menu-icon.png",
        "mode": RetinaImg.Mode.ContentIsMask
      })));
    };

    ToolbarMenuControl.prototype._openMenu = function() {
      var applicationMenu;
      applicationMenu = remote.getGlobal('application').applicationMenu;
      return applicationMenu.menu.popup(NylasEnv.getCurrentWindow());
    };

    return ToolbarMenuControl;

  })(React.Component);

  ComponentRegistry.register(ToolbarWindowControls, {
    location: WorkspaceStore.Sheet.Global.Toolbar.Left
  });

  ComponentRegistry.register(ToolbarMenuControl, {
    location: WorkspaceStore.Sheet.Global.Toolbar.Right
  });

  Toolbar = (function(_super) {
    __extends(Toolbar, _super);

    Toolbar.displayName = 'Toolbar';

    Toolbar.propTypes = {
      data: React.PropTypes.object,
      depth: React.PropTypes.number
    };

    Toolbar.childContextTypes = {
      sheetDepth: React.PropTypes.number
    };

    Toolbar.prototype.getChildContext = function() {
      return {
        sheetDepth: this.props.depth
      };
    };

    function Toolbar(props) {
      this.props = props;
      this._getStateFromStores = __bind(this._getStateFromStores, this);
      this._onWindowResize = __bind(this._onWindowResize, this);
      this.recomputeLayout = __bind(this.recomputeLayout, this);
      this._flexboxForComponents = __bind(this._flexboxForComponents, this);
      this.render = __bind(this.render, this);
      this.shouldComponentUpdate = __bind(this.shouldComponentUpdate, this);
      this.componentDidUpdate = __bind(this.componentDidUpdate, this);
      this.componentWillReceiveProps = __bind(this.componentWillReceiveProps, this);
      this.componentWillUnmount = __bind(this.componentWillUnmount, this);
      this.componentDidMount = __bind(this.componentDidMount, this);
      this.getChildContext = __bind(this.getChildContext, this);
      this.state = this._getStateFromStores();
    }

    Toolbar.prototype.componentDidMount = function() {
      this.mounted = true;
      this.unlisteners = [];
      this.unlisteners.push(WorkspaceStore.listen((function(_this) {
        return function(event) {
          return _this.setState(_this._getStateFromStores());
        };
      })(this)));
      this.unlisteners.push(ComponentRegistry.listen((function(_this) {
        return function(event) {
          return _this.setState(_this._getStateFromStores());
        };
      })(this)));
      window.addEventListener("resize", this._onWindowResize);
      return window.requestAnimationFrame((function(_this) {
        return function() {
          return _this.recomputeLayout();
        };
      })(this));
    };

    Toolbar.prototype.componentWillUnmount = function() {
      var unlistener, _i, _len, _ref1, _results;
      this.mounted = false;
      window.removeEventListener("resize", this._onWindowResize);
      _ref1 = this.unlisteners;
      _results = [];
      for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
        unlistener = _ref1[_i];
        _results.push(unlistener());
      }
      return _results;
    };

    Toolbar.prototype.componentWillReceiveProps = function(props) {
      return this.setState(this._getStateFromStores(props));
    };

    Toolbar.prototype.componentDidUpdate = function() {
      return window.requestAnimationFrame((function(_this) {
        return function() {
          return _this.recomputeLayout();
        };
      })(this));
    };

    Toolbar.prototype.shouldComponentUpdate = function(nextProps, nextState) {
      return !Utils.isEqualReact(nextProps, this.props) || !Utils.isEqualReact(nextState, this.state);
    };

    Toolbar.prototype.render = function() {
      var style, toolbars;
      style = {
        position: 'absolute',
        width: '100%',
        height: '100%',
        zIndex: 1
      };
      toolbars = this.state.columns.map((function(_this) {
        return function(components, idx) {
          return React.createElement("div", {
            "style": {
              position: 'absolute',
              top: 0,
              display: 'none'
            },
            "className": "toolbar-" + _this.state.columnNames[idx],
            "data-column": idx,
            "key": idx
          }, _this._flexboxForComponents(components));
        };
      })(this));
      return React.createElement("div", {
        "style": style,
        "className": "sheet-toolbar-container mode-" + this.state.mode
      }, toolbars);
    };

    Toolbar.prototype._flexboxForComponents = function(components) {
      var elements;
      elements = components.map((function(_this) {
        return function(component) {
          return React.createElement(component, React.__spread({
            "key": component.displayName
          }, _this.props));
        };
      })(this));
      return React.createElement(Flexbox, {
        "className": "item-container",
        "direction": "row"
      }, elements, React.createElement(ToolbarSpacer, {
        "key": "spacer-50",
        "order": -50.
      }), React.createElement(ToolbarSpacer, {
        "key": "spacer+50",
        "order": 50.
      }));
    };

    Toolbar.prototype.recomputeLayout = function() {
      var column, columnEl, columnToolbarEl, columnToolbarEls, el, sheet, _i, _len;
      if (!this.mounted) {
        return;
      }
      el = ReactDOM.findDOMNode(this);
      columnToolbarEls = el.querySelectorAll('[data-column]');
      sheet = document.querySelectorAll("[name='Sheet']")[this.props.depth];
      if (!sheet) {
        return;
      }
      for (_i = 0, _len = columnToolbarEls.length; _i < _len; _i++) {
        columnToolbarEl = columnToolbarEls[_i];
        column = columnToolbarEl.dataset.column;
        columnEl = sheet.querySelector("[data-column='" + column + "']");
        if (!columnEl) {
          continue;
        }
        columnToolbarEl.style.display = 'inherit';
        columnToolbarEl.style.left = "" + columnEl.offsetLeft + "px";
        columnToolbarEl.style.width = "" + columnEl.offsetWidth + "px";
      }
      return remote.getCurrentWindow().setSheetOffset(el.clientHeight);
    };

    Toolbar.prototype._onWindowResize = function() {
      return this.recomputeLayout();
    };

    Toolbar.prototype._getStateFromStores = function(props) {
      var entries, loc, state, _i, _j, _k, _len, _len1, _len2, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8;
      if (props == null) {
        props = this.props;
      }
      state = {
        mode: WorkspaceStore.layoutMode(),
        columns: [],
        columnNames: []
      };
      if (((_ref1 = this.props.data) != null ? _ref1.columns[state.mode] : void 0) != null) {
        _ref2 = this.props.data.columns[state.mode];
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          loc = _ref2[_i];
          if (WorkspaceStore.isLocationHidden(loc)) {
            continue;
          }
          entries = ComponentRegistry.findComponentsMatching({
            location: loc.Toolbar,
            mode: state.mode
          });
          state.columns.push(entries);
          if (entries) {
            state.columnNames.push(loc.Toolbar.id.split(":")[0]);
          }
        }
      }
      _ref3 = [WorkspaceStore.Sheet.Global, this.props.data];
      for (_j = 0, _len1 = _ref3.length; _j < _len1; _j++) {
        loc = _ref3[_j];
        entries = ComponentRegistry.findComponentsMatching({
          location: loc.Toolbar.Left,
          mode: state.mode
        });
        if ((_ref4 = state.columns[0]) != null) {
          _ref4.push.apply(_ref4, entries);
        }
      }
      if (this.props.depth > 0) {
        if ((_ref5 = state.columns[0]) != null) {
          _ref5.push(ToolbarBack);
        }
      }
      _ref6 = [WorkspaceStore.Sheet.Global, this.props.data];
      for (_k = 0, _len2 = _ref6.length; _k < _len2; _k++) {
        loc = _ref6[_k];
        entries = ComponentRegistry.findComponentsMatching({
          location: loc.Toolbar.Right,
          mode: state.mode
        });
        if ((_ref7 = state.columns[state.columns.length - 1]) != null) {
          _ref7.push.apply(_ref7, entries);
        }
      }
      if (state.mode === "popout") {
        if ((_ref8 = state.columns[0]) != null) {
          _ref8.push(WindowTitle);
        }
      }
      return state;
    };

    return Toolbar;

  })(React.Component);

  module.exports = Toolbar;

}).call(this);
