(function() {
  var SoundRegistry, path, _;

  _ = require('underscore');

  path = require('path');

  SoundRegistry = (function() {
    function SoundRegistry() {
      this._sounds = {};
    }

    SoundRegistry.prototype.playSound = function(name) {
      var a, args, resourcePath, src;
      if (NylasEnv.inSpecMode()) {
        return;
      }
      src = this._sounds[name];
      if (!src) {
        return;
      }
      a = new Audio();
      if (_.isString(src)) {
        if (src.indexOf("nylas://") === 0) {
          a.src = src;
        } else {
          a.src = path.join(resourcePath, 'static', 'sounds', src);
        }
      } else if (_.isArray(src)) {
        resourcePath = NylasEnv.getLoadSettings().resourcePath;
        args = [resourcePath].concat(src);
        a.src = path.join.apply(this, args);
      }
      a.autoplay = true;
      return a.play();
    };

    SoundRegistry.prototype.register = function(name, path) {
      var key, _results;
      if (_.isObject(name)) {
        _results = [];
        for (key in name) {
          path = name[key];
          _results.push(this._sounds[key] = path);
        }
        return _results;
      } else if (_.isString(name)) {
        return this._sounds[name] = path;
      }
    };

    SoundRegistry.prototype.unregister = function(name) {
      var key, _i, _len, _results;
      if (_.isArray(name)) {
        _results = [];
        for (_i = 0, _len = name.length; _i < _len; _i++) {
          key = name[_i];
          _results.push(delete this._sounds[key]);
        }
        return _results;
      } else if (_.isString(name)) {
        return delete this._sounds[name];
      }
    };

    return SoundRegistry;

  })();

  module.exports = new SoundRegistry();

}).call(this);
