(function() {
  var ComponentRegistry, MessageStore, PhishingIndicator, React, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ref = require('nylas-exports'), React = _ref.React, ComponentRegistry = _ref.ComponentRegistry, MessageStore = _ref.MessageStore;

  PhishingIndicator = (function(_super) {
    __extends(PhishingIndicator, _super);

    function PhishingIndicator() {
      this.isPhishingAttempt = __bind(this.isPhishingAttempt, this);
      this.render = __bind(this.render, this);
      return PhishingIndicator.__super__.constructor.apply(this, arguments);
    }

    PhishingIndicator.displayName = 'PhishingIndicator';

    PhishingIndicator.propTypes = {
      thread: React.PropTypes.object.isRequired
    };

    PhishingIndicator.prototype.render = function() {
      var from, reply_to, _ref1;
      _ref1 = this.isPhishingAttempt(), from = _ref1[0], reply_to = _ref1[1];
      if (from !== null && reply_to !== null) {
        return React.createElement("div", {
          "className": "phishingIndicator"
        }, React.createElement("b", null, "This message looks suspicious!"), React.createElement("p", null, "It originates from ", from, " but replies will go to ", reply_to, "."));
      } else {
        return null;
      }
    };

    PhishingIndicator.prototype.isPhishingAttempt = function() {
      var from, message, reply_to;
      message = MessageStore.items()[0];
      if ((message.replyTo != null) && message.replyTo.length !== 0) {
        from = message.from[0].email;
        reply_to = message.replyTo[0].email;
        if (reply_to !== from) {
          return [from, reply_to];
        }
      }
      return [null, null];
    };

    return PhishingIndicator;

  })(React.Component);

  module.exports = {
    activate: function(state) {
      this.state = state;
      return ComponentRegistry.register(PhishingIndicator, {
        role: 'MessageListHeaders'
      });
    },
    serialize: function() {},
    deactivate: function() {
      return ComponentRegistry.unregister(PhishingIndicator);
    }
  };

}).call(this);
